create or replace
PACKAGE BODY PAK_CARREGA_DW AS

  PROCEDURE PROC_IDIOMES IS
  BEGIN
  
  DELETE FROM IDIOMES;
  INSERT INTO IDIOMES (SELECT  Id, Nom FROM Usuario_ods.IDIOMES);
  
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;


  PROCEDURE PROC_CENTRES IS
  BEGIN
  
  DELETE FROM CENTRES;
  INSERT INTO CENTRES (SELECT  Id, Tipus, Nom, DocTipus, DocNumero, 
                               Adrea, CP, Ciutat,Provincia, Pais, DataBaixa, IdIdioma 
                       FROM Usuario_ods.CENTRES);
  
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  
  PROCEDURE PROC_TREBALLADORS IS
  BEGIN
  
  DELETE FROM TREBALLADORS;
  INSERT INTO TREBALLADORS (SELECT  Id, Nom, Cognom1, Cognom2, Rol, NomUsuari, 
                                    Contrasenya, DataBaixa, IdCentre, IdIdioma 
                            FROM Usuario_ods.TREBALLADORS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_CLIENTS IS
  BEGIN
  
  DELETE FROM CLIENTS;
  INSERT INTO CLIENTS (SELECT  Id, Nom, Cognom1, Cognom2, DataNaixement, Sexe, DocTipus,
                               DocNumero, Adrea, CP, Ciutat, Provincia,Pais, DataBaixa, IdIdioma 
                            FROM Usuario_ods.CLIENTS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_CLIENTS_VEH IS
  BEGIN
  
  DELETE FROM CLIENTS_VEH;
  INSERT INTO CLIENTS_VEH 
       (SELECT  C.Id, C.Nom || ' ' || C.Cognom1 || ' ' || C.Cognom2 AS NomComplert,
                CASE
                  WHEN ROUND(TRUNC(MONTHS_BETWEEN(SYSDATE,C.DATANAIXEMENT)/12,0)) < 30 THEN 'Jove'
                  WHEN ROUND(TRUNC(MONTHS_BETWEEN(SYSDATE,C.DATANAIXEMENT)/12,0)) BETWEEN 30 AND 40 THEN 'Adult'
                  WHEN ROUND(TRUNC(MONTHS_BETWEEN(SYSDATE,C.DATANAIXEMENT)/12,0)) BETWEEN 40 AND 55 THEN 'Avanat'
                  WHEN ROUND(TRUNC(MONTHS_BETWEEN(SYSDATE,C.DATANAIXEMENT)/12,0)) > 55 THEN 'Senior' END AS RangEdad, 
                Count(V.Id) AS Num_Vehicles, 
                DECODE (C.Sexe, 'H', 'Home', 'Dona') AS Sexe, 
                C.DocTipus, C.DocNumero, C.Adrea, C.CP, C.Ciutat, C.Provincia, C.Pais, C.DataBaixa, C.IdIdioma 
        FROM Usuario_ods.CLIENTS C, Usuario_ods.Vehicles V
        WHERE C.Id = V.IdClient
        GROUP BY C.Id, C.Nom || ' ' || C.Cognom1 || ' ' || C.Cognom2,
                 CASE
                   WHEN ROUND(TRUNC(MONTHS_BETWEEN(SYSDATE,C.DATANAIXEMENT)/12,0)) < 30 THEN 'Jove'
                   WHEN ROUND(TRUNC(MONTHS_BETWEEN(SYSDATE,C.DATANAIXEMENT)/12,0)) BETWEEN 30 AND 40 THEN 'Adult'
                   WHEN ROUND(TRUNC(MONTHS_BETWEEN(SYSDATE,C.DATANAIXEMENT)/12,0)) BETWEEN 40 AND 55 THEN 'Avanat'
                   WHEN ROUND(TRUNC(MONTHS_BETWEEN(SYSDATE,C.DATANAIXEMENT)/12,0)) > 55 THEN 'Senior' END, 
                   DECODE (C.Sexe, 'H', 'Home', 'Dona'), 
                   C.DocTipus, C.DocNumero, C.Adrea, C.CP, C.Ciutat, C.Provincia, C.Pais, C.DataBaixa, C.IdIdioma
        );

  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
   
 
  PROCEDURE PROC_DISTRIBUIDORS IS
  BEGIN
  
  DELETE FROM DISTRIBUIDORS;
  INSERT INTO DISTRIBUIDORS (SELECT  Id, Nom, NomContacte, DocTipus, DocNumero, 
                                    Adrea, CP, Ciutat, Provincia, Pais, DataBaixa, IdIdioma 
                            FROM Usuario_ods.DISTRIBUIDORS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_MARQUES IS
  BEGIN
  
  DELETE FROM MARQUES;
  INSERT INTO MARQUES (SELECT  Id, Nom, Pais FROM Usuario_ods.MARQUES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_MODELS IS
  BEGIN
  
  DELETE FROM MODELS;
  INSERT INTO MODELS (SELECT  Id, IdMarca, Nom, AnyModel FROM Usuario_ods.MODELS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
 
 
  PROCEDURE PROC_COMBUSTIBLES IS
  BEGIN
  
  DELETE FROM COMBUSTIBLES;
  INSERT INTO COMBUSTIBLES (SELECT  Id, Nom FROM Usuario_ods.COMBUSTIBLES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
  PROCEDURE PROC_POTENCIES IS
  BEGIN
  
  DELETE FROM POTENCIES;
  INSERT INTO POTENCIES (SELECT  Id, Nom FROM Usuario_ods.POTENCIES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
  PROCEDURE PROC_CILINDRADES IS
  BEGIN
  
  DELETE FROM CILINDRADES;
  INSERT INTO CILINDRADES (SELECT  Id, Nom FROM Usuario_ods.CILINDRADES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
  PROCEDURE PROC_VERSIO IS
  BEGIN
  
  DELETE FROM VERSIO;
  INSERT INTO VERSIO (SELECT  Id, Nom, AnyVersio, Portes, Cambi FROM Usuario_ods.VERSIO);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
   
  PROCEDURE PROC_DISTRIBUIDORS_MARQUES IS
  BEGIN
  
  DELETE FROM DISTRIBUIDORS_MARQUES;
  INSERT INTO DISTRIBUIDORS_MARQUES (SELECT  Id, IdDistribuidor, IdMarca FROM Usuario_ods.DISTRIBUIDORS_MARQUES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

   PROCEDURE PROC_TIPUS_EXTRES IS
  BEGIN
  
  DELETE FROM TIPUS_EXTRES;
  INSERT INTO TIPUS_EXTRES (SELECT  Id, Nom FROM Usuario_ods.TIPUS_EXTRES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
 PROCEDURE PROC_EXTRES IS
  BEGIN
  
  DELETE FROM EXTRES;
  INSERT INTO EXTRES (SELECT  Id, Nom, IdTipusExtra, Preu FROM Usuario_ods.EXTRES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  

  PROCEDURE PROC_EXTRES_MODELS IS
  BEGIN
  
  DELETE FROM EXTRES_MODELS;
  INSERT INTO EXTRES_MODELS (SELECT  Id, IdModel, IdExtra FROM Usuario_ods.EXTRES_MODELS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

  PROCEDURE PROC_VEHICLES IS
  BEGIN
  
  DELETE FROM VEHICLES;
  INSERT INTO VEHICLES (SELECT  A.Id, F.IdMarca, F.Id, B.IdVersio, B.Preu, C.IdCilindrada, D.IdPotencia, E.IdCombustible,
                                A.IdClient, A.Bastidor, A.Matricula, A.Km, A.DataRevisio, A.DataBaixa, A.AnyFabricacio 
                          FROM  Usuario_ods.VEHICLES A, Usuario_ods.CONFIGFIN B, 
                                Usuario_ods.CONFIG3 C, Usuario_ods.CONFIG2 D, 
                                Usuario_ods.CONFIG1 E, Usuario_ods.MODELS F
                        WHERE   A.IdConfigFin = B.Id AND
                                B.IdConfig3 = C.Id AND
                                C.Idconfig2 = D.Id AND
                                D.Idconfig1 = E.Id AND 
                                E.IdModel = F.Id);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

  PROCEDURE PROC_VEHICLES_VENUTS IS
  BEGIN
  
    DELETE FROM VEHICLES_VENUTS;
    INSERT INTO VEHICLES_VENUTS (SELECT  VH.ID, MA.Id, MA.Nom, M.Id, M.Nom,
                                         CASE
                                         WHEN VE.PreuFinal < 20000 THEN 'Economic'
                                         WHEN VE.PreuFinal BETWEEN 20000 AND 35000 THEN 'Mig'
                                         WHEN VE.PreuFinal > 35000 THEN 'Car' END,
                                        CASE
                                         WHEN M.ANYMODEL < 1990 THEN 'Molt Antic'
                                         WHEN M.ANYMODEL BETWEEN 1990 AND 2002 THEN 'Antic'
                                         WHEN M.ANYMODEL BETWEEN 2002 AND 2007 THEN 'Normal'
                                         WHEN M.ANYMODEL > 2007 THEN 'Nou' END,
                                      DECODE (VE.Us, 'N', 'Nou', 'Segona Ma')
                                FROM Usuario_ods.VEHICLES VH, Usuario_ods.CONFIGFIN CF, 
                                     Usuario_ods.CONFIG3 C3, Usuario_ods.CONFIG2 C2, 
                                     Usuario_ods.CONFIG1 C1, Usuario_ods.MODELS M, 
                                     Usuario_ods.MARQUES MA, Usuario_ods.VENTES VE
                               WHERE VH.IdConfigFin = CF.Id AND
                                     CF.IdConfig3 = C3.Id AND
                                     C3.IdConfig2 = C2.Id AND
                                     C2.IdConfig1 = C1.Id AND
                                     C1.IdModel = M.Id AND
                                     M.IdMarca = MA.Id AND
                                     VH.Id = VE.IdVehicle AND
                                     VE.DataVenta IS NOT NULL);
    COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

 
  PROCEDURE PROC_VEHICLES_EXTRES IS
  BEGIN
  
  DELETE FROM VEHICLES_EXTRES;
  INSERT INTO VEHICLES_EXTRES (SELECT  Id, IdVehicle, IdExtra FROM Usuario_ods.VEHICLES_EXTRES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 
 
  PROCEDURE PROC_REPREV_ACCIONS IS
  BEGIN
  
  DELETE FROM REPREV_ACCIONS;
  INSERT INTO REPREV_ACCIONS (SELECT  Id, Nom, Preu FROM Usuario_ods.REPREV_ACCIONS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
  PROCEDURE PROC_REPREV IS
  BEGIN
  
  DELETE FROM REPREV;
  INSERT INTO REPREV (SELECT  Id, IdVehicle, IdCentre, IdClient, Incidencia, IdAccioSol,
                              DataEntrada, DataSortida, DataInici, DataFi, IdMecanicEnt,
                              IdMecanic, IdMecanicSor, Preu, ComentariClient, ComentariMecanic
                        FROM Usuario_ods.REPREV);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_REPREV_LINIES IS
  BEGIN
  
  DELETE FROM REPREV_LINIES;
  INSERT INTO REPREV_LINIES (SELECT  Id, IdRepRev, IdAccio, Preu, Quantitat, Comentari
                             FROM Usuario_ods.REPREV_LINIES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_VENTES IS
  BEGIN
  
  DELETE FROM VENTES;
  INSERT INTO VENTES (SELECT  Id, IdVehicle, IdClient, IdCentre, IdTreballador, DataEncarrec,
                             Pagat, DataVenta, Preu, Descompte, PreuFinal, DataPrevEntrega,
                             DataEntrega, Us, DataBaixa, Comentari
                        FROM Usuario_ods.VENTES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_COMPRES IS
  BEGIN
  
  DELETE FROM COMPRES;
  INSERT INTO COMPRES (SELECT  Id, IdCentre, IdTreballador, IdDistribuidor, IdClient, Us,
                               DataCompra, DataTancament, IdAutoritzador, Preu, 
                               DataRecepcio, IdReceptor, DataBaixa, Comentari
                        FROM Usuario_ods.COMPRES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

  PROCEDURE PROC_COMPRES_LINIES IS
  BEGIN
  
  DELETE FROM COMPRES_LINIES;
  INSERT INTO COMPRES_LINIES (SELECT  Id, IdCompra, IdVehicle, Preu, Comentari
                        FROM Usuario_ods.COMPRES_LINIES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
 
  PROCEDURE PROC_STOCK IS
  BEGIN
  
  DELETE FROM STOCK;
  INSERT INTO STOCK (SELECT  Id, IdVehicle, IdCentre, DataEntrada, DataEncarrec, 
                             DataSortida, PreuVenta, Us
                        FROM Usuario_ods.STOCK);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_ESBORRAT IS
  BEGIN
  
    DELETE FROM VEHICLES_VENUTS;
    COMMIT;
    DELETE FROM CLIENTS_VEH;
    COMMIT;
    DELETE FROM STOCK;
    COMMIT;
    DELETE FROM COMPRES_LINIES;
    COMMIT;
    DELETE FROM COMPRES;
    COMMIT;
    DELETE FROM VENTES;
    COMMIT;
    DELETE FROM REPREV_LINIES;
    COMMIT;
    DELETE FROM REPREV;
    COMMIT;
    DELETE FROM REPREV_ACCIONS;
    COMMIT;
    DELETE FROM VEHICLES_EXTRES;
    COMMIT;
    DELETE FROM VEHICLES;
    COMMIT;
    DELETE FROM EXTRES_MODELS;
    COMMIT;
    DELETE FROM EXTRES;
    COMMIT;
    DELETE FROM TIPUS_EXTRES;
    COMMIT;
    DELETE FROM DISTRIBUIDORS_MARQUES;
    COMMIT;
    DELETE FROM VERSIO;
    COMMIT;
    DELETE FROM CILINDRADES;
    COMMIT;
    DELETE FROM POTENCIES;
    COMMIT;
    DELETE FROM COMBUSTIBLES;
    COMMIT;
    DELETE FROM MODELS;
    COMMIT; 
    DELETE FROM MARQUES;
    COMMIT;
    DELETE FROM DISTRIBUIDORS;
    COMMIT;
    DELETE FROM CLIENTS;
    COMMIT;
    DELETE FROM TREBALLADORS;
    COMMIT;
    DELETE FROM CENTRES;
    COMMIT;
    DELETE FROM IDIOMES;
    COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;


END;
/