create or replace
PACKAGE PAK_EST_CONTROL AS

/*Funci per controlar les dates vuides a les cerques*/
FUNCTION CONTROL_DATES(pDataInici IN OUT DATE, pDataFi IN OUT DATE) RETURN RETORNS;

/*Funci generadora de mitjanes en reparacions*/
FUNCTION MITJA_REPREV(pDada OUT NUMBER, pLiteral VARCHAR2, pIdMecanic IN VARCHAR2 DEFAULT NULL,
                      pIdCentre IN VARCHAR2 DEFAULT NULL, pIncidencia IN VARCHAR2 DEFAULT NULL,
                      pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*Funci generadora de mitjanes en ventes*/
FUNCTION MITJA_VENTES(pDada OUT NUMBER, pLiteral VARCHAR2, pIdTreballador IN VARCHAR2 DEFAULT NULL,
                      pIdCentre IN VARCHAR2 DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,
                      pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*Funci generadora de diferencials de mitjanes en reparacions*/
FUNCTION MITJA_DIFF_REPREV(pDada OUT NUMBER, pLitDataSup VARCHAR2, pLitDataInf VARCHAR2, pIdMecanic IN VARCHAR2 DEFAULT NULL,
                           pIdCentre IN VARCHAR2 DEFAULT NULL, pIncidencia IN VARCHAR2 DEFAULT NULL,
                           pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*Funci generadora de diferencials de mitjanes en ventes*/
FUNCTION MITJA_DIFF_VENTES(pDada OUT NUMBER, pLitDataSup VARCHAR2, pLitDataInf VARCHAR2, pIdTreballador IN VARCHAR2 DEFAULT NULL,
                      pIdCentre IN VARCHAR2 DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,
                      pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*Funci generadora de mxims en reparacions*/
FUNCTION MAX_REPREV(pRetPerParells OUT RETORN_PARELLES, pAccio VARCHAR2,
                    pAgrupatPer VARCHAR2, pIdCentre IN NUMBER, pIncidencia IN VARCHAR2,
                    pDataInici IN DATE, pDataFi IN DATE)  RETURN RETORNS;

/*Funci generadora de mxims en compres*/
FUNCTION MAX_COMPRES(pRetPerParells OUT RETORN_PARELLES, pAccio VARCHAR2, pAgrupatPer VARCHAR2,
                      pIdCentre IN NUMBER, pUs IN VARCHAR2,
                      pDataInici IN DATE, pDataFi IN DATE) RETURN RETORNS;

/*Funci generadora de mxims en ventes*/
FUNCTION MAX_VENTES(pRetPerParells OUT RETORN_PARELLES, pAccio VARCHAR2, pAgrupatPer VARCHAR2,
                      pIdCentre IN NUMBER, pUs IN VARCHAR2,
                      pDataInici IN DATE, pDataFi IN DATE) RETURN RETORNS;

/*Funci generadora de mxims en ventes de vehicles en stock*/
FUNCTION MAX_VENTASTOCK(pRetPerParells OUT RETORN_PARELLES, pAccio VARCHAR2, pAgrupatPer VARCHAR2,
                          pIdCentre IN NUMBER, pUs IN VARCHAR2,
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*Funci generadora de percentatges de descompte*/
FUNCTION MAX_PERCENDTO(pRetPerParells OUT RETORN_PARELLES, pAccio VARCHAR2, pAgrupatPer VARCHAR2,
                          pIdCentre IN NUMBER, pUs IN VARCHAR2,
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*Funci generadora de mxims en models venuts*/
FUNCTION MAX_MODELVENTA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pUs IN VARCHAR2,
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*Funci generadora de mxims en models comprats*/
FUNCTION MAX_MODELCOMPRA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pUs IN VARCHAR2,
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*Funci generadora de mxims en models en estoc*/
FUNCTION MAX_MODELSTOCK(pRetPerParells OUT RETORN_PARELLES, pIdCentre IN NUMBER, pUs IN VARCHAR2,
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*Funci generadora de mxims en models reparats*/
FUNCTION MAX_MODELREPREV(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pIncidencia IN VARCHAR2,
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*Funci generadora de mxims en marques venudes*/
FUNCTION MAX_MARCAVENTA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pUs IN VARCHAR2,
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*Funci generadora de mxims en marques comprades*/
FUNCTION MAX_MARCACOMPRA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pUs IN VARCHAR2,
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*Funci generadora de mxims en marques en estoc*/
FUNCTION MAX_MARCASTOCK(pRetPerParells OUT RETORN_PARELLES, pIdCentre IN NUMBER, pUs IN VARCHAR2,
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*Funci generadora de mxims en marques reparades*/
FUNCTION MAX_MARCAREPREV(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pIncidencia IN VARCHAR2,
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*Funci distribuidora peticions per a centres*/
FUNCTION XXX_PER_CENTRES(pRetPerCentre OUT RETORN_PARELLES_tab, pAccio VARCHAR2, pTipusCentre VARCHAR2,
                         pCriteri IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL,
                         pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*Funci distribuidora peticions per a treballadors*/
FUNCTION XXX_PER_TREBALLADORS(pRetPerTreb OUT RETORN_PARELLES_tab, pAccio VARCHAR2, pTipusCentre VARCHAR2,
                          pCriteri IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL,
                          pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*Funci distribuidora peticions d'ens per a centres*/
FUNCTION XXX_PER_ELEM_CEN(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pAccio IN VARCHAR2,
                          pTipusCentre IN VARCHAR2, pCriteri IN VARCHAR2 DEFAULT NULL,
                          pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;


/*Funci distribuidora peticions d'ens per a treballadors*/
FUNCTION XXX_PER_ELEM_TREB(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pAccio IN VARCHAR2,
                            pTipusCentre IN VARCHAR2, pCriteri IN VARCHAR2 DEFAULT NULL,
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

END PAK_EST_CONTROL;