create or replace
PACKAGE BODY PAK_EXTRACCIO_ODS AS


  PROCEDURE PROC_PERMISOS IS
  BEGIN
  
  DELETE FROM PERMISOS;
  INSERT INTO PERMISOS (SELECT  Id, Accio, Nivell FROM Usuario.PERMISOS);
  
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_IDIOMES IS
  BEGIN
  
  DELETE FROM IDIOMES;
  INSERT INTO IDIOMES (SELECT  Id, Nom FROM Usuario.IDIOMES);
  
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_MISSATGES IS
  BEGIN
  
  DELETE FROM MISSATGES;
  INSERT INTO MISSATGES (SELECT  Id, IdIdioma, Text FROM Usuario.MISSATGES);
  
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_CENTRES IS
  BEGIN
  
  DELETE FROM CENTRES;
  INSERT INTO CENTRES (SELECT  Id, Tipus, Nom, DocTipus, DocNumero, 
                               Adrea, CP, Ciutat,Provincia, Pais, DataBaixa, IdIdioma 
                       FROM Usuario.CENTRES);
  
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_CENTRES_CONTACTE IS
  BEGIN
  
  DELETE FROM CENTRES_CONTACTE;
  INSERT INTO CENTRES_CONTACTE (SELECT  Id, IdCentre, Tipus, Dada FROM Usuario.CENTRES_CONTACTE);
  
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_TREBALLADORS IS
  BEGIN
  
  DELETE FROM TREBALLADORS;
  INSERT INTO TREBALLADORS (SELECT  Id, Nom, Cognom1, Cognom2, Rol, NomUsuari, 
                                    Contrasenya, DataBaixa, IdCentre, IdIdioma 
                            FROM Usuario.TREBALLADORS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_TREBALLADORS_CONTACTE IS
  BEGIN
  
  DELETE FROM TREBALLADORS_CONTACTE;
  INSERT INTO TREBALLADORS_CONTACTE (SELECT  Id, IdTreballador, Tipus, Dada FROM Usuario.TREBALLADORS_CONTACTE);
  
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_CLIENTS IS
  BEGIN
  
  DELETE FROM CLIENTS;
  INSERT INTO CLIENTS (SELECT  Id, Nom, Cognom1, Cognom2, DataNaixement, Sexe, DocTipus,
                               DocNumero, Adrea, CP, Ciutat, Provincia,Pais, DataBaixa, IdIdioma 
                            FROM Usuario.CLIENTS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_CLIENTS_CONTACTE IS
  BEGIN
  
  DELETE FROM CLIENTS_CONTACTE;
  INSERT INTO CLIENTS_CONTACTE (SELECT  Id, IdClient, Tipus, Dada FROM Usuario.CLIENTS_CONTACTE);
  
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;    
 
  PROCEDURE PROC_DISTRIBUIDORS IS
  BEGIN
  
  DELETE FROM DISTRIBUIDORS;
  INSERT INTO DISTRIBUIDORS (SELECT  Id, Nom, NomContacte, DocTipus, DocNumero, 
                                    Adrea, CP, Ciutat, Provincia, Pais, DataBaixa, IdIdioma 
                            FROM Usuario.DISTRIBUIDORS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_DISTRIBUIDORS_CONTACTE IS
  BEGIN
  
  DELETE FROM DISTRIBUIDORS_CONTACTE;
  INSERT INTO DISTRIBUIDORS_CONTACTE (SELECT  Id, IdDistribuidor, Tipus, Dada FROM Usuario.DISTRIBUIDORS_CONTACTE);
  
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;    

  PROCEDURE PROC_MARQUES IS
  BEGIN
  
  DELETE FROM MARQUES;
  INSERT INTO MARQUES (SELECT  Id, Nom, Pais FROM Usuario.MARQUES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_MODELS IS
  BEGIN
  
  DELETE FROM MODELS;
  INSERT INTO MODELS (SELECT  Id, IdMarca, Nom, AnyModel FROM Usuario.MODELS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
 
  PROCEDURE PROC_MODELS_IMATGES IS
  BEGIN
  
  DELETE FROM MODELS_IMATGES;
  INSERT INTO MODELS_IMATGES (SELECT  Id, IdModel, ImatgeG, ImatgeP FROM Usuario.MODELS_IMATGES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 
 
  PROCEDURE PROC_MODELS_IMATGES_IDIOMA IS
  BEGIN
  
  DELETE FROM MODELS_IMATGES_IDIOMA;
  INSERT INTO MODELS_IMATGES_IDIOMA (SELECT  Id, IdModelImatge, IdIdioma, Nom, Descripcio FROM Usuario.MODELS_IMATGES_IDIOMA);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 
  
  PROCEDURE PROC_COMBUSTIBLES IS
  BEGIN
  
  DELETE FROM COMBUSTIBLES;
  INSERT INTO COMBUSTIBLES (SELECT  Id, Nom FROM Usuario.COMBUSTIBLES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
  PROCEDURE PROC_COMBUSTIBLES_IDIOMA IS
  BEGIN
  
  DELETE FROM COMBUSTIBLES_IDIOMA;
  INSERT INTO COMBUSTIBLES_IDIOMA (SELECT  Id, IdCombustible, IdIdioma, Nom, Descripcio
                                   FROM Usuario.COMBUSTIBLES_IDIOMA);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  

  PROCEDURE PROC_POTENCIES IS
  BEGIN
  
  DELETE FROM POTENCIES;
  INSERT INTO POTENCIES (SELECT  Id, Nom FROM Usuario.POTENCIES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
  PROCEDURE PROC_POTENCIES_IDIOMA IS
  BEGIN
  
  DELETE FROM POTENCIES_IDIOMA;
  INSERT INTO POTENCIES_IDIOMA (SELECT  Id, IdPotencia, IdIdioma, Nom, Descripcio
                                   FROM Usuario.POTENCIES_IDIOMA);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  

  PROCEDURE PROC_CILINDRADES IS
  BEGIN
  
  DELETE FROM CILINDRADES;
  INSERT INTO CILINDRADES (SELECT  Id, Nom FROM Usuario.CILINDRADES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
  PROCEDURE PROC_CILINDRADES_IDIOMA IS
  BEGIN
  
  DELETE FROM CILINDRADES_IDIOMA;
  INSERT INTO CILINDRADES_IDIOMA (SELECT  Id, IdCilindrada, IdIdioma, Nom, Descripcio
                                   FROM Usuario.CILINDRADES_IDIOMA);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

 PROCEDURE PROC_VERSIO IS
  BEGIN
  
  DELETE FROM VERSIO;
  INSERT INTO VERSIO (SELECT  Id, Nom, AnyVersio, Portes, Cambi FROM Usuario.VERSIO);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
  PROCEDURE PROC_VERSIO_IDIOMA IS
  BEGIN
  
  DELETE FROM VERSIO_IDIOMA;
  INSERT INTO VERSIO_IDIOMA (SELECT  Id, IdVersio, IdIdioma, Nom, Descripcio
                                   FROM Usuario.VERSIO_IDIOMA);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

 PROCEDURE PROC_DISTRIBUIDORS_MARQUES IS
  BEGIN
  
  DELETE FROM DISTRIBUIDORS_MARQUES;
  INSERT INTO DISTRIBUIDORS_MARQUES (SELECT  Id, IdDistribuidor, IdMarca FROM Usuario.DISTRIBUIDORS_MARQUES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

   PROCEDURE PROC_TIPUS_EXTRES IS
  BEGIN
  
  DELETE FROM TIPUS_EXTRES;
  INSERT INTO TIPUS_EXTRES (SELECT  Id, Nom FROM Usuario.TIPUS_EXTRES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
  PROCEDURE PROC_TIPUS_EXTRES_IDIOMA IS
  BEGIN
  
  DELETE FROM TIPUS_EXTRES_IDIOMA;
  INSERT INTO TIPUS_EXTRES_IDIOMA (SELECT  Id, IdTipusExtra, IdIdioma, Nom, Descripcio
                                   FROM Usuario.TIPUS_EXTRES_IDIOMA);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
  
 PROCEDURE PROC_EXTRES IS
  BEGIN
  
  DELETE FROM EXTRES;
  INSERT INTO EXTRES (SELECT  Id, Nom, IdTipusExtra, Preu FROM Usuario.EXTRES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
  PROCEDURE PROC_EXTRES_IDIOMA IS
  BEGIN
  
  DELETE FROM EXTRES_IDIOMA;
  INSERT INTO EXTRES_IDIOMA (SELECT  Id, IdExtra, IdIdioma, Nom, Descripcio
                                   FROM Usuario.EXTRES_IDIOMA);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
    
  PROCEDURE PROC_CONFIG1 IS
  BEGIN
  
  DELETE FROM CONFIG1;
  INSERT INTO CONFIG1 (SELECT  Id, IdModel, IdCombustible FROM Usuario.CONFIG1);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

  PROCEDURE PROC_CONFIG2 IS
  BEGIN
  
  DELETE FROM CONFIG2;
  INSERT INTO CONFIG2 (SELECT  Id, IdConfig1, IdPotencia FROM Usuario.CONFIG2);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

  PROCEDURE PROC_CONFIG3 IS
  BEGIN
  
  DELETE FROM CONFIG3;
  INSERT INTO CONFIG3 (SELECT  Id, IdConfig2, IdCilindrada FROM Usuario.CONFIG3);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 
  
  PROCEDURE PROC_CONFIGFIN IS
  BEGIN
  
  DELETE FROM CONFIGFIN;
  INSERT INTO CONFIGFIN (SELECT  Id, IdConfig3, IdVersio, Preu FROM Usuario.CONFIGFIN);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_CONFIGFIN_IMATGES IS
  BEGIN
  
  DELETE FROM CONFIGFIN_IMATGES;
  INSERT INTO CONFIGFIN_IMATGES (SELECT  Id, IdConfigFin, ImatgeG, ImatgeP FROM Usuario.CONFIGFIN_IMATGES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 
 
  PROCEDURE PROC_CONFIGFIN_IMATGES_IDIOMA IS
  BEGIN
  
  DELETE FROM CONFIGFIN_IMATGES_IDIOMA;
  INSERT INTO CONFIGFIN_IMATGES_IDIOMA (SELECT  Id, IdConfigFinImatge, IdIdioma, Nom, Descripcio FROM Usuario.CONFIGFIN_IMATGES_IDIOMA);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

  PROCEDURE PROC_EXTRES_MODELS IS
  BEGIN
  
  DELETE FROM EXTRES_MODELS;
  INSERT INTO EXTRES_MODELS (SELECT  Id, IdModel, IdExtra FROM Usuario.EXTRES_MODELS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

  PROCEDURE PROC_EXTRES_CONFIGFIN IS
  BEGIN
  
  DELETE FROM EXTRES_CONFIGFIN;
  INSERT INTO EXTRES_CONFIGFIN (SELECT  Id, IdConfigFin, IdExtra FROM Usuario.EXTRES_CONFIGFIN);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;   
 
  PROCEDURE PROC_VEHICLES IS
  BEGIN
  
  DELETE FROM VEHICLES;
  INSERT INTO VEHICLES (SELECT  Id, IdConfigFin, IdClient, Bastidor, Matricula, 
                                Km, DataRevisio, DataBaixa, AnyFabricacio 
                          FROM Usuario.VEHICLES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

  PROCEDURE PROC_VEHICLES_IMATGES IS
  BEGIN
  
  DELETE FROM VEHICLES_IMATGES;
  INSERT INTO VEHICLES_IMATGES (SELECT  Id, IdVehicle, ImatgeG, ImatgeP 
                          FROM Usuario.VEHICLES_IMATGES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 
 
  PROCEDURE PROC_VEHICLES_IMATGES_IDIOMA IS
  BEGIN
  
  DELETE FROM VEHICLES_IMATGES_IDIOMA;
  INSERT INTO VEHICLES_IMATGES_IDIOMA (SELECT  Id, IdVehicleImatge, IdIdioma, Nom, Descripcio
                          FROM Usuario.VEHICLES_IMATGES_IDIOMA);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 
 
  PROCEDURE PROC_VEHICLES_EXTRES IS
  BEGIN
  
  DELETE FROM VEHICLES_EXTRES;
  INSERT INTO VEHICLES_EXTRES (SELECT  Id, IdVehicle, IdExtra FROM Usuario.VEHICLES_EXTRES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 
 
  PROCEDURE PROC_REPREV_ACCIONS IS
  BEGIN
  
  DELETE FROM REPREV_ACCIONS;
  INSERT INTO REPREV_ACCIONS (SELECT  Id, Nom, Preu FROM Usuario.REPREV_ACCIONS);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;  
 
  PROCEDURE PROC_REPREV_ACCIONS_IDIOMA IS
  BEGIN
  
  DELETE FROM REPREV_ACCIONS_IDIOMA;
  INSERT INTO REPREV_ACCIONS_IDIOMA (SELECT  Id, IdRepRevAccio, IdIdioma, Nom, Descripcio
                                   FROM Usuario.REPREV_ACCIONS_IDIOMA);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_REPREV IS
  BEGIN
  
  DELETE FROM REPREV;
  INSERT INTO REPREV (SELECT  Id, IdVehicle, IdCentre, IdClient, Incidencia, IdAccioSol,
                              DataEntrada, DataSortida, DataInici, DataFi, IdMecanicEnt,
                              IdMecanic, IdMecanicSor, Preu, ComentariClient, ComentariMecanic
                        FROM Usuario.REPREV);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_REPREV_LINIES IS
  BEGIN
  
  DELETE FROM REPREV_LINIES;
  INSERT INTO REPREV_LINIES (SELECT  Id, IdRepRev, IdAccio, Preu, Quantitat, Comentari
                             FROM Usuario.REPREV_LINIES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_VENTES IS
  BEGIN
  
  DELETE FROM VENTES;
  INSERT INTO VENTES (SELECT  Id, IdVehicle, IdClient, IdCentre, IdTreballador, DataEncarrec,
                             Pagat, DataVenta, Preu, Descompte, PreuFinal, DataPrevEntrega,
                             DataEntrega, Us, DataBaixa, Comentari
                        FROM Usuario.VENTES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_COMPRES IS
  BEGIN
  
  DELETE FROM COMPRES;
  INSERT INTO COMPRES (SELECT  Id, IdCentre, IdTreballador, IdDistribuidor, IdClient, Us,
                               DataCompra, DataTancament, IdAutoritzador, Preu, 
                               DataRecepcio, IdReceptor, DataBaixa, Comentari
                        FROM Usuario.COMPRES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END; 

  PROCEDURE PROC_COMPRES_LINIES IS
  BEGIN
  
  DELETE FROM COMPRES_LINIES;
  INSERT INTO COMPRES_LINIES (SELECT  Id, IdCompra, IdVehicle, Preu, Comentari
                        FROM Usuario.COMPRES_LINIES);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
 
  PROCEDURE PROC_STOCK IS
  BEGIN
  
  DELETE FROM STOCK;
  INSERT INTO STOCK (SELECT  Id, IdVehicle, IdCentre, DataEntrada, DataEncarrec, 
                             DataSortida, PreuVenta, Us
                        FROM Usuario.STOCK);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_HISTORIC IS
  BEGIN
  
  DELETE FROM HISTORIC;
  INSERT INTO HISTORIC (SELECT  Id, Taula, IdRegistre, DataAccio, Accio, IdTreballador
                        FROM Usuario.HISTORIC);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

  PROCEDURE PROC_HISTORIC_DETALL IS
  BEGIN
  
  DELETE FROM HISTORIC_DETALL;
  INSERT INTO HISTORIC_DETALL (SELECT  Id, IdHistoric, Columna, Valor
                        FROM Usuario.HISTORIC_DETALL);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_LOGERROR IS
  BEGIN
  
  DELETE FROM LOGERROR;
  INSERT INTO LOGERROR (SELECT  Id, ErrorCode, Taula, IdRegistre, Descripcio, 
                                DataError, Accio, IdTreballador
                        FROM Usuario.LOGERROR);
  COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;
  
  PROCEDURE PROC_ESBORRAT IS
  BEGIN
  
    DELETE FROM LOGERROR;
    COMMIT;
    DELETE FROM HISTORIC_DETALL;
    COMMIT;
    DELETE FROM HISTORIC;
    COMMIT;
    DELETE FROM STOCK;
    COMMIT;
    DELETE FROM COMPRES_LINIES;
    COMMIT;
    DELETE FROM COMPRES;
    COMMIT;
    DELETE FROM VENTES;
    COMMIT;
    DELETE FROM REPREV_LINIES;
    COMMIT;
    DELETE FROM REPREV;
    COMMIT;
    DELETE FROM REPREV_ACCIONS_IDIOMA;
    COMMIT;
    DELETE FROM REPREV_ACCIONS;
    COMMIT;
    DELETE FROM VEHICLES_EXTRES;
    COMMIT;
    DELETE FROM VEHICLES_IMATGES_IDIOMA;
    COMMIT;
    DELETE FROM VEHICLES_IMATGES;
    COMMIT;
    DELETE FROM VEHICLES;
    COMMIT;
    DELETE FROM EXTRES_CONFIGFIN;
    COMMIT;
    DELETE FROM EXTRES_MODELS;
    COMMIT;
    DELETE FROM CONFIGFIN_IMATGES_IDIOMA;
    COMMIT;
    DELETE FROM CONFIGFIN_IMATGES;
    COMMIT;
    DELETE FROM CONFIGFIN;
    COMMIT;
    DELETE FROM CONFIG3;
    COMMIT;
    DELETE FROM CONFIG2;
    COMMIT;
    DELETE FROM CONFIG1;
    COMMIT;
    DELETE FROM EXTRES_IDIOMA;
    COMMIT;
    DELETE FROM EXTRES;
    COMMIT;
    DELETE FROM TIPUS_EXTRES_IDIOMA;
    COMMIT;
    DELETE FROM TIPUS_EXTRES;
    COMMIT;
    DELETE FROM DISTRIBUIDORS_MARQUES;
    COMMIT;
    DELETE FROM VERSIO_IDIOMA;
    COMMIT;
    DELETE FROM VERSIO;
    COMMIT;
    DELETE FROM CILINDRADES_IDIOMA;
    COMMIT;
    DELETE FROM CILINDRADES;
    COMMIT;
    DELETE FROM POTENCIES_IDIOMA;
    COMMIT;
    DELETE FROM POTENCIES;
    COMMIT;
    DELETE FROM COMBUSTIBLES_IDIOMA;
    COMMIT;
    DELETE FROM COMBUSTIBLES;
    COMMIT;
    DELETE FROM MODELS_IMATGES_IDIOMA;
    COMMIT;
    DELETE FROM MODELS_IMATGES;
    COMMIT;
    DELETE FROM MODELS;
    COMMIT;
    DELETE FROM MARQUES;
    COMMIT;
    DELETE FROM DISTRIBUIDORS_CONTACTE;
    COMMIT;
    DELETE FROM DISTRIBUIDORS;
    COMMIT;
    DELETE FROM CLIENTS_CONTACTE;
    COMMIT;
    DELETE FROM CLIENTS;
    COMMIT;
    DELETE FROM TREBALLADORS_CONTACTE;
    COMMIT;
    DELETE FROM TREBALLADORS;
    COMMIT;
    DELETE FROM CENTRES_CONTACTE;
    COMMIT;
    DELETE FROM CENTRES;
    COMMIT;
    DELETE FROM MISSATGES;
    COMMIT;
    DELETE FROM IDIOMES;
    COMMIT;
    DELETE FROM PERMISOS;
    COMMIT;

  EXCEPTION
    WHEN OTHERS THEN
      RAISE;
  END;

END;
/