-- Conectacts com a SYS
DROP TABLESPACE ODS INCLUDING CONTENTS AND DATAFILES;

CREATE TABLESPACE ODS
	DATAFILE 'ODS.DBF' SIZE 50 M 
	AUTOEXTEND ON
	LOGGING ONLINE PERMANENT
	EXTENT MANAGEMENT LOCAL AUTOALLOCATE
	BLOCKSIZE 8 K
	SEGMENT SPACE MANAGEMENT AUTO;

DROP USER usuario_ODS CASCADE;

CREATE USER usuario_ODS
	IDENTIFIED BY usuario_ODS
	DEFAULT TABLESPACE ODS
	QUOTA UNLIMITED ON ODS
	TEMPORARY TABLESPACE temp
	QUOTA 0 ON users;

GRANT CREATE session, CREATE table, CREATE view,
      CREATE procedure, CREATE synonym,
      CREATE SEQUENCE, CREATE TRIGGER,
      CREATE TYPE TO usuario_ODS;


DROP TABLESPACE DW INCLUDING CONTENTS AND DATAFILES;

CREATE TABLESPACE DW
	DATAFILE 'DW.DBF' SIZE 50 M 
	AUTOEXTEND ON
	LOGGING ONLINE PERMANENT
	EXTENT MANAGEMENT LOCAL AUTOALLOCATE
	BLOCKSIZE 8 K
	SEGMENT SPACE MANAGEMENT AUTO;

DROP USER usuario_DW CASCADE;

CREATE USER usuario_DW
	IDENTIFIED BY usuario_DW
	DEFAULT TABLESPACE DW
	QUOTA UNLIMITED ON DW
	TEMPORARY TABLESPACE temp
	QUOTA 0 ON users;

GRANT CREATE session, CREATE table, CREATE view,
      CREATE procedure, CREATE synonym,
      CREATE SEQUENCE, CREATE TRIGGER,
      CREATE TYPE TO usuario_DW;