CREATE OR REPLACE FUNCTION FUNC_ACCES_PERMES (pAccio VARCHAR2, pIdTreballador NUMBER) RETURN BOOLEAN IS

vRol PERMISOS.Nivell%TYPE;
vNivell PERMISOS.Nivell%TYPE;

BEGIN
  -- Funci de control dels permisos dels usuaris, mirant segons el seu rol si aquest es autoritzat o no a executar la acci solicitada
  IF (pAccio IS NULL) OR (pIdTreballador IS NULL) THEN 
    RETURN FALSE;
  END IF;
  
  BEGIN 
    SELECT DECODE (ROL,'AD', 0, 'RE', 1, 'EN', 2, 'VE', 3, 'ME', 3,3)
      INTO vRol
      FROM TREBALLADORS
    WHERE Id = pIdTreballador;
  EXCEPTION 
    WHEN NO_DATA_FOUND THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'PERMISOS', 0, 'Treballador '||pIdTreballador ||' en taula treballadors no trobat', 'F', 0);
      RETURN FALSE;
  END;

  BEGIN
    SELECT NIVELL
      INTO vNivell
      FROM PERMISOS
      WHERE Accio = pAccio;
  EXCEPTION 
    WHEN NO_DATA_FOUND THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'PERMISOS', 0, 'Accio '||pAccio ||' en taula permisos no trobat', 'F', 0);
      RETURN FALSE;
  END;

  IF vRol <= vNivell THEN RETURN TRUE;
  ELSE RETURN FALSE;
  END IF;

 EXCEPTION 
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'PERMISOS', 0, SQLERRM, 'F', 0);
      RETURN FALSE;
  END;
/