create or replace
FUNCTION FUNC_ENVIA_CORREU(pDesde VARCHAR2, pPara VARCHAR2, pAsumpte VARCHAR2, pDocument CLOB) RETURN RETORNS
is
      l_conn         utl_smtp.connection;
      nls_charset    varchar2(255);

   begin
   	-- Funci generadora de correus electronics que donat una adrea, un assumpte i un contingut realitza per codi PL/SQL l'enviament
   	-- Necessari adaptaci segons el servidor utilitzat
      -- get characterset
      select value
      into   nls_charset
      from   nls_database_parameters
      where  parameter = 'NLS_CHARACTERSET';
      -- establish connection and autheticate
      l_conn   := utl_smtp.open_connection ('localhost', 1925);
      utl_smtp.ehlo(l_conn, 'gmail.com');  
      utl_smtp.command(l_conn, 'auth login');
      utl_smtp.command(l_conn,utl_encode.text_encode('data@concessionari.com', nls_charset, 1));
      utl_smtp.command(l_conn, utl_encode.text_encode('pass', nls_charset, 1));
      -- set from/recipient
      utl_smtp.command(l_conn, 'MAIL FROM: <'||pDesde||'>');
      utl_smtp.command(l_conn, 'RCPT TO: <'||pPara||'>');
      -- write mime headers
      utl_smtp.open_data (l_conn);
      utl_smtp.write_data ( l_conn, 'From: '|| pDesde || utl_tcp.crlf);
      utl_smtp.write_data ( l_conn, 'To: '|| pPara || utl_tcp.crlf);
      utl_smtp.write_data ( l_conn, 'Subject: '|| pAsumpte || utl_tcp.crlf);
      utl_smtp.write_data ( l_conn, 'Content-Type:text/plain' || utl_tcp.crlf);
      utl_smtp.write_data ( l_conn, 'X-Mailer: Mailer by Oracle UTL_SMTP' || utl_tcp.crlf);
      utl_smtp.write_data (l_conn, utl_tcp.crlf);
      -- write message body
      utl_smtp.write_data (l_conn, pDocument);
      utl_smtp.close_data (l_conn);
      -- end connection
      utl_smtp.quit (l_conn);
      
      return RETORNS (0,0,null);
   exception
      when others
      then
         begin
           utl_smtp.quit(l_conn);
         exception
           when others then
             null;
         end;
         raise_application_error(-20000,'Failed to send mail due to the following error: ' || sqlerrm);   
   end;   
/