create or replace
PROCEDURE PROC_INSERT_LOGERROR(pErrorCode IN LOGERROR.ErrorCode%TYPE,
                                                 pTaula IN LOGERROR.Taula%TYPE,
                                                 pId IN LOGERROR.IdRegistre%TYPE,
                                                 pDescripcio IN LOGERROR.Descripcio%TYPE,
                                                 pAccio IN LOGERROR.Accio%TYPE,
                                                 pIdTreballador IN  TREBALLADORS.Id%TYPE DEFAULT 0) IS
  vAccio LOGERROR.Accio%TYPE := pAccio;
  vEnvia BOOLEAN := FALSE;
  vDocument CLOB;
  vRet RETORNS;
BEGIN

	-- Proces d'inserci a la taula de logerror
  IF vAccio IS NULL OR vAccio NOT IN ('I', 'U', 'D', 'F', 'P') THEN
    vAccio := 'A';
  END IF;

  INSERT INTO LOGERROR (Id, ErrorCode, Taula, IdRegistre, Descripcio, Accio, IdTreballador)
                VALUES (SEQ_LOGERROR.NEXTVAL, pErrorCode, pTaula, pId, pDescripcio, vAccio, pIdTreballador);
                
  IF vEnvia THEN
    vDocument := '<html> <head> <title> Error de Base de Dades </title> </head> <body> ';
    vDocument := vDocument ||'<div>';
    vDocument := vDocument || ' S''ha produit un error a la taula '||pTaula;
    vDocument := vDocument || ' per l''usuari '||pIdTreballador;
    vDocument := vDocument || ' mentre es realitzava '||pAccio;
    vDocument := vDocument || ' amb identificador '|| pId;
    vDocument := vDocument || ' i amb text descriptiu '|| pDescripcio;
    vDocument := vDocument ||'</div>';
    vDocument := vDocument ||'</table> </body> </html> ';
    vRet:= FUNC_ENVIA_CORREU ('Sistema@concessionari.com', 'Administrador@concessionari.com', 'Error BD', vDocument);
  END IF;
END;