-- tots els Disparadors per escriure a totes a la taula d'histrics quan es realitza alguna 
-- acci d'inserci, esborrat o modificaci sobre els elements de les BBDD
-- Hi ha disparadors per totes les taules excepte la de Logerrors i les mateixes d'historics
CREATE OR REPLACE TRIGGER TRI_CENTRES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CENTRES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CENTRES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CENTRES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.Tipus <> :old.Tipus THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TIPUS', :old.Tipus);
    END IF;   
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.DocTipus <> :old.DocTipus THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCTIPUS', :old.DocTipus);
    END IF;   
    IF :new.DocNumero <> :old.DocNumero THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCNUMERO', :old.DocNumero);
    END IF;
    IF :new.Adrea <> :old.Adrea THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ADREA', :old.Adrea);
    END IF;   
    IF :new.CP <> :old.CP THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CP', :old.CP);
    END IF;
    IF :new.Ciutat <> :old.Ciutat THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CIUTAT', :old.Ciutat);
    END IF;   
    IF :new.Provincia <> :old.Provincia THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PROVINCIA', :old.Provincia);
    END IF;
        IF :new.Pais <> :old.Pais THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PAIS', :old.Pais);
    END IF; 
    IF :new.DataBaixa <> :old.DataBaixa THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);
    END IF;  
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CENTRES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TIPUS', :old.Tipus);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCTIPUS', :old.DocTipus);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCNUMERO', :old.DocNumero);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ADREA', :old.Adrea);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CP', :old.CP);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CIUTAT', :old.Ciutat);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PROVINCIA', :old.Provincia);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PAIS', :old.Pais);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_CENTRES_CONTACTE_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CENTRES_CONTACTE
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CENTRES_CONTACTE', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CENTRES_CONTACTE', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdCentre <> :old.IdCentre THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    END IF;   
    IF :new.Tipus <> :old.Tipus THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TIPUS', :old.Tipus);
    END IF;
    IF :new.Dada <> :old.Dada THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DADA', :old.Dada);
    END IF;   
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CENTRES_CONTACTE', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TIPUS', :old.Tipus);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DADA', :old.Dada);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_CILINDRADES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CILINDRADES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CILINDRADES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CILINDRADES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CILINDRADES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_CILINDRADES_IDIOMA_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CILINDRADES_IDIOMA
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CILINDRADES_IDIOMA', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CILINDRADES_IDIOMA', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdCilindrada <> :old.IdCilindrada THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCILINDRADA', :old.IdCilindrada);
    END IF;
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Descripcio <> :old.Descripcio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CILINDRADES_IDIOMA', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCILINDRADA', :old.IdCilindrada);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_CLIENTS_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CLIENTS
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CLIENTS', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CLIENTS', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;   
    IF :new.Cognom1 <> :old.Cognom1 THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COGNOM1', :old.Cognom1);
    END IF;
    IF :new.Cognom2 <> :old.Cognom2 THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COGNOM2', :old.Cognom2);
    END IF;
    IF :new.DataNaixement <> :old.DataNaixement THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATANAIXEMENT', :old.DataNaixement);
    END IF;
    IF :new.Sexe <> :old.Sexe THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'SEXE', :old.Sexe);
    END IF;
    IF :new.DocTipus <> :old.DocTipus THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCTIPUS', :old.DocTipus);
    END IF;   
    IF :new.DocNumero <> :old.DocNumero THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCNUMERO', :old.DocNumero);
    END IF;
    IF :new.Adrea <> :old.Adrea THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ADREA', :old.Adrea);
    END IF;   
    IF :new.CP <> :old.CP THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CP', :old.CP);
    END IF;
    IF :new.Ciutat <> :old.Ciutat THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CIUTAT', :old.Ciutat);
    END IF;   
    IF :new.Provincia <> :old.Provincia THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PROVINCIA', :old.Provincia);
    END IF;
        IF :new.Pais <> :old.Pais THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PAIS', :old.Pais);
    END IF;
    IF :new.DataBaixa <> :old.DataBaixa THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);
    END IF;
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CLIENTS', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);  
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COGNOM1', :old.Cognom1);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COGNOM2', :old.Cognom2);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATANAIXEMENT', :old.DataNaixement);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'SEXE', :old.Sexe);    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCTIPUS', :old.DocTipus);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCNUMERO', :old.DocNumero);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ADREA', :old.Adrea);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CP', :old.CP);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CIUTAT', :old.Ciutat);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PROVINCIA', :old.Provincia);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PAIS', :old.Pais);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_CLIENTS_CONTACTE_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CLIENTS_CONTACTE
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CLIENTS_CONTACTE', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CLIENTS_CONTACTE', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdClient <> :old.IdClient THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCLIENT', :old.IdCLient);
    END IF;   
    IF :new.Tipus <> :old.Tipus THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TIPUS', :old.Tipus);
    END IF;
    IF :new.Dada <> :old.Dada THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DADA', :old.Dada);
    END IF;   
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CLIENTS_CONTACTE', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCLIENT', :old.IdClient);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TIPUS', :old.Tipus);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DADA', :old.Dada);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_COMBUSTIBLES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON COMBUSTIBLES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMBUSTIBLES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMBUSTIBLES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMBUSTIBLES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_COMBUSTIBLES_IDIOMA_LOG
    AFTER INSERT or UPDATE or DELETE
        ON COMBUSTIBLES_IDIOMA
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMBUSTIBLES_IDIOMA', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMBUSTIBLES_IDIOMA', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdCombustible <> :old.IdCombustible THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCOMBUSTIBLE', :old.IdCombustible);
    END IF;
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Descripcio <> :old.Descripcio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMBUSTIBLES_IDIOMA', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCOMBUSTIBLE', :old.IdCombustible);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_COMPRES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON COMPRES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMPRES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMPRES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdCentre <> :old.IdCentre THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    END IF;   
    IF :new.IdTreballador <> :old.IdTreballador THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDTREBALLADOR', :old.IdTreballador);
    END IF;
    IF :new.IdClient <> :old.IdClient THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCLIENT', :old.IdClient);
    END IF;    
    IF :new.Us <> :old.Us THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'US', :old.Us);
    END IF;   
    IF :new.DataCompra <> :old.DataCompra THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATACOMPRA', :old.DataCompra);
    END IF;
    IF :new.DataTancament <> :old.DataTancament THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATATANCAMENT', :old.DataTancament);
    END IF;
    IF :new.IdAutoritzador <> :old.IdAutoritzador THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDAUTORITZADOR', :old.IdAutoritzador);
    END IF;    
    IF :new.Preu <> :old.Preu THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    END IF;
    IF :new.DataRecepcio <> :old.DataRecepcio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATARECEPCIO', :old.DataRecepcio);
    END IF; 
    IF :new.IdReceptor <> :old.IdReceptor THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDRECEPTOR', :old.IdReceptor);
    END IF; 
    IF :new.DataBaixa <> :old.DataBaixa THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);
    END IF;     
    IF :new.Comentari <> :old.Comentari THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARI', :old.Comentari);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMPRES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDTREBALLADOR', :old.IdTreballador);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCLIENT', :old.IdClient);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'US', :old.Us);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATACOMPRA', :old.DataCompra);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATATANCAMENT', :old.DataTancament);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDAUTORITZADOR', :old.IdAutoritzador);    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATARECEPCIO', :old.DataRecepcio);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDRECEPTOR', :old.IdReceptor);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARI', :old.Comentari);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_COMPRES_LINIES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON COMPRES_LINIES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMPRES_LINIES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMPRES_LINIES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdCompra <> :old.IdCompra THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCOMPRA', :old.IdCompra);
    END IF;   
    IF :new.IdVehicle <> :old.IdVehicle THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLE', :old.IdVehicle);
    END IF;
    IF :new.Preu <> :old.Preu THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    END IF;   
    IF :new.Comentari <> :old.Comentari THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARI', :old.Comentari);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'COMPRES_LINIES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCOMPRA', :old.IdCompra);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLE', :old.IdVehicle);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARI', :old.Comentari);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_CONFIG1_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CONFIG1
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIG1', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIG1', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdModel <> :old.IdModel THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMODEL', :old.IdModel);
    END IF;   
    IF :new.IdCombustible <> :old.IdCombustible THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCOMBUSTIBLE', :old.IdCombustible);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIG1', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMODEL', :old.IdModel);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCOMBUSTIBLE', :old.IdCombustible);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_CONFIG2_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CONFIG2
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIG2', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIG2', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdConfig1 <> :old.IdConfig1 THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIG1', :old.IdConfig1);
    END IF;   
    IF :new.IdPotencia <> :old.IdPotencia THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDPOTENCIA', :old.IdPotencia);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIG2', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIG1', :old.IdConfig1);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDPOTENCIA', :old.IdPotencia);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_CONFIG3_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CONFIG3
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIG3', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIG3', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdConfig2 <> :old.IdConfig2 THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIG2', :old.IdConfig2);
    END IF;   
    IF :new.IdCilindrada <> :old.IdCilindrada THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCILINDRADA', :old.IdCilindrada);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIG3', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIG2', :old.IdConfig2);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCILINDRADA', :old.IdCilindrada);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_CONFIGFIN_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CONFIGFIN
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIGFIN', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIGFIN', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdConfig3 <> :old.IdConfig3 THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIG3', :old.IdConfig3);
    END IF;   
    IF :new.IdVersio <> :old.IdVersio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVERSIO', :old.IdVersio);
    END IF;
    IF :new.Preu <> :old.Preu THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    END IF;    
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIGFIN', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIG3', :old.IdConfig3);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVERSIO', :old.IdVersio);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);    
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_CONFIGFIN_IMATGES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CONFIGFIN_IMATGES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIGFIN_IMATGES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIGFIN_IMATGES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdConfigFin <> :old.IdConfigFin THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIGFIN', :old.IdConfigFin);
    END IF;
    IF :new.ImatgeG <> :old.ImatgeG THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEG', :old.ImatgeG);
    END IF;
    IF :new.ImatgeP <> :old.ImatgeP THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEP', :old.ImatgeP);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIGFIN_IMATGES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIGFIN', :old.IdConfigFin);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEG', :old.ImatgeG);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEP', :old.ImatgeP);          
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_CONFIGFIN_IMAIDI_LOG
    AFTER INSERT or UPDATE or DELETE
        ON CONFIGFIN_IMATGES_IDIOMA
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIGFIN_IMATGES_IDIOMA', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIGFIN_IMATGES_IDIOMA', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdConfigFinImatge <> :old.IdConfigFinImatge THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIGFINIMATGE', :old.IdConfigFinImatge);
    END IF;
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Descripcio <> :old.Descripcio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'CONFIGFIN_IMATGES_IDIOMA', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIGFINIMATGE', :old.IdConfigFinImatge);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_DISTRIBUIDORS_LOG
    AFTER INSERT or UPDATE or DELETE
        ON DISTRIBUIDORS
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'DISTRIBUIDORS', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'DISTRIBUIDORS', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;   
    IF :new.NomContacte <> :old.NomContacte THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOMCONTACTE', :old.NomContacte);
    END IF;
    IF :new.DocTipus <> :old.DocTipus THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCTIPUS', :old.DocTipus);
    END IF;   
    IF :new.DocNumero <> :old.DocNumero THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCNUMERO', :old.DocNumero);
    END IF;
    IF :new.Adrea <> :old.Adrea THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ADREA', :old.Adrea);
    END IF;   
    IF :new.CP <> :old.CP THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CP', :old.CP);
    END IF;
    IF :new.Ciutat <> :old.Ciutat THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CIUTAT', :old.Ciutat);
    END IF;   
    IF :new.Provincia <> :old.Provincia THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PROVINCIA', :old.Provincia);
    END IF;
        IF :new.Pais <> :old.Pais THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PAIS', :old.Pais);
    END IF;
    IF :new.DataBaixa <> :old.DataBaixa THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);
    END IF;    
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'DISTRIBUIDORS', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);  
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOMCONTACTE', :old.NomContacte);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCTIPUS', :old.DocTipus);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DOCNUMERO', :old.DocNumero);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ADREA', :old.Adrea);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CP', :old.CP);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CIUTAT', :old.Ciutat);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PROVINCIA', :old.Provincia);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PAIS', :old.Pais);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_DISTRIBUIDORS_CONTACTE_LOG
    AFTER INSERT or UPDATE or DELETE
        ON DISTRIBUIDORS_CONTACTE
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'DISTRIBUIDORS_CONTACTE', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'DISTRIBUIDORS_CONTACTE', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdDistribuidor <> :old.IdDistribuidor THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDDISTRIBUIDOR', :old.IdDistribuidor);
    END IF;   
    IF :new.Tipus <> :old.Tipus THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TIPUS', :old.Tipus);
    END IF;
    IF :new.Dada <> :old.Dada THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DADA', :old.Dada);
    END IF;   
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'DISTRIBUIDORS_CONTACTE', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDDISTRIBUIDOR', :old.IdDistribuidor);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TIPUS', :old.Tipus);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DADA', :old.Dada);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_DISTRIBUIDORS_MARQUES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON DISTRIBUIDORS_MARQUES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'DISTRIBUIDORS_MARQUES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'DISTRIBUIDORS_MARQUES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdDistribuidor <> :old.IdDistribuidor THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDDISTRIBUIDOR', :old.IdDistribuidor);
    END IF;   
    IF :new.IdMarca <> :old.IdMarca THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMARCA', :old.IdMarca);
    END IF;  
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'DISTRIBUIDORS_MARQUES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDDISTRIBUIDOR', :old.IdDistribuidor);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMARCA', :old.IdMarca);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_EXTRES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON EXTRES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;   
    IF :new.IdTipusExtra <> :old.IdTipusExtra THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDTIPUSEXTRA', :old.IdTipusExtra);
    END IF;
    IF :new.Preu <> :old.Preu THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    END IF;   
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDTIPUSEXTRA', :old.IdTipusExtra);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_EXTRES_CONFIGFIN_LOG
    AFTER INSERT or UPDATE or DELETE
        ON EXTRES_CONFIGFIN
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES_CONFIGFIN', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES_CONFIGFIN', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdConfigFin <> :old.IdConfigFin THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIGFIN', :old.IdConfigFin);
    END IF;   
    IF :new.IdExtra <> :old.IdExtra THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDEXTRA', :old.IdExtra);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES_CONFIGFIN', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIGFIN', :old.IdConfigFin);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDEXTRA', :old.IdExtra);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_EXTRES_IDIOMA_LOG
    AFTER INSERT or UPDATE or DELETE
        ON EXTRES_IDIOMA
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES_IDIOMA', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES_IDIOMA', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdExtra <> :old.IdExtra THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDEXTRA', :old.IdExtra);
    END IF;
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Descripcio <> :old.Descripcio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES_IDIOMA', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDEXTRA', :old.IdExtra);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_EXTRES_MODELS_LOG
    AFTER INSERT or UPDATE or DELETE
        ON EXTRES_MODELS
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES_MODELS', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES_MODELS', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdModel <> :old.IdModel THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMODEL', :old.IdModel);
    END IF;   
    IF :new.IdExtra <> :old.IdExtra THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDEXTRA', :old.IdExtra);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'EXTRES_MODELS', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMODEL', :old.IdModel);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDEXTRA', :old.IdExtra);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_IDIOMES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON IDIOMES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'IDIOMES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'IDIOMES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'IDIOMES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_MARQUES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON MARQUES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN
  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                 VALUES (SEQ_HISTORIC.NEXTVAL, 'MARQUES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MARQUES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Pais <> :old.Pais THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PAIS', :old.Pais);   
    END IF;                  
  ELSIF deleting THEN
     INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MARQUES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PAIS', :old.Pais);                    
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_MISSATGES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON MISSATGES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;
BEGIN
  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MISSATGES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MISSATGES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
    IF :new.Text <> :old.Text THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TEXT', :old.Text);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MISSATGES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TEXT', :old.Text);    
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_MODELS_LOG
    AFTER INSERT or UPDATE or DELETE
        ON MODELS
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN
  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                 VALUES (SEQ_HISTORIC.NEXTVAL, 'MODELS', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MODELS', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdMarca <> :old.IdMarca THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMARCA', :old.IdMarca);
    END IF;                  
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.AnyModel <> :old.AnyModel THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ANYMODEL', :old.AnyModel);   
    END IF;                  
  ELSIF deleting THEN
     INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MODELS', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMARCA', :old.IdMarca);    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ANYMODEL', :old.AnyModel);                    
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_MODELS_IMATGES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON MODELS_IMATGES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MODELS_IMATGES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MODELS_IMATGES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdModel <> :old.IdModel THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMODEL', :old.IdModel);
    END IF;
    IF :new.ImatgeG <> :old.ImatgeG THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEG', :old.ImatgeG);
    END IF;
    IF :new.ImatgeP <> :old.ImatgeP THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEP', :old.ImatgeP);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MODELS_IMATGES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMODEL', :old.IdModel);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEG', :old.ImatgeG);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEP', :old.ImatgeP);          
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_MODELS_IMAIDI_LOG
    AFTER INSERT or UPDATE or DELETE
        ON MODELS_IMATGES_IDIOMA
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MODELS_IMATGES_IDIOMA', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MODELS_IMATGES_IDIOMA', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdModelImatge <> :old.IdModelImatge THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMODELIMATGE', :old.IdModelImatge);
    END IF;
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Descripcio <> :old.Descripcio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'MODELS_IMATGES_IDIOMA', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMODELIMATGE', :old.IdModelImatge);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_PERMISOS_LOG
    AFTER INSERT or UPDATE or DELETE
        ON PERMISOS
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN
  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                 VALUES (SEQ_HISTORIC.NEXTVAL, 'PERMISOS', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'PERMISOS', :new.Id, 'U', 0)
    RETURNING Id INTO vId;                  
    IF :new.Accio <> :old.Accio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ACCIO', :old.Accio);
    END IF;
    IF :new.Nivell <> :old.Nivell THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NIVELL', :old.Nivell);   
    END IF;                  
  ELSIF deleting THEN
     INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'PERMISOS', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ACCIO', :old.Accio);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NIVELL', :old.Nivell);                    
  END IF;
END;
/
CREATE OR REPLACE TRIGGER TRI_POTENCIES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON POTENCIES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'POTENCIES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'POTENCIES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'POTENCIES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_POTENCIES_IDIOMA_LOG
    AFTER INSERT or UPDATE or DELETE
        ON POTENCIES_IDIOMA
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'POTENCIES_IDIOMA', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'POTENCIES_IDIOMA', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdPotencia <> :old.IdPotencia THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDPOTENCIA', :old.IdPotencia);
    END IF;
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Descripcio <> :old.Descripcio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'POTENCIES_IDIOMA', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDPOTENCIA', :old.IdPotencia);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_REPREV_LOG
    AFTER INSERT or UPDATE or DELETE
        ON REPREV
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdVehicle <> :old.IdVehicle THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLE', :old.IdVehicle);
    END IF;
    IF :new.IdCentre <> :old.IdCentre THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    END IF;
    IF :new.IdClient <> :old.IdClient THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCLIENT', :old.IdClient);
    END IF;    
    IF :new.Incidencia <> :old.Incidencia THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'INCIDENCIA', :old.Incidencia);
    END IF;
    IF :new.IdAccioSol <> :old.IdAccioSol THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDACCIOSOL', :old.IdAccioSol);
    END IF;
    IF :new.DataEntrada <> :old.DataEntrada THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAENTRADA', :old.DataEntrada);
    END IF;
    IF :new.DataSortida <> :old.DataSortida THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATASORTIDA', :old.DataSortida);
    END IF;
    IF :new.DataInici <> :old.DataInici THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAINICI', :old.DataInici);
    END IF;
    IF :new.DataFi <> :old.DataFi THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAFI', :old.DataFi);
    END IF;    
    IF :new.IdMecanicEnt <> :old.IdMecanicEnt THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMECANICENT', :old.IdMecanicEnt);
    END IF;
    IF :new.IdMecanic <> :old.IdMecanic THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMECANIC', :old.IdMecanic);
    END IF;
    IF :new.IdMecanicSor <> :old.IdMecanicSor THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMECANICSOR', :old.IdMecanicSor);
    END IF;
    IF :new.Preu <> :old.Preu THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    END IF;
    IF :new.ComentariClient <> :old.ComentariClient THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARICLIENT', :old.ComentariClient);
    END IF;
    IF :new.ComentariMecanic <> :old.ComentariMecanic THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARIMECANIC', :old.ComentariMecanic);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLE', :old.IdVehicle);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCLIENT', :old.IdClient);    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'INCIDENCIA', :old.Incidencia);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDACCIOSOL', :old.IdAccioSol);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAENTRADA', :old.DataEntrada);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATASORTIDA', :old.DataSortida);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAINICI', :old.DataInici);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAFI', :old.DataFi);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMECANICENT', :old.IdMecanicEnt);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMECANIC', :old.IdMecanic);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMECANICSOR', :old.IdMecanicSor);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARICLIENT', :old.ComentariClient);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARIMECANIC', :old.ComentariMecanic);                 
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_REPREVP_ACCIONS_LOG
    AFTER INSERT or UPDATE or DELETE
        ON REPREV_ACCIONS
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV_ACCIONS', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV_ACCIONS', :new.Id, 'U', 0)
    RETURNING Id INTO vId;

    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Preu <> :old.Preu THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV_ACCIONS', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_REPREV_ACCIONS_IDIOMA_LOG
    AFTER INSERT or UPDATE or DELETE
        ON REPREV_ACCIONS_IDIOMA
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV_ACCIONS_IDIOMA', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV_ACCIONS_IDIOMA', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdRepRevAccio <> :old.IdRepRevAccio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDREPREVACCIO', :old.IdRepRevAccio);
    END IF;
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Descripcio <> :old.Descripcio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV_ACCIONS_IDIOMA', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDREPREVACCIO', :old.IdRepRevAccio);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_REPREV_LINIES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON REPREV_LINIES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV_LINIES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV_LINIES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdRepRev <> :old.IdRepRev THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDREPREV', :old.IdRepRev);
    END IF;
    IF :new.IdAccio <> :old.IdAccio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDACCIO', :old.IdAccio);
    END IF;
    IF :new.Preu <> :old.Preu THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    END IF;
    IF :new.Quantitat <> :old.Quantitat THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'QUANTITAT', :old.Quantitat);
    END IF;
    IF :new.Comentari <> :old.Comentari THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARI', :old.Comentari);
    END IF;    
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'REPREV_LINIES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDREPREV', :old.IdRepRev);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDACCIO', :old.IdAccio);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'QUANTITAT', :old.Quantitat);  
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARI', :old.Comentari);  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_STOCK_LOG
    AFTER INSERT or UPDATE or DELETE
        ON STOCK
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'STOCK', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'STOCK', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdVehicle <> :old.IdVehicle THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLE', :old.IdVehicle);
    END IF;
    IF :new.IdCentre <> :old.IdCentre THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    END IF;
    IF :new.DataEntrada <> :old.DataEntrada THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAENTRADA', :old.DataEntrada);
    END IF;
    IF :new.DataSortida <> :old.DataSortida THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATASORTIDA', :old.DataSortida);
    END IF;
    IF :new.PreuVenta <> :old.PreuVenta THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREUVENTA', :old.PreuVenta);
    END IF;
    IF :new.Us <> :old.Us THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'US', :old.Us);
    END IF;    
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'STOCK', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLE', :old.IdVehicle);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAENTRADA', :old.DataEntrada);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATASORTIDA', :old.DataSortida);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREUVENTA', :old.PreuVenta);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'US', :old.Us);    
             
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_TIPUS_EXTRES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON TIPUS_EXTRES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TIPUS_EXTRES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TIPUS_EXTRES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;   
 
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TIPUS_EXTRES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_TIPUS_EXTRES_IDIOMA_LOG
    AFTER INSERT or UPDATE or DELETE
        ON TIPUS_EXTRES_IDIOMA
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TIPUS_EXTRES_IDIOMA', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TIPUS_EXTRES_IDIOMA', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdTipusExtra <> :old.IdTipusExtra THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDTIPUSEXTRES', :old.IdTipusExtra);
    END IF;
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Descripcio <> :old.Descripcio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TIPUS_EXTRES_IDIOMA', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDTIPUSEXTRES', :old.IdTipusExtra);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_TREBALLADORS_LOG
    AFTER INSERT or UPDATE or DELETE
        ON TREBALLADORS
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TREBALLADORS', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TREBALLADORS', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;   
    IF :new.Cognom1 <> :old.Cognom1 THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COGNOM1', :old.Cognom1);
    END IF;
    IF :new.Cognom2 <> :old.Cognom2 THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COGNOM2', :old.Cognom2);
    END IF;    
    IF :new.Rol <> :old.Rol THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ROL', :old.Rol);
    END IF;   
    IF :new.NomUsuari <> :old.NomUsuari THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOMUSUARI', :old.NomUsuari);
    END IF;
    IF :new.Contrasenya <> :old.Contrasenya THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CONTRASENYA', :old.Contrasenya);
    END IF; 
    IF :new.DataBaixa <> :old.DataBaixa THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);
    END IF;     
    IF :new.IdCentre <> :old.IdCentre THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    END IF;   
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TREBALLADORS', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COGNOM1', :old.Cognom1);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COGNOM2', :old.Cognom2);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ROL', :old.Rol);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOMUSUARI', :old.NomUsuari);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CONTRASENYA', :old.Contrasenya);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_TREBALLADORS_CONTACTE_LOG
    AFTER INSERT or UPDATE or DELETE
        ON TREBALLADORS_CONTACTE
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TREBALLADORS_CONTACTE', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TREBALLADORS_CONTACTE', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdTreballador <> :old.IdTreballador THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDTREBALLADOR', :old.IdTreballador);
    END IF;   
    IF :new.Tipus <> :old.Tipus THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TIPUS', :old.Tipus);
    END IF;
    IF :new.Dada <> :old.Dada THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DADA', :old.Dada);
    END IF;   
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'TREBALLADORS_CONTACTE', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDTREBALLADOR', :old.IdTreballador);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'TIPUS', :old.Tipus);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DADA', :old.Dada);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_VEHICLES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON VEHICLES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdConfigfin <> :old.IdConfigfin THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIGFIN', :old.IdConfigfin);
    END IF;   
    IF :new.IdClient <> :old.IdClient THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCLIENT', :old.IdClient);
    END IF;
    IF :new.Bastidor <> :old.Bastidor THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'BASTIDOR', :old.Bastidor);
    END IF;  
    IF :new.Matricula <> :old.Matricula THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'MATRICULA', :old.Matricula);
    END IF;
    IF :new.Km <> :old.Km THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'KM', :old.Km);
    END IF;
    IF :new.DataRevisio <> :old.DataRevisio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAREVISIO', :old.DataRevisio);
    END IF;
    IF :new.DataBaixa <> :old.DataBaixa THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);
    END IF;    
    IF :new.AnyFabricacio <> :old.AnyFabricacio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ANYFABRICACIO', :old.AnyFabricacio);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCONFIGFIN', :old.IdConfigfin);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCLIENT', :old.IdClient);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'BASTIDOR', :old.Bastidor);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'MATRICULA', :old.Matricula);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'KM', :old.Km);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAREVISIO', :old.DataRevisio);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ANYFABRICACIO', :old.AnyFabricacio);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_VEHICLES_EXTRES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON VEHICLES_EXTRES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES_EXTRES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES_EXTRES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdVehicle <> :old.IdVehicle THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLE', :old.IdVehicle);
    END IF;
    IF :new.IdExtra <> :old.IdExtra THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDEXTRA', :old.IdExtra);
    END IF;  
 
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES_EXTRES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLE', :old.IdVehicle);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDEXTRA', :old.IdExtra);

  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_VEHICLES_IMATGES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON VEHICLES_IMATGES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES_IMATGES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES_IMATGES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdVehicle <> :old.IdVehicle THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLE', :old.IdVehicle);
    END IF;
    IF :new.ImatgeG <> :old.ImatgeG THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEG', :old.ImatgeG);
    END IF;
    IF :new.ImatgeP <> :old.ImatgeP THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEP', :old.ImatgeP);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES_IMATGES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDMODEL', :old.IdVehicle);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEG', :old.ImatgeG);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IMATGEP', :old.ImatgeP);          
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_VEHICLES_IMAIDI_LOG
    AFTER INSERT or UPDATE or DELETE
        ON VEHICLES_IMATGES_IDIOMA
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES_IMATGES_IDIOMA', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES_IMATGES_IDIOMA', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdVehicleImatge <> :old.IdVehicleImatge THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLEIMATGE', :old.IdVehicleImatge);
    END IF;
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Descripcio <> :old.Descripcio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VEHICLES_IMATGES_IDIOMA', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLEIMATGE', :old.IdVehicleImatge);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);                  
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_VENTES_LOG
    AFTER INSERT or UPDATE or DELETE
        ON VENTES
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VENTES', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VENTES', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdVehicle <> :old.IdVehicle THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLE', :old.IdVehicle);
    END IF;   
    IF :new.IdClient <> :old.IdClient THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCLIENT', :old.IdClient);
    END IF;
    IF :new.IdCentre <> :old.IdCentre THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    END IF;    
    IF :new.IdTreballador <> :old.IdTreballador THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDTREBALLADOR', :old.IdTreballador);
    END IF;   
    IF :new.DataEncarrec <> :old.DataEncarrec THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAENCARREC', :old.DataEncarrec);
    END IF;
    IF :new.Pagat <> :old.Pagat THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PAGAT', :old.Pagat);
    END IF;  
    IF :new.DataVenta <> :old.DataVenta THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAVENTA', :old.DataVenta);
    END IF;
    IF :new.Preu <> :old.Preu THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    END IF;   
    IF :new.Descompte <> :old.Descompte THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCOMPTE', :old.Descompte);
    END IF;   
    IF :new.PreuFinal <> :old.PreuFinal THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREUFINAL', :old.PreuFinal);
    END IF;
    IF :new.DataPrevEntrega <> :old.DataPrevEntrega THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAPREVENTREGA', :old.DataPrevEntrega);
    END IF;
    IF :new.DataEntrega <> :old.DataEntrega THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAENTREGA', :old.DataEntrega);
    END IF;
    IF :new.Us <> :old.Us THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'US', :old.Us);
    END IF;
    IF :new.DataBaixa <> :old.DataBaixa THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);
    END IF;     
    IF :new.Comentari <> :old.Comentari THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARI', :old.Comentari);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VENTES', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVEHICLE', :old.IdVehicle);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCLIENT', :old.IdClient);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDCENTRE', :old.IdCentre);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDTREBALLADOR', :old.IdTreballador);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAENCARREC', :old.DataEncarrec);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PAGAT', :old.Pagat);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAVENTA', :old.DataVenta);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREU', :old.Preu);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCOMPTE', :old.Descompte);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PREUFINAL', :old.PreuFinal);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAPREVENTREGA', :old.DataPrevEntrega);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATAENTREGA', :old.DataEntrega);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'US', :old.Us);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DATABAIXA', :old.DataBaixa);    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'COMENTARI', :old.Comentari);
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_VERSIO_LOG
    AFTER INSERT or UPDATE or DELETE
        ON VERSIO
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VERSIO', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VERSIO', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.AnyVersio <> :old.AnyVersio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ANYVERSIO', :old.AnyVersio);
    END IF;
    IF :new.Portes <> :old.Portes THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PORTES', :old.Portes);
    END IF;
    IF :new.Cambi <> :old.Cambi THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CAMBI', :old.Cambi);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VERSIO', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'ANYVERSIO', :old.AnyVersio);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'PORTES', :old.Portes);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'CAMBI', :old.Cambi);                 
  END IF;
END;
/

CREATE OR REPLACE TRIGGER TRI_VERSIO_IDIOMA_LOG
    AFTER INSERT or UPDATE or DELETE
        ON VERSIO_IDIOMA
        REFERENCING NEW AS new OLD AS old
        FOR EACH ROW
DECLARE
  vId HISTORIC.Id%TYPE;        
BEGIN

  IF inserting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VERSIO_IDIOMA', :new.Id, 'I', 0);
  ELSIF updating THEN 
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VERSIO_IDIOMA', :new.Id, 'U', 0)
    RETURNING Id INTO vId;
    IF :new.IdVersio <> :old.IdVersio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVERSIO', :old.IdVersio);
    END IF;
    IF :new.IdIdioma <> :old.IdIdioma THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    END IF;
    IF :new.Nom <> :old.Nom THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    END IF;
    IF :new.Descripcio <> :old.Descripcio THEN
      INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);
    END IF;
  ELSIF deleting THEN
    INSERT INTO HISTORIC (Id, Taula, IdRegistre, Accio, IdTreballador) 
                  VALUES (SEQ_HISTORIC.NEXTVAL, 'VERSIO_IDIOMA', :old.Id, 'D', 0)
    RETURNING Id INTO vId;
    
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDVERSIO', :old.IdVersio);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'IDIDIOMA', :old.IdIdioma);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'NOM', :old.Nom);
    INSERT INTO HISTORIC_DETALL VALUES (SEQ_HISTORIC_DETALL.NEXTVAL, vId, 'DESCRIPCIO', :old.Descripcio);                  
  END IF;
END;
/
/

