-- Recull d'objectes utils per la base de dades
-- Hi ha objectes per a retornar informaci sobre l'execuci, de retorn de funcions
-- Hi ha objectes per a contenir el resultat d'una consulta per que una aplicaci de visualitzaci pugui fer us sense esfor
create or replace
TYPE RETORN_AMB_CENTRE AS OBJECT 
( 
Valor NUMBER,
Id NUMBER,
IdCentre NUMBER
);
/

create or replace
TYPE RETORN_AMB_CENTRE_tab IS TABLE OF RETORN_AMB_CENTRE;
/

create or replace
TYPE RETORN_PARELLES AS OBJECT 
( 
Valor NUMBER,
Id NUMBER
);
/

create or replace
TYPE RETORN_PARELLES_tab IS TABLE OF RETORN_PARELLES;
/

create or replace
TYPE RETORNS AS OBJECT 
( 
IdMissatge NUMBER,
IdRetorn NUMBER,
Text VARCHAR2 (255)
);
/

create or replace
TYPE CONTACTE_TYP AS OBJECT 
(
Id NUMBER,
IdPare NUMBER,
Tipus VARCHAR2(2),
Dada VARCHAR2(255)
);
/

create or replace
TYPE contacte_tab IS TABLE OF contacte_typ;
/

create or replace
TYPE CLIENTS_TYP AS OBJECT 
(
  Id NUMBER,
  Nom VARCHAR2(255),
  Cognom1 VARCHAR2(255),
  Cognom2 VARCHAR2(255),
  DocTipus VARCHAR2(8),
  DocNumero VARCHAR2(12),
  Adrea VARCHAR2(255),
  CP VARCHAR2(7),
  Ciutat VARCHAR2(100),
  Provincia VARCHAR2(100),
  Pais VARCHAR2(50),
  DataBaixa DATE,
  IdIdioma NUMBER,
  contactes contacte_tab
);
/

create or replace
TYPE Clients_tab IS TABLE OF clients_typ;
/

create or replace
TYPE TREBALLADORS_TYP AS OBJECT 
(
  Id NUMBER,
  Nom VARCHAR2(255),
  Cognom1 VARCHAR2(255),
  Cognom2 VARCHAR2(255),
  Rol VARCHAR2(2),
  NomUsuari VARCHAR2(50),
  Contrasenya VARCHAR2(255),
  IdCentre NUMBER,
  IdIdioma NUMBER,
  contactes contacte_tab
);
/

create or replace
TYPE Treballadors_tab IS TABLE OF treballadors_typ;
/

create or replace
TYPE CENTRES_TYP AS OBJECT 
(
  Id NUMBER,
  Tipus VARCHAR2(1),
  Nom VARCHAR2(255),
  DocTipus VARCHAR2(3),
  DocNumero VARCHAR2(12),
  Adrea VARCHAR2(255),
  CP VARCHAR2(7),
  Ciutat VARCHAR2(100),
  Provincia VARCHAR2(100),
  Pais VARCHAR2(50),
  DataBaixa DATE,
  IdIdioma NUMBER,
  contactes contacte_tab
) NOT FINAL;
/

create or replace
TYPE CENTRES_TREB_TYP UNDER CENTRES_TYP 
(
  Treballadors treballadors_tab
);
/

create or replace
TYPE Centres_tab IS TABLE OF centres_typ;
/

create or replace
TYPE CENTRES_TREB_TAB IS TABLE OF CENTRES_TREB_TYP;
/

create or replace
TYPE DISTRIBUIDORS_TYP AS OBJECT 
(
  Id NUMBER,
  Nom VARCHAR2(255),
  NomContacte VARCHAR2(255),
  DocTipus VARCHAR2(8),
  DocNumero VARCHAR2(12),
  Adrea VARCHAR2(255),
  CP VARCHAR2(7),
  Ciutat VARCHAR2(100),
  Provincia VARCHAR2(100),
  Pais VARCHAR2(50),
  DataBaixa DATE,
  IdIdioma NUMBER,
  contactes contacte_tab
) NOT FINAL;
/

create or replace
TYPE MARQUES_TYP AS OBJECT 
(
  Id NUMBER,
  Nom VARCHAR2(255),
  Pais VARCHAR2(50)
);
/

create or replace
TYPE Marques_tab IS TABLE OF marques_typ;
/

create or replace
TYPE DISTRIBUIDORS_MARQUES_TYP UNDER DISTRIBUIDORS_TYP 
(
  Marques marques_tab
  );
/

  create or replace
TYPE Distribuidors_tab IS TABLE OF distribuidors_typ;
/

create or replace
TYPE DISTRIBUIDORS_MARQUES_TAB IS TABLE OF DISTRIBUIDORS_MARQUES_TYP;
/

/* us directe per a Idiomes, missatges, 
                     combustibles, potencies, cilindrades,
					 Tipus_extres*/
CREATE  or replace
TYPE taula_mestre_typ AS OBJECT
    ( Id        NUMBER,
      Nom       VARCHAR2(100)
    ) NOT FINAL;
/

CREATE or replace
TYPE Idiomes_typ AS OBJECT
   ( Id	        NUMBER,
     IdPare     NUMBER, 
     IdIdioma	NUMBER,
     Nom	    VARCHAR2(100),
     Descripcio	VARCHAR2(255)
     );
/	 
create or replace
TYPE Idiomes_tab IS TABLE OF Idiomes_typ;
/

CREATE or replace
TYPE taula_mestre_Idi_typ UNDER taula_mestre_typ
    ( traduccions Idiomes_tab
    );
/
create or replace
TYPE taula_mestre_Idi_tab IS TABLE OF taula_mestre_Idi_typ;
/
/*Us directe per a Distribuidors_marques, cofig1, config2, */
/*config3, extres_models, extres_configfin, vehicles_extres*/
CREATE  or replace
TYPE relacions_typ AS OBJECT
    ( Id        NUMBER,
      IdOrigen  NUMBER,
      IdDesti   NUMBER
    )NOT FINAL;
/
create or replace
TYPE relacions_tab IS TABLE OF relacions_typ;
/

CREATE or replace
TYPE Imatges_typ AS OBJECT
   ( Id	        NUMBER,
     IdPare     NUMBER, 
     ImatgeG    VARCHAR2(255),
     ImatgeP	VARCHAR2(255),
	 traduccions Idiomes_tab
     );
/	 
create or replace
TYPE Imatges_tab IS TABLE OF Imatges_typ;
/

create or replace
TYPE Models_typ UNDER taula_mestre_typ
   ( IdMarca     NUMBER, 
     AnyModel     NUMBER
     )NOT FINAL;
/	 
create or replace
TYPE Models_tab IS TABLE OF Models_typ;
/

create or replace
TYPE Models_Ima_typ UNDER Models_typ
   ( Fotografies Imatges_tab
     );
/	 

create or replace
TYPE Models_Ima_tab IS TABLE OF Models_Ima_typ;
/

create or replace
TYPE Versio_typ UNDER taula_mestre_typ
   ( AnyVersio	NUMBER,	 
     Cambi		VARCHAR2(1),
	 Portes		NUMBER
     )NOT FINAL;
/	 

create or replace
TYPE Versio_tab IS TABLE OF Versio_typ;
/

CREATE or replace
TYPE Versio_Idi_typ UNDER Versio_typ
    ( traduccions Idiomes_tab
    );
/

create or replace
TYPE Versio_Idi_tab IS TABLE OF Versio_Idi_typ;
/

create or replace
TYPE Extres_typ UNDER taula_mestre_typ
   ( IdTipusExtra	NUMBER,	 
     Preu 			NUMBER
     )NOT FINAL;
/	 

create or replace
TYPE Extres_tab IS TABLE OF Extres_typ;
/

CREATE or replace
TYPE Extres_Idi_typ UNDER Extres_typ
    ( traduccions Idiomes_tab
    );
/

create or replace
TYPE Extres_Idi_tab IS TABLE OF Extres_Idi_typ;
/

create or replace
TYPE ConfigFin_typ UNDER relacions_typ
   (  Preu 			NUMBER
     )NOT FINAL;
/	 

create or replace
TYPE ConfigFin_tab IS TABLE OF ConfigFin_typ;
/

create or replace
TYPE ConfigFin_Ima_typ UNDER ConfigFin_typ
   ( Fotografies Imatges_tab
     );
/	 

create or replace
TYPE ConfigFin_Ima_tab IS TABLE OF ConfigFin_Ima_typ;
/

CREATE or replace
TYPE Vehicles_typ AS OBJECT
   ( Id				NUMBER,	 
	 IdConfigFin	NUMBER,
	 IdClient		NUMBER,
	 Bastidor		VARCHAR2(20),
	 Matricula		VARCHAR2(10),
	 Km				NUMBER,
	 DataRevisio	DATE,	 
	 DataBaixa		DATE,	 
	 AnyFabricacio	NUMBER	
     )NOT FINAL;
/	 
create or replace
TYPE Vehicles_tab IS TABLE OF Vehicles_typ;
/
create or replace
TYPE Vehicles_Ima_typ UNDER Vehicles_typ
   ( Fotografies Imatges_tab
     );
/	 

create or replace
TYPE Vehicles_Ima_tab IS TABLE OF Vehicles_Ima_typ;
/
create or replace
TYPE RepRevAccions_typ UNDER taula_mestre_typ
   ( Preu 			NUMBER
     )NOT FINAL;
/	 

create or replace
TYPE RepRevAccions_tab IS TABLE OF RepRevAccions_typ;
/

CREATE or replace
TYPE RepRevAccions_Idi_typ UNDER RepRevAccions_typ
    ( traduccions Idiomes_tab
    );
/

create or replace
TYPE RepRevAccions_Idi_tab IS TABLE OF RepRevAccions_Idi_typ;
/
create or replace
TYPE RepRevLinies_typ AS OBJECT
   ( Id				NUMBER,	 
	 IdRepRev		NUMBER,
	 IdAccio		NUMBER,
	 Preu			NUMBER,
	 Quantitat		NUMBER,	 
	 Comentari		VARCHAR2(255)
     );
/	 
create or replace
TYPE RepRevLinies_tab IS TABLE OF RepRevLinies_typ;
/
create or replace
TYPE RepRev_typ AS OBJECT
   ( Id					NUMBER,	 
	 IdVehicle			NUMBER,	 
	 IdCentre			NUMBER,	 
	 IdClient			NUMBER,	 
	 Incidencia			VARCHAR2(3),
	 IdAccioSol			NUMBER,	 
	 DataEntrada		DATE,	 
	 DataInici			DATE,	 
	 DataFi				DATE,	 
	 DataSortida		DATE,	 
	 IdMecanicEnt		NUMBER,	 
	 IdMecanic			NUMBER,	 
	 IdMecanicSor		NUMBER,	 
	 Preu				NUMBER,	 
	 ComentariClient	VARCHAR2(2000),
	 ComentariMecanic	VARCHAR2(2000),
	 Linies				RepRevLinies_tab
     );
/	 
create or replace
TYPE RepRev_tab IS TABLE OF RepRev_typ;
/
create or replace
TYPE Ventes_typ AS OBJECT
   ( Id					NUMBER,	 
	 IdVehicle			NUMBER,	 
	 IdClient			NUMBER,	 
	 IdCentre			NUMBER,	 
	 IdTreballador		NUMBER,	 
	 DataEncarrec		DATE,	 
	 Senyal				NUMBER,	 
	 DataVenta			DATE,	 
	 Preu				NUMBER,	 
	 Descompte			NUMBER,	 
	 PreuFinal			NUMBER,	 
	 DataPrevEntrega	DATE,	 
	 DataEntrega		DATE,	 
	 Us					VARCHAR2(1),
	 DataBaixa			DATE,	
	 Comentari			VARCHAR2(255)
     );
/	 
create or replace
TYPE Ventes_tab IS TABLE OF Ventes_typ;
/
create or replace
TYPE CompresLinies_typ AS OBJECT
   ( Id				NUMBER,	 
	 IdCompra		NUMBER,
	 IdVehicle		NUMBER,
	 Preu			NUMBER,
	 Comentari		VARCHAR2(255)
     );
/	 
create or replace
TYPE CompresLinies_tab IS TABLE OF CompresLinies_typ;
/
create or replace
TYPE Compres_typ AS OBJECT
   ( Id				NUMBER, 
	 IdCentre		NUMBER, 
	 IdTreballador	NUMBER, 
	 IdDistribuidor	NUMBER, 
	 IdClient		NUMBER,
	 Us				VARCHAR2(1),
	 DataCompra		DATE,	 
	 DataTancament	DATE, 
	 IdAutoritzador	NUMBER, 
	 Preu			NUMBER,
	 DataRecepcio	DATE,
	 IdReceptor		NUMBER,
	 DataBaixa		DATE,
	 Comentari		VARCHAR2(255),
	 Linies			CompresLinies_tab
     );
/	 
create or replace
TYPE Compres_tab IS TABLE OF Compres_typ;
/
create or replace
TYPE Stock_typ AS OBJECT
   ( Id				NUMBER, 
	 IdVehicle		NUMBER,	 
	 IdCentre		NUMBER,	 
	 DataEntrada	DATE,	 
	 DataEncarrec	DATE,	
	 DataSortida	DATE,	 
	 PreuVenta		NUMBER, 
	 Us				VARCHAR2(1)
     );
/	 
create or replace
TYPE Stock_tab IS TABLE OF Stock_typ;
/
create or replace
TYPE Permisos_typ AS OBJECT
   ( Id			NUMBER, 
	 Accio		VARCHAR2(50),	 
	 Nivell		NUMBER
     );
/	 
create or replace
TYPE Permisos_tab IS TABLE OF Permisos_typ;
/
create or replace
TYPE HistoricDetall_typ AS OBJECT
   ( Id			NUMBER,
	 IdHistoric NUMBER,
	 Columna	VARCHAR2(30),	 
	 Valor		VARCHAR2(255)
     );
/	 
create or replace
TYPE HistoricDetall_tab IS TABLE OF HistoricDetall_typ;
/
create or replace
TYPE Historic_typ AS OBJECT
   ( Id				NUMBER,
	 Taula			VARCHAR2(30),
	 IdRegistre		NUMBER,	 
	 DataAccio		DATE,	 
	 Accio			VARCHAR2(1),
	 IdTreballador	NUMBER,
	 Detall			HistoricDetall_tab
     );
/	 
create or replace
TYPE Historic_tab IS TABLE OF Historic_typ;
/
create or replace
TYPE LogError_typ AS OBJECT
   ( Id				NUMBER,
	 ErrorCode		VARCHAR2(20),
	 Taula			VARCHAR2(30),
	 IdRegistre		NUMBER,	 
	 Descripcio		VARCHAR2(255),
	 DataError		DATE,	 
	 Accio			VARCHAR2(1),
	 IdTreballador	NUMBER
     );
/	 
create or replace
TYPE LogError_tab IS TABLE OF LogError_typ;
/
/