create or replace
PACKAGE BODY PAK_CONFIG AS

  TE_FILLS exception;
  pragma exception_init( TE_FILLS, -2292 );

  FUNCTION CONFIG1_I (pIdMod NUMBER, pIdCom NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIG1_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pIdMod IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIG1.IdModel');  /*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM CONFIG1
         WHERE Id = pIdMod;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3, pIdMod, 'CONFIG1.IdModel');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF pIdCom IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIG1.IdCombustible');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM COMBUSTIBLES
         WHERE Id = pIdCom;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdCom, 'CONFIG1.IdCombustible');/*Valor d'Id No existeix*/
      END;
    END IF;
        
    BEGIN
      SELECT 1
        INTO vAux
        FROM CONFIG1
       WHERE IdModel = pIdMod AND
             IdCombustible = pIdCom;
      IF vAux = 1 THEN 
        RETURN RETORNS(14, 0, 'CONFIG1'); 
      END IF;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
       null;/*tot OK*/
    END;

    INSERT INTO CONFIG1 VALUES (SEQ_CONFIG1.NEXTVAL, pIdMod, pIdCom)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG1', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIG2_I (pIdCon NUMBER, pIdPot NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIG2_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pIdCon IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIG2.IdConfig1');  /*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM CONFIG1
         WHERE Id = pIdCon;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3, pIdCon, 'CONFIG2.IdConfig1');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF pIdPot IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIG2.IdPotencia');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM POTENCIES
         WHERE Id = pIdPot;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdPot, 'CONFIG2.IdPotencia');/*Valor d'Id No existeix*/
      END;
    END IF;
        
    BEGIN
      SELECT 1
        INTO vAux
        FROM CONFIG2
       WHERE IdConfig1 = pIdCon AND
             Idpotencia = pIdPot;
      IF vAux = 1 THEN 
        RETURN RETORNS(14, 0, 'CONFIG2'); 
      END IF;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
       null;/*tot OK*/
    END;

    INSERT INTO CONFIG2 VALUES (SEQ_CONFIG2.NEXTVAL, pIdCon, pIdPot)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG2', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIG3_I (pIdCon NUMBER, pIdCil NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIG3_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pIdCon IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIG3.IdConfig2');  /*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM CONFIG2
         WHERE Id = pIdCon;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3, pIdCon, 'CONFIG3.IdConfig2');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF pIdCil IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIG3.IdCilindrada');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM CILINDRADES
         WHERE Id = pIdCil;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdCil, 'CONFIG3.IdCilindrada');/*Valor d'Id No existeix*/
      END;
    END IF;
        
    BEGIN
      SELECT 1
        INTO vAux
        FROM CONFIG3
       WHERE IdConfig2 = pIdCon AND
             IdCilindrada = pIdCil;
      IF vAux = 1 THEN 
        RETURN RETORNS(14, 0, 'CONFIG3'); 
      END IF;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
       null;/*tot OK*/
    END;

    INSERT INTO CONFIG3 VALUES (SEQ_CONFIG3.NEXTVAL, pIdCon, pIdCil)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG3', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIGFIN_I (pIdCon NUMBER, pIdVer NUMBER, pPreu NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIGFIN_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pPreu IS NULL THEN
      RETURN RETORNS(2, 0, 'CONFIGFIN.Preu');/*Valor Null no possible*/
    END IF;
    
    IF pIdCon IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIGFIN.IdConfig2');  /*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM CONFIG3
         WHERE Id = pIdCon;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3, pIdCon, 'CONFIGFIN.IdConfig3');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF pIdVer IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIGFIN.IdVersio');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM VERSIO
         WHERE Id = pIdVer;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdVer, 'CONFIGFIN.IdVersio');/*Valor d'Id No existeix*/
      END;
    END IF;
        
    BEGIN
      SELECT 1
        INTO vAux
        FROM CONFIGFIN
       WHERE IdConfig3 = pIdCon AND
             IdVersio = pIdVer;
      IF vAux = 1 THEN 
        RETURN RETORNS(14, 0, 'CONFIGFIN'); 
      END IF;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
       null;/*tot OK*/
    END;

    INSERT INTO CONFIGFIN VALUES (SEQ_CONFIGFIN.NEXTVAL, pIdCon, pIdVer, pPreu)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION CONFIGFIN_IMATGES_I (pIdCon NUMBER, pImatgeG VARCHAR2, pImatgeP VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIGFIN_IMATGES_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pImatgeG IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIGFIN_IMATGES.ImatgeG');/*Valor Null no possible*/
    END IF;

   IF pIdCon IS NULL THEN
     RETURN RETORNS(2, 0, 'CONFIGFIN_IMATGES.IdConfigFin');/*Valor Null no possible*/
   ELSE
     BEGIN
       SELECT Id
         INTO vAux
         FROM CONFIGFIN
        WHERE Id = pIdCon;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         RETURN RETORNS(3, pIdCon, 'CONFIGFIN_IMATGES.IdConfigFin');/*Valor d'Id No existeix*/
     END;
   END IF;
     
    INSERT INTO CONFIGFIN_IMATGES VALUES (SEQ_CONFIGFIN_IMATGES.NEXTVAL, pIdCon, pImatgeG, pImatgeP)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN_IMATGES', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION CONFIGFIN_IMATGES_IDIOMA_I (pIdConIma NUMBER, pIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIGFIN_IMATGES_IDIOMA_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pNom IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIGFIN_IMATGES_IDIOMA.Nom');/*Valor Null no possible*/
    END IF;

    IF pIdConIma IS NULL THEN
      RETURN RETORNS(2, 0, 'CONFIGFIN_IMATGES_IDIOMA.IdConfigFinImatge');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM CONFIGFIN_IMATGES
         WHERE Id = pIdConIma;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3, pIdConIma, 'CONFIGFIN_IMATGES_IDIOMA.IdConfigFinImatge');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF pIdId IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIGFIN_IMATGES_IDIOMA.IdIdioma');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM IDIOMES
         WHERE Id = pIdId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdId, 'CONFIGFIN_IMATGES_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
      END;
    END IF;

    INSERT INTO CONFIGFIN_IMATGES_IDIOMA VALUES (SEQ_CONFIGFIN_IMATGES_IDIOMA.NEXTVAL, pIdConIma, pIdId, pNom, pDesc)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN_IMATGES_IDIOMA', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIG1_U (pId NUMBER, pIdMod NUMBER, pIdCom NUMBER, pIdUser NUMBER) RETURN RETORNS IS

  BEGIN

    IF FUNC_ACCES_PERMES ('CONFIG1_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    RETURN RETORNS (15, 0, 'CONFIG1');

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG1', pId, SQLERRM, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

 FUNCTION CONFIG2_U (pId NUMBER, pIdCon NUMBER, pIdPot NUMBER, pIdUser NUMBER) RETURN RETORNS IS

  BEGIN

    IF FUNC_ACCES_PERMES ('CONFIG2_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    RETURN RETORNS (15, 0, 'CONFIG2');

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG2', pId, SQLERRM, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

 FUNCTION CONFIG3_U (pId NUMBER, pIdCon NUMBER, pIdCil NUMBER, pIdUser NUMBER) RETURN RETORNS IS

  BEGIN

    IF FUNC_ACCES_PERMES ('CONFIG3_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    RETURN RETORNS (15, 0, 'CONFIG3');

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG3', pId, SQLERRM, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIGFIN_U (pId NUMBER, pIdCon NUMBER, pIdVer NUMBER, pPreu NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux NUMBER;
    vModif BOOLEAN := FALSE;
    vFila CONFIGFIN%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIGFIN_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pId IS NULL 
      THEN RETURN RETORNS(2, 0, 'CONFIGFIN.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM CONFIGFIN
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'CONFIGFIN.Id'); /*Valor d'Id No existeix*/
      END;
    END IF;

    IF pIdCon IS NOT NULL AND pIdCon <> vFila.IdConfig3 THEN
      RETURN RETORNS(18,pId, 'CONFIGFIN.IdConfig3'); /*Valor d'Id No existeix*/
    END IF;

    IF pIdVer IS NOT NULL AND pIdVer <> vFila.IdVersio THEN
      RETURN RETORNS(18,pId, 'CONFIGFIN.IdVersio'); /*Valor d'Id No existeix*/
    END IF;

   IF pPreu IS NOT NULL AND pPreu <> vFila.Preu THEN
      vSQL := vSQL||' Preu = ' || pPreu ||',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE CONFIGFIN SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIGFIN_IMATGES_U (pId NUMBER, pIdCon NUMBER, pImatgeG VARCHAR2, pImatgeP VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS

    vAux VARCHAR2 (100);
    vModif BOOLEAN := FALSE;
    vFila CONFIGFIN_IMATGES%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIGFIN_IMATGES_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pId IS NULL THEN 
      RETURN RETORNS(2, 0, 'CONFIGFIN_IMATGES.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM CONFIGFIN_IMATGES
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'CONFIGFIN_IMATGES.Id');/*Valor d'Id No existeix*/
      END;
    END IF;
   
    IF pIdCon IS NOT NULL AND pIdCon <> vFila.IdConfigFin THEN
      BEGIN
        SELECT Id
          INTO vAux
          FROM CONFIGFIN
         WHERE Id = pIdCon;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdCon, 'CONFIGFIN_IMATGES.IdModel');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdConfigFin = ' || pIdCon||',';
      vModif := TRUE;
    END IF;
  
    IF pImatgeG <> vFila.ImatgeG THEN
      vSQL := vSQL||' ImatgeG = ''' || pImatgeG||''',';
      vModif := TRUE;
    END IF;

    IF pImatgeP <> vFila.ImatgeP THEN
      vSQL := vSQL||' ImatgeP = ''' || pImatgeP||''',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE CONFIGFIN_IMATGES SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN_IMATGES', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIGFIN_IMATGES_IDIOMA_U (pId NUMBER, pIdConIma NUMBER, PIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS

    vAux VARCHAR2 (100);
    vModif BOOLEAN := FALSE;
    vFila CONFIGFIN_IMATGES_IDIOMA%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIGFIN_IMATGES_IDIOMA_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
   IF pId IS NULL THEN 
     RETURN RETORNS(2, 0, 'CONFIGFIN_IMATGES_IDIOMA.Id');/*Valor Null no possible*/
   ELSE
     BEGIN
       SELECT *
         INTO vFila
         FROM CONFIGFIN_IMATGES_IDIOMA
        WHERE Id = pId;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         RETURN RETORNS(3,pId, 'CONFIGFIN_IMATGES_IDIOMA.Id');/*Valor d'Id No existeix*/
     END;
   END IF;
   
    IF pIdConIma IS NOT NULL AND pIdConIma <> vFila.IdConfigFinImatge THEN
      BEGIN
        SELECT Id
          INTO vAux
          FROM CONFIGFIN_IMATGES
         WHERE Id = pIdConIma;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdConIma, 'CONFIGFIN_IMATGES_IDIOMA.IdConfigFinImatge');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdConfigFinImatge = ' || pIdConIma||',';
      vModif := TRUE;
    END IF;
  
    IF pDesc IS NOT NULL AND pDesc <> vFila.Descripcio THEN
      vSQL := vSQL||' Descripcio = ''' || pDesc ||''',';
      vModif := TRUE;
    END IF;

    IF pIdId IS NOT NULL AND pIdId <> vFila.IdIdioma THEN  
      BEGIN
        SELECT Id
          INTO vAux
          FROM IDIOMES
         WHERE Id = pIdId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdId, 'CONFIGFIN_IMATGES_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdIdioma = ' || pIdId||',';
      vModif := TRUE;
    END IF;  
  
    IF pNom <> vFila.Nom THEN
      vSQL := vSQL||' Nom = ''' || pNom||''',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE CONFIGFIN_IMATGES_IDIOMA SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN_IMATGES_IDIOMA', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIG1_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIG1_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
      
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'CONFIG1.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM CONFIG1
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE CONFIG1 WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG1', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'CONFIG1.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG1', pId, SQLERRM, 'D', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIG2_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIG2_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
      
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'CONFIG2.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM CONFIG2
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE CONFIG2 WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG2', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'CONFIG2.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG2', pId, SQLERRM, 'D', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIG3_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIG3_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
      
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'CONFIG3.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM CONFIG3
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE CONFIG3 WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG3', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'CONFIG3.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIG3', pId, SQLERRM, 'D', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIGFIN_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIGFIN_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
      
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'CONFIGFIN.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM CONFIGFIN
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE CONFIGFIN WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'CONFIGFIN.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN', pId, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIGFIN_IMATGES_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIGFIN_IMATGES_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'CONFIGFIN_IMATGES.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM CONFIGFIN_IMATGES
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE CONFIGFIN_IMATGES WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN_IMATGES', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'CONFIGFIN_IMATGES.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN_IMATGES', pId, SQLERRM, 'D', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION CONFIGFIN_IMATGES_IDIOMA_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('CONFIGFIN_IMATGES_IDIOMA_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'CONFIGFIN_IMATGES_IDIOMA.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM CONFIGFIN_IMATGES_IDIOMA
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE CONFIGFIN_IMATGES_IDIOMA WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN_IMATGES_IDIOMA', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'CONFIGFIN_IMATGES_IDIOMA.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONFIGFIN_IMATGES_IDIOMA', pId, SQLERRM, 'D', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

END PAK_CONFIG;
/