create or replace
PACKAGE BODY PAK_ESTADISTIC AS

  FUNCTION MTEMPS_MECANIC_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  ret RETORNS;
  BEGIN

    ret:= PAK_EST_CONTROL.MITJA_DIFF_REPREV(pDada, 'DataFi', 'DataInici', null, null, pIncidencia, pDataInici, pDataFi);
    IF ret.IdMissatge = 0 THEN               
      RETURN RETORNS(0,null, 'MTEMPS_MECANIC_REPREV');
    ELSE
      RETURN ret;
    END IF;
    
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MTEMPS_MECANIC_REPREV', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MTEMPS_MECANIC_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_CENTRES(pRetPerCentre, 'MTEMPS_MECANIC_REPREV_C', 'T', pIncidencia, pDataInici, pDataFi);
  END;

  FUNCTION MTEMPS_MECANIC_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                  pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_TREBALLADORS(pRetPerMecanic, 'MTEMPS_MECANIC_REPREV_M', 'T', pIncidencia, pDataInici, pDataFi);
  END;
 
  FUNCTION MTEMPS_NOUTIL_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
     ret RETORNS;
  BEGIN

   ret:= PAK_EST_CONTROL.MITJA_DIFF_REPREV(pDada, 'DataInici', 'DataEntrada', null, null, pIncidencia, pDataInici, pDataFi);
    IF ret.IdMissatge = 0  THEN               
      RETURN RETORNS(0,null, 'MTEMPS_NOUTIL_REPREV');
    ELSE
      RETURN ret;
    END IF;          
    
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MTEMPS_NOUTIL_REPREV', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MTEMPS_NOUTIL_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_CENTRES(pRetPerCentre, 'MTEMPS_NOUTIL_REPREV_C', 'T', pIncidencia, pDataInici, pDataFi);
  END;                                 
  
  FUNCTION MTEMPS_NOUTIL_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                  pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_TREBALLADORS(pRetPerMecanic, 'MTEMPS_NOUTIL_REPREV_M', 'T', pIncidencia, pDataInici, pDataFi);
  END;

  FUNCTION MTEMPS_NOLLEST_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
    ret RETORNS;
  BEGIN

    ret:= PAK_EST_CONTROL.MITJA_DIFF_REPREV(pDada, 'DataFi', 'DataEntrada', null, null, pIncidencia, pDataInici, pDataFi);
    IF ret.IdMissatge = 0 THEN              
      RETURN RETORNS(0,null, 'MTEMPS_NOLLEST_REPREV');
    ELSE
      RETURN ret;
    END IF;  

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MTEMPS_NOLLEST_REPREV', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MTEMPS_NOLLEST_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_CENTRES(pRetPerCentre, 'MTEMPS_NOLLEST_REPREV_C', 'T', pIncidencia, pDataInici, pDataFi);
  END;                                  

  FUNCTION MTEMPS_NOLLEST_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                   pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_TREBALLADORS(pRetPerMecanic, 'MTEMPS_NOLLEST_REPREV_M', 'T', pIncidencia, pDataInici, pDataFi);
  END;

  FUNCTION MTEMPS_EMMAGATZEMATGE_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
   ret RETORNS;
  BEGIN

    ret:= PAK_EST_CONTROL.MITJA_DIFF_REPREV(pDada, 'DataSortida', 'DataFi', null, null, pIncidencia, pDataInici, pDataFi);
    IF ret.IdMissatge = 0  THEN               
      RETURN RETORNS(0,null, 'MTEMPS_EMMAGATZEMATGE_REPREV');
    ELSE
      RETURN ret;
    END IF;  
        
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MTEMPS_EMMAGATZEMATGE_REPREV', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MTEMPS_EMMAGATZEMATGE_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_CENTRES(pRetPerCentre, 'MTEMPS_EMMAGATZEMATGE_REPREV_C', 'T', pIncidencia, pDataInici, pDataFi);
  END;                                 
 
  FUNCTION MTEMPS_EMMAGATZEMATGE_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_TREBALLADORS(pRetPerMecanic, 'MTEMPS_EMMAGATZEMATGE_REPREV_M', 'T', pIncidencia, pDataInici, pDataFi);
  END;

  FUNCTION MTEMPS_TOTAL_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                               pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
    ret RETORNS;
  BEGIN

    ret:= PAK_EST_CONTROL.MITJA_DIFF_REPREV(pDada, 'DataSortida', 'DataEntrada', null, null, pIncidencia, pDataInici, pDataFi);
    IF ret.IdMissatge = 0   THEN              
      RETURN RETORNS(0,null, 'MTEMPS_TOTAL_REPREV');
    ELSE
      RETURN ret;
    END IF;  

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MTEMPS_TOTAL_REPREV', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MTEMPS_TOTAL_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_CENTRES(pRetPerCentre, 'MTEMPS_TOTAL_REPREV_C', 'T', pIncidencia, pDataInici, pDataFi);
  END;                                  
 
  FUNCTION MTEMPS_TOTAL_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_TREBALLADORS(pRetPerMecanic, 'MTEMPS_TOTAL_REPREV_M', 'T', pIncidencia, pDataInici, pDataFi);
  END;

  FUNCTION MPREU_TOTAL_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
    ret RETORNS;
  BEGIN

    ret:= PAK_EST_CONTROL.MITJA_REPREV(pDada, 'Preu', null, null, pIncidencia, pDataInici, pDataFi);
    IF ret.IdMissatge = 0 THEN                
      RETURN RETORNS(0,null, 'MPREU_TOTAL_REPREV');
    ELSE
      RETURN ret;
    END IF;
    
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MPREU_TOTAL_REPREV', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MPREU_TOTAL_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_CENTRES(pRetPerCentre, 'MPREU_TOTAL_REPREV_C', 'T', pIncidencia, pDataInici, pDataFi);
  END; 

  FUNCTION MPREU_TOTAL_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_TREBALLADORS(pRetPerMecanic, 'MPREU_TOTAL_REPREV_M', 'T', pIncidencia, pDataInici, pDataFi);
  END;
    
  FUNCTION MTEMPS_ENTREGA_VENTA(pDada OUT NUMBER, pUs IN VARCHAR2 DEFAULT NULL, 
                                pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
    ret RETORNS;
  BEGIN

    ret:= PAK_EST_CONTROL.MITJA_DIFF_VENTES(pDada, 'DataEntrega', 'DataVenta', null, null, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge = 0 THEN                
      RETURN RETORNS(0,null, 'MTEMPS_ENTREGA_VENTA');
    ELSE
      RETURN ret;
    END IF;
  
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MTEMPS_ENTREGA_VENTA', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MTEMPS_ENTREGA_VENTA_C(pRetPerCentre OUT RETORN_PARELLES_tab, pUs IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_CENTRES(pRetPerCentre, 'MTEMPS_ENTREGA_VENTA_C', 'C', pUs, pDataInici, pDataFi);
  END;   
  
  FUNCTION MTEMPS_ENTREGA_VENTA_V(pRetPerVenedor OUT RETORN_PARELLES_tab, pUs IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_TREBALLADORS(pRetPerVenedor, 'MTEMPS_ENTREGA_VENTA_V', 'C', pUs, pDataInici, pDataFi);
  END;                                 
   
  FUNCTION MPREU_VENTES(pDada OUT NUMBER, pUs IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                                 pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
    ret RETORNS;
  BEGIN

    ret:= PAK_EST_CONTROL.MITJA_VENTES(pDada, 'PreuFinal', null, null, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge = 0 THEN                
      RETURN RETORNS(0,null, 'MPREU_VENTES');
    ELSE
      RETURN ret;
    END IF;
  END;
    
  FUNCTION MPREU_VENTES_C(pRetPerCentre OUT RETORN_PARELLES_tab, pUs IN VARCHAR2 DEFAULT NULL,
                                pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_CENTRES(pRetPerCentre, 'MPREU_VENTES_C', 'C', pUs, pDataInici, pDataFi);
  END;
 
  FUNCTION MPREU_VENTES_V(pRetPerVenedor OUT RETORN_PARELLES_tab, pUs IN VARCHAR2 DEFAULT NULL,
                          pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_TREBALLADORS(pRetPerVenedor, 'MPREU_VENTES_V', 'C', pUs, pDataInici, pDataFi);
  END;                          

  FUNCTION MAX_UNIT_CONCES_VENTES(pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
   ret RETORNS;
  BEGIN
    ret := PAK_EST_CONTROL.MAX_VENTES ( pRetPerCentre, 'Count(Id)', 'IdCentre', null, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_UNIT_CONCES_VENTES'); 
    END IF;
  END;

  FUNCTION MAX_FACT_CONCES_VENTES(pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
     ret RETORNS;
  BEGIN
    ret := PAK_EST_CONTROL.MAX_VENTES ( pRetPerCentre, 'SUM(PreuFinal)', 'IdCentre',null , pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_CONCES_VENTES'); 
    END IF;
  END;
  
  FUNCTION MAX_UNIT_VEND_VENTES(pRetPerVenedor OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
   ret RETORNS;
  BEGIN
    ret := PAK_EST_CONTROL.MAX_VENTES (pRetPerVenedor, 'Count(Id)', 'IdTreballador', pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_UNIT_VEND_VENTES'); 
    END IF;
  END;

  FUNCTION MAX_FACT_VEND_VENTES(pRetPerVenedor OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
     ret RETORNS;
  BEGIN
    ret := PAK_EST_CONTROL.MAX_VENTES (pRetPerVenedor, 'SUM(PreuFinal)', 'IdTreballador', pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_VEND_VENTES'); 
    END IF;
  END;
  
  FUNCTION MAX_UNIT_VEND_VENTES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_UNIT_VEND_VENTES_C', 'C', pUs, pDataInici, pDataFi);
  END;
   
  FUNCTION MAX_FACT_VEND_VENTES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL,  
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_FACT_VEND_VENTES_C', 'C', pUs, pDataInici, pDataFi);
  END;

  FUNCTION MAX_UNIT_CONCES_COMPRES(pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret := PAK_EST_CONTROL.MAX_COMPRES ( pRetPerCentre, 'Count(Id)', 'IdCentre', null, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_UNIT_CONCES_COMPRES'); 
    END IF;
  END;

  FUNCTION MAX_FACT_CONCES_COMPRES(pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
     ret RETORNS;
  BEGIN
    ret := PAK_EST_CONTROL.MAX_COMPRES ( pRetPerCentre, 'SUM(Preu)', 'IdCentre', null , pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_CONCES_COMPRES'); 
    END IF;
  END;
  
  FUNCTION MAX_UNIT_VEND_COMPRES(pRetPerVenedor OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret := PAK_EST_CONTROL.MAX_COMPRES ( pRetPerVenedor, 'Count(IdVehicle)', 'IdTreballador', pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_UNIT_VEND_COMPRES'); 
    END IF;
  END;

  FUNCTION MAX_FACT_VEND_COMPRES(pRetPerVenedor OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
     ret RETORNS;
  BEGIN
    ret := PAK_EST_CONTROL.MAX_COMPRES ( pRetPerVenedor, 'SUM(Preu)', 'IdTreballador', pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_VEND_COMPRES'); 
    END IF;
  END;
  
  FUNCTION MAX_UNIT_VEND_COMPRES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_UNIT_VEND_COMPRES_C', 'C', pUs, pDataInici, pDataFi);
  END;
  
  FUNCTION MAX_FACT_VEND_COMPRES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL,  
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_FACT_VEND_COMPRES_C', 'C', pUs, pDataInici, pDataFi);
  END;  
  
  FUNCTION MAX_UNIT_MECANIC_REPREV(pRetPerMecanic OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL,  pIndidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
   ret RETORNS;
  BEGIN
    ret := PAK_EST_CONTROL.MAX_REPREV (pRetPerMecanic, 'Count(Id)', 'IdMecanic', pIdCentre, pIndidencia, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_UNIT_MECANIC_REPREV'); 
    END IF;
  END;

  FUNCTION MAX_FACT_MECANIC_REPREV(pRetPerMecanic OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pIndidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
     ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_REPREV (pRetPerMecanic, 'SUM(Preu)', 'IdMecanic', pIdCentre, pIndidencia, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_MECANIC_REPREV'); 
    END IF;
  END; 

  FUNCTION MAX_UNIT_TALLER_REPREV(pRetPerCentre OUT RETORN_PARELLES, pIndidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
   ret RETORNS;
  BEGIN
    ret := PAK_EST_CONTROL.MAX_REPREV (pRetPerCentre, 'Count(Id)', 'IdCentre', null, pIndidencia, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_UNIT_TALLER_REPREV'); 
    END IF;
  END;
  
  FUNCTION MAX_FACT_TALLER_REPREV(pRetPerCentre OUT RETORN_PARELLES, pIndidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
     ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_REPREV (pRetPerCentre, 'SUM(Preu)', 'IdCentre', null, pIndidencia, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_TALLER_REPREV'); 
    END IF;
  END; 
  

  FUNCTION MAX_UNIT_MECANIC_REPREV_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_UNIT_MECANIC_REPREV_C', 'T', pIncidencia, pDataInici, pDataFi);
  END;                                 
  
    
  FUNCTION MAX_FACT_MECANIC_REPREV_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,  
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_FACT_MECANIC_REPREV_C', 'T', pIncidencia, pDataInici, pDataFi);
  END;
  
  FUNCTION MAX_UNIT_VEND_VENTESSTOCK(pRetPerTreballador OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,  
                                         pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_VENTASTOCK (pRetPerTreballador, 'count(v.id)', 'Idtreballador', pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_TALLER_REPREV'); 
    END IF;
  END;

  FUNCTION MAX_FACT_VEND_VENTESSTOCK(pRetPerTreballador OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,  
                                         pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_VENTASTOCK (pRetPerTreballador, 'SUM(Preu)', 'Idtreballador', pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_TALLER_REPREV'); 
    END IF;
  END;   

  FUNCTION MAX_UNIT_CONCES_VENTESSTOCK(pRetPerCentre OUT RETORN_PARELLES,  pUs IN VARCHAR2 DEFAULT NULL,  
                                         pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_VENTASTOCK (pRetPerCentre, 'count(v.id)', 'IdCentre', null, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_TALLER_REPREV'); 
    END IF;
  END;

  FUNCTION MAX_FACT_CONCES_VENTESSTOCK(pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL,  
                                         pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_VENTASTOCK (pRetPerCentre, 'SUM(Preu)', 'IdCentre', null, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_TALLER_REPREV'); 
    END IF;
  END;  
  
  FUNCTION MAX_UNIT_VEND_VENTESSTOCK_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_UNIT_VEND_VENTESSTOCK_C', 'C', pUs, pDataInici, pDataFi);
  END;                                 
  
    
  FUNCTION MAX_FACT_VEND_VENTESSTOCK_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL,  
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_FACT_VEND_VENTESSTOCK_C', 'C', pUs, pDataInici, pDataFi);
  END;
  
  FUNCTION MAX_UNIT_P_DTO_VEND_VENTES (pRetPerTreballador OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,  
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
                                   
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_PERCENDTO (pRetPerTreballador, 'count(id)', 'IdTreballador', pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_TALLER_REPREV'); 
    END IF;
  END;  
  
  FUNCTION MAX_UNIT_P_DTO_CONCES_VENTES (pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL,  
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_PERCENDTO (pRetPerCentre, 'count(id)', 'IdCentre', null, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_TALLER_REPREV'); 
    END IF;
  END;
  
  FUNCTION MAX_FACT_P_DTO_VEND_VENTES (pRetPerTreballador OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,  
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_PERCENDTO (pRetPerTreballador, 'SUM(PreuFinal)', 'IdTreballador', pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_TALLER_REPREV'); 
    END IF;
  END;  
  
  FUNCTION MAX_FACT_P_DTO_CONCES_VENTES (pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL,  
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_PERCENDTO (pRetPerCentre, 'SUM(PreuFinal)', 'IdCentre', null, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_FACT_TALLER_REPREV'); 
    END IF;
  END;
  
  FUNCTION MAX_UNIT_P_DTO_VEND_VENTES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_UNIT_P_DTO_VEND_VENTES_C', 'C', pUs, pDataInici, pDataFi);
  END;                                 
  
    
  FUNCTION MAX_FACT_P_DTO_VEND_VENTES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL,  
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_FACT_P_DTO_VEND_VENTES_C', 'C', pUs, pDataInici, pDataFi);
  END;
 
FUNCTION MAX_MODELVENTA_V(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_TREB(pRetPerTreb, 'MAX_MODELVENTA_V', 'C', pUs, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MARCAVENTA_V(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_TREB(pRetPerTreb, 'MAX_MARCAVENTA_V', 'C', pUs, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MODELCOMPRA_V(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_TREB(pRetPerTreb, 'MAX_MODELCOMPRA_V', 'C', pUs, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MARCACOMPRA_V(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_TREB(pRetPerTreb, 'MAX_MARCACOMPRA_V', 'C', pUs, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MODELREPREV_M(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_TREB(pRetPerTreb, 'MAX_MODELREPREV_M', 'T', pIncidencia, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MARCAREPREV_M(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_TREB(pRetPerTreb, 'MAX_MARCAREPREV_M', 'T', pIncidencia, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MODELVENTA_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_MODELVENTA_C', 'C', pUs, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MARCAVENTA_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_MARCAVENTA_C', 'C', pUs, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MODELCOMPRA_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_MODELCOMPRA_C', 'C', pUs, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MARCACOMPRA_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_MARCACOMPRA_C', 'C', pUs, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MODELSTOCK_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_MODELSTOCK_C', 'C', pUs, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MARCASTOCK_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_MARCASTOCK_C', 'C', pUs, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MODELREPREV_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_MODELREPREV_C', 'T', pIncidencia, pDataInici, pDataFi);
  END;
  
FUNCTION MAX_MARCAREPREV_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
  BEGIN
    RETURN PAK_EST_CONTROL.XXX_PER_ELEM_CEN(pRetPerCentre, 'MAX_MARCAREPREV_C', 'T', pIncidencia, pDataInici, pDataFi);
  END;

FUNCTION MAX_MODELVENTA(pRetPerParells OUT RETORN_PARELLES, pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_MODELVENTA (pRetPerParells, null, null, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_MODELVENTA'); 
    END IF;
  END;
  
FUNCTION MAX_MARCAVENTA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER, pIdCentre IN NUMBER,
                           pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_MARCAVENTA (pRetPerParells, pIdTreballador, pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_MARCAVENTA'); 
    END IF;
  END;
  
FUNCTION MAX_MODELCOMPRA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER, pIdCentre IN NUMBER,
                           pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_MODELCOMPRA (pRetPerParells, pIdTreballador, pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_MODELCOMPRA'); 
    END IF;
  END;
  
FUNCTION MAX_MARCACOMPRA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER, pIdCentre IN NUMBER,
                           pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_MARCACOMPRA (pRetPerParells, pIdTreballador, pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_MARCACOMPRA'); 
    END IF;
  END;
  
FUNCTION MAX_MODELSTOCK(pRetPerParells OUT RETORN_PARELLES, pIdCentre IN NUMBER,
                           pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_MODELSTOCK (pRetPerParells, pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_MODELSTOCK'); 
    END IF;
  END;
  
FUNCTION MAX_MARCASTOCK(pRetPerParells OUT RETORN_PARELLES, pIdCentre IN NUMBER,
                           pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_MARCASTOCK (pRetPerParells, pIdCentre, pUs, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_MARCASTOCK'); 
    END IF;
  END;
  
  FUNCTION MAX_MODELREPREV(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER, pIdCentre IN NUMBER,
                           pIncidencia IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_MODELREPREV (pRetPerParells, pIdTreballador, pIdCentre, pIncidencia, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_MODELREPREV'); 
    END IF;
  END;
  
  FUNCTION MAX_MARCAREPREV(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER, pIdCentre IN NUMBER,
                           pIncidencia IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    ret RETORNS;
  BEGIN
    ret :=  PAK_EST_CONTROL.MAX_MARCAREPREV (pRetPerParells, pIdTreballador, pIdCentre, pIncidencia, pDataInici, pDataFi);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    ELSE
      RETURN RETORNS(0,null, 'MAX_MARCAREPREV'); 
    END IF;
  END;

 
END PAK_ESTADISTIC;
/