create or replace
PACKAGE PAK_ESTADISTIC AS

/*
Mitjana de temps que es triga per realitzar una reparaci des de s'assigna la tasca un mecanic 
fins que el mecanic dona per finalitzada la feina. 
Dada el nmero absolut per tots els tallers i mecnics
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_MECANIC_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL,
                               pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps que es triga per realitzar una reparaci des de s'assigna la tasca un mecanic 
fins que el mecanic dona per finalitzada la feina. 
Dades agrupades per tallers
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_MECANIC_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps que es triga per realitzar una reparaci des de s'assigna la tasca un mecanic 
fins que el mecanic dona per finalitzada la feina. 
Dades agrupades per cada mecnic
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_MECANIC_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps en la que un vehicle esta aturat sense que es realitzi cap acci sobre ell.
Temps d'espera des de que el vehicle arriba al taller i aquest es assignat (es comena a treballar, pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)
a un mecnic
Dada el nmero absolut per tots els tallers i mecnics 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_NOUTIL_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL,
                              pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps en la que un vehicle esta aturat sense que es realitzi cap acci sobre ell.
Temps d'espera des de que el vehicle arriba al taller i aquest es assignat (es comena a treballar, pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)
a un mecnic
Dades agrupades per tallers
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_NOUTIL_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps en la que un vehicle esta aturat sense que es realitzi cap acci sobre ell.
Temps d'espera des de que el vehicle arriba al taller i aquest es assignat (es comena a treballar, pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)
a un mecnic 
Dades agrupades per cada mecnic
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_NOUTIL_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps per realitzar una reparaci des de que entra en el taller portada pel client 
fins que el mecanic dona per finalitzada la feina. 
Dada el nmero absolut per tots els tallers i mecnics 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_NOLLEST_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps per realitzar una reparaci des de que entra en el taller portada pel client 
fins que el mecanic dona per finalitzada la feina.
Dades agrupades per tallers
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_NOLLEST_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps per realitzar una reparaci des de que entra en el taller portada pel client 
fins que el mecanic dona per finalitzada la feina.
Dades agrupades per cada mecnic
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_NOLLEST_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps d'espera amb la reparaci enllestida, des de que la feina es finalitzada pel 
mecnic fins en client ve a recollir el vehicle
Dada el nmero absolut per tots els tallers i mecnics 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_EMMAGATZEMATGE_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps per realitzar una reparaci des de que entra en el taller portada pel client 
fins que el mecanic dona per finalitzada la feina.
Dades agrupades per tallers
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_EMMAGATZEMATGE_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps per realitzar una reparaci des de que entra en el taller portada pel client 
fins que el mecanic dona per finalitzada la feina.
Dades agrupades per cada mecnic
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_EMMAGATZEMATGE_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps global que un vehicle esta en el taller. 
Total del temps des de que el client entra el vehicle al taller fins que el recull
Dada el nmero absolut per tots els tallers i mecnics 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_TOTAL_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps global que un vehicle esta en el taller. 
Total del temps des de que el client entra el vehicle al taller fins que el recull
Dades agrupades per tallers
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_TOTAL_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps global que un vehicle esta en el taller. 
Total del temps des de que el client entra el vehicle al taller fins que el recull
Dades agrupades per cada mecnic
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MTEMPS_TOTAL_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana en preu que tenen les accions del taller. 
Dada el nmero absolut per tots els tallers i mecnics 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MPREU_TOTAL_REPREV(pDada OUT NUMBER, pIncidencia IN VARCHAR2 DEFAULT NULL,
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana en preu que tenen les accions del taller. 
Dades agrupades per tallers
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MPREU_TOTAL_REPREV_C(pRetPerCentre OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                              pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana en preu que tenen les accions del taller. 
Dades agrupades per cada mecnic
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MPREU_TOTAL_REPREV_M(pRetPerMecanic OUT RETORN_PARELLES_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                              pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)RETURN RETORNS;

/*
Mitjana de temps des de que un client compra el vehicle, venta tancada fins que aquest es entregat
Dada el nmero absolut per tots els concessionaris i venedors
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
*/
FUNCTION MTEMPS_ENTREGA_VENTA(pDada OUT NUMBER, pUs IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps des de que un client compra el vehicle, venta tancada fins que aquest es entregat
Dades agrupades per Concessionaris
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
*/
FUNCTION MTEMPS_ENTREGA_VENTA_C(pRetPerCentre OUT RETORN_PARELLES_tab, pUs IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana de temps des de que un client compra el vehicle, venta tancada fins que aquest es entregat 
Dades agrupades per cada venedors
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
*/
FUNCTION MTEMPS_ENTREGA_VENTA_V(pRetPerVenedor OUT RETORN_PARELLES_tab, pUs IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana en preu que tenen el total de vehicles venuts.
Dada el nmero absolut per tots els concessionaris i venedors
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
*/
FUNCTION MPREU_VENTES(pDada OUT NUMBER, pUs IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana en preu que tenen el total de vehicles venuts.
Dades agrupades per Concessionaris
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
*/
FUNCTION MPREU_VENTES_C(pRetPerCentre OUT RETORN_PARELLES_tab, pUs IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Mitjana en preu que tenen el total de vehicles venuts.
Dades agrupades per cada venedors
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
*/
 FUNCTION MPREU_VENTES_V(pRetPerVenedor OUT RETORN_PARELLES_tab, pUs IN VARCHAR2 DEFAULT NULL,
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Qui es el venedor que mes unitats ven?
Funci que ens dona  l'identificador del treballador que mes ven i les unitats que ha venut
Dada el nmero absolut per tots els concessionaris 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat, sino cerca per tot
Si s'informa un centre es filtraran les dades pel centre informat, sino cerca per tot
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_VEND_VENTES(pRetPerVenedor OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Qui es el venedor que mes unitats ven per cada concessionari?
Funci que ens dona una llista d'identificadors dels treballadors que mes venen i les unitats que han venut
Dada el nmero absolut per tots els concessionaris 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_VEND_VENTES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL,
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Qui es el venedor que mes factura?
Funci que ens dona  l'identificador del treballador que mes ven i el valor pel que ha venut
Dada el nmero absolut per tots els concessionaris 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat, sino cerca per tot
Si s'informa un centre es filtraran les dades pel centre informat, sino cerca per tot
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_FACT_VEND_VENTES(pRetPerVenedor OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;

/*
Qui es el venedor que mes factura per cada concessionari?
Funci que ens dona  l'identificador del treballador que mes ven i els valor pel que han venut
Dada el nmero absolut per tots els concessionaris 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_FACT_VEND_VENTES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;


/*
Qui s el venedor que mes unitats compra?
Funci que ens dona  l'identificador del treballador que mes compra vehicles i les unitats que ha comprat
Dada el nmero absolut per tots els concessionaris 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat, sino cerca per tot
Si s'informa un centre es filtraran les dades pel centre informat, sino cerca per tot
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_VEND_COMPRES(pRetPerVenedor OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

/*
Qui es el venedor que mes unitats compra per cada concessionari?
Funci que ens dona una llista d'identificadors dels treballadors que mes compren i les unitats que han comprat
Dada el nmero absolut per tots els concessionaris 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_VEND_COMPRES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab,  pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

/*
Qui es el venedor que mes gasta?
Funci que ens dona  l'identificador del treballador que mes compra i els valor pel que han comprat
Dada el nmero absolut per tots els concessionaris 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat, sino cerca per tot
Si s'informa un centre es filtraran les dades pel centre informat, sino cerca per tot
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_FACT_VEND_COMPRES(pRetPerVenedor OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

/*
Qui es el venedor que mes gasta per cada concessionari?
Funci que ens dona una llista d'identificadors dels treballadors que mes compren i els valors que han comprat
Dada el nmero absolut per tots els concessionaris 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_FACT_VEND_COMPRES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

/*
Qui es el mecanic que mes repara o revisa?
Funci que ens dona  l'identificador del treballador que mes repara o revisa i les unitats que ha reparat o revisat
Dada el nmero absolut per tots els tallers 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat, sino cerca per tot
Si s'informa un centre es filtraran les dades pel centre informat, sino cerca per tot
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_MECANIC_REPREV(pRetPerMecanic OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pIndidencia IN VARCHAR2 DEFAULT NULL, 
                                pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

FUNCTION MAX_UNIT_TALLER_REPREV(pRetPerCentre OUT RETORN_PARELLES, pIndidencia IN VARCHAR2 DEFAULT NULL, 
                                pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

/*
Qui es el mecanic que mes que mes factura?
Funci que ens dona  l'identificador del treballador que mes repara o revisa i el valor pel que ha reparat o revisat
Dada el nmero absolut per tots els tallers 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat, sino cerca per tot
Si s'informa un centre es filtraran les dades pel centre informat, sino cerca per tot
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MAX_FACT_MECANIC_REPREV(pRetPerMecanic OUT RETORN_PARELLES,  pIdCentre IN NUMBER DEFAULT NULL, pIndidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

FUNCTION MAX_FACT_TALLER_REPREV(pRetPerCentre OUT RETORN_PARELLES, pIndidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

/*
Funci que ens dona l'identificador del concessionari que mes vehicles ven i les unitats que ven
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_CONCES_VENTES(pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
                                 
/*
Funci que ens dona l'identificador del concessionari que mes diners ingresa i el seu valor.
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_FACT_CONCES_VENTES(pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

/*
Funci que ens dona l'identificador del concessionari que mes vehicles compra i les unitats que compra
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                                   
FUNCTION MAX_UNIT_CONCES_COMPRES(pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Funci que ens dona l'identificador del concessionari que mes diners paga en compres i el seu valor.
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/       
FUNCTION MAX_FACT_CONCES_COMPRES(pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
                                 
/*
Qui es el venedor que mes unitats ven per cada taller?
Funci que ens dona una llista d'identificadors dels treballadors ue mes reparen o revisen i les unitats que ha reparat o revisat
Dada agrupades per tallers
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_MECANIC_REPREV_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL,
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;


/*
Qui es el mecanic que mes que mes factura per cada taller?
Funci que ens dona una llista d'identificadors dels treballadors ue mes reparen o revisen i els valorss que han reparat o revisat
Dada agrupades per tallers 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/
FUNCTION MAX_FACT_MECANIC_REPREV_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS;                                 
/*
Qui es el venedor que mes unitats ven de les que hi ha en stock?
Funci que ens dona identificador del treballador que ms ven unitats en stock i el nombre de vehicles que ha venut
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_VEND_VENTESSTOCK(pRetPerTreballador OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,  
                                         pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Qui es el venedor que mes diners factura de les que hi ha en stock?
Funci que ens dona identificador del treballador que mes diners factura en stock i el valor que en diners que ha venut
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_FACT_VEND_VENTESSTOCK(pRetPerTreballador OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,  
                                         pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;   
/*
Qui es el concessionari que ms unitats ven de les que hi ha en stock?
Funci que ens dona identificador del concessionari que ms ven unitats en stock i el nombre de vehicles que ha venut
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_CONCES_VENTESSTOCK(pRetPerCentre OUT RETORN_PARELLES,  pUs IN VARCHAR2 DEFAULT NULL,  
                                         pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Qui es el concessionari que mes diners factura de les que hi ha en stock?
Funci que ens dona identificador del concessionari que mes diners factura en stock i el valor que en diners que ha venut
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_FACT_CONCES_VENTESSTOCK(pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL,  
                                         pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Qui es el venedor que mes unitats ven de les que hi ha en stock per cada concessionari?
Funci que ens dona identificador del treballador que ms ven unitats en stock i el nombre de vehicles que ha venut per cada concessionari
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_VEND_VENTESSTOCK_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Qui es el venedor que mes diners factura de les que hi ha en stock per cada concessionari?
Funci que ens dona identificador del treballador que mes diners factura en stock i el valor que en diners que ha venut per cada concessionari
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_FACT_VEND_VENTESSTOCK_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL,  
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Qui es el venedor que ms necessita fer descomptes per vendre, en unitats?
Funci que ens dona identificador del treballador que ms de les seves venden tenen descompte i el nombre porcentual d'unitats
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_P_DTO_VEND_VENTES (pRetPerTreballador OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,  
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quin es el concessionari que ms necessita fer descomptes per vendre?
Funci que ens dona identificador del concessionari que ms de les seves venden tenen descompte i el nombre porcentual d'unitats
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_P_DTO_CONCES_VENTES (pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL,  
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Qui es el venedor que ms necessita fer descomptes per vendre, en facturaci?
Funci que ens dona identificador del treballador que ms de les seves venden tenen descompte i el nombre porcentual sobre la facturaci
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_FACT_P_DTO_VEND_VENTES (pRetPerTreballador OUT RETORN_PARELLES, pIdCentre IN NUMBER DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL,  
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quin es el concessionari que ms necessita fer descomptes per vendre, en facturaci?
Funci que ens dona identificador del concessionari que ms de les seves venden tenen descompte i el nombre porcentual sobre la facturaci
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_FACT_P_DTO_CONCES_VENTES (pRetPerCentre OUT RETORN_PARELLES, pUs IN VARCHAR2 DEFAULT NULL,  
                                   pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quin es el concessionari que ms necessita fer descomptes per vendre per cada concessionari?
Funci que ens dona identificador del concessionari que ms de les seves venden tenen descompte i el nombre porcentual d'unitats per cada concessionari?
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/
FUNCTION MAX_UNIT_P_DTO_VEND_VENTES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Qui es el venedor que ms necessita fer descomptes per vendre, en facturaci per cada concessionari?
Funci que ens dona identificador del treballador que ms de les seves venden tenen descompte i el nombre porcentual sobre la facturaciper cada concessionari
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/ 
FUNCTION MAX_FACT_P_DTO_VEND_VENTES_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL,  
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Qui es el model de vehicle que ms es ven?
Funci que ens dona identificador del model del vehicle que ms es ven i el nombre d'unitats
Si s'informa l'identificador del centre es filtrara per aquell centre
Si s'informa l'identificador del treballador es filtrara pel treballador 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                                  
FUNCTION MAX_MODELVENTA(pRetPerParells OUT RETORN_PARELLES, pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

 /*
Qui es la marca de vehicle que ms es ven?
Funci que ens dona identificador de la marca del vehicle que ms es ven i el nombre d'unitats
Si s'informa l'identificador del centre es filtrara per aquell centre
Si s'informa l'identificador del treballador es filtrara pel treballador 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                          
FUNCTION MAX_MARCAVENTA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER, pIdCentre IN NUMBER,
                           pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;
/*
Qui es el model de vehicle que ms es compra?
Funci que ens dona identificador del model del vehicle que ms es compra i el nombre d'unitats
Si s'informa l'identificador del centre es filtrara per aquell centre
Si s'informa l'identificador del treballador es filtrara pel treballador 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                              
FUNCTION MAX_MODELCOMPRA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER, pIdCentre IN NUMBER,
                           pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;
 
/*
Quina es la marca de vehicle que ms es compra?
Funci que ens dona identificador de la marca del vehicle que ms es compra i el nombre d'unitats
Si s'informa l'identificador del centre es filtrara per aquell centre
Si s'informa l'identificador del treballador es filtrara pel treballador 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                            
FUNCTION MAX_MARCACOMPRA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER, pIdCentre IN NUMBER,
                           pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*
Quin es el model de vehicle que ms hi ha en estoc?
Funci que ens dona identificador del model del vehicle que ms hi ha en estoc i el nombre d'unitats
Si s'informa l'identificador del centre es filtrara per aquell centre
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                            
FUNCTION MAX_MODELSTOCK(pRetPerParells OUT RETORN_PARELLES, pIdCentre IN NUMBER,
                           pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;

/*
Quina es el marca de vehicle que ms hi ha en estoc?
Funci que ens dona identificador del marca del vehicle que ms hi ha en estoc i el nombre d'unitats
Si s'informa l'identificador del centre es filtrara per aquell centre
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                            
FUNCTION MAX_MARCASTOCK(pRetPerParells OUT RETORN_PARELLES, pIdCentre IN NUMBER,
                           pUs IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;
/*
Quin s el model de vehicle que ms es repara?
Funci que ens dona identificador del model del vehicle que ms es repara i el nombre d'unitats
Si s'informa l'identificador del centre es filtrara per aquell centre
Si s'informa l'identificador del treballador es filtrara pel treballador 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/                           
FUNCTION MAX_MODELREPREV(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER, pIdCentre IN NUMBER,
                           pIncidencia IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;
/*
Quina s la marca de vehicle que ms es repara?
Funci que ens dona identificador de la marca del vehicle que ms es repara i el nombre d'unitats
Si s'informa l'identificador del centre es filtrara per aquell centre
Si s'informa l'identificador del treballador es filtrara pel treballador 
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/                           
FUNCTION MAX_MARCAREPREV(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER, pIdCentre IN NUMBER,
                           pIncidencia IN VARCHAR2, pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS;
/*
Quin s el model de vehicle que ms es venen cadascun dels treballadors?
Funci que ens dona identificador del model del vehicle que ms es ven i el nombre d'unitats que ven cada treballador
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                                   
FUNCTION MAX_MODELVENTA_V(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quina s la marca de vehicle que ms es venen cadascun dels treballadors?
Funci que ens dona identificador de la marca del vehicle que ms es ven i el nombre d'unitats que ven cada treballador
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                            
FUNCTION MAX_MARCAVENTA_V(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

/*
Quin s el model de vehicle que ms es compra cadascun dels treballadors?
Funci que ens dona identificador del model del vehicle que ms es compra i el nombre d'unitats que ven cada treballador
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                             
FUNCTION MAX_MODELCOMPRA_V(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;

/*
Quina s la marca de vehicle que ms es compra cadascun dels treballadors?
Funci que ens dona identificador de la marca del vehicle que ms es compra i el nombre d'unitats que ven cada treballador
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                             
FUNCTION MAX_MARCACOMPRA_V(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quin s el model de vehicle que ms es repara cadascun dels treballadors?
Funci que ens dona identificador del model del vehicle que ms es repara i el nombre d'unitats que ven cada treballador
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/                             
FUNCTION MAX_MODELREPREV_M(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quina s la marca de vehicle que ms es compra cadascun dels treballadors?
Funci que ens dona identificador de la marca del vehicle que ms es compra i el nombre d'unitats que ven cada treballador
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l'incidncia es cerca en funci de que el vehicle sigui revisat (REV) o reparat (REP) o tots dos (NULL)
*/                            
FUNCTION MAX_MARCAREPREV_M(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quin s el model de vehicle que ms es venen cadascun dels centres?
Funci que ens dona identificador del model del vehicle que ms es ven i el nombre d'unitats que ven cada centre
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                             
FUNCTION MAX_MODELVENTA_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quina s la marca de vehicle que ms es venen cadascun dels centres?
Funci que ens dona identificador de la marca del vehicle que ms es ven i el nombre d'unitats que ven cada centre
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                                  
FUNCTION MAX_MARCAVENTA_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quin s el model de vehicle que ms es compren cadascun dels centres?
Funci que ens dona identificador del model del vehicle que ms es compra i el nombre d'unitats que ven cada centre
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                                 
FUNCTION MAX_MODELCOMPRA_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quina s la marca de vehicle que ms es compren cadascun dels centres?
Funci que ens dona identificador de la marca del vehicle que ms es compra i el nombre d'unitats que ven cada centre
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                                  
FUNCTION MAX_MARCACOMPRA_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quin s el model de vehicle que ms hi ha en estoc cadascun dels centres?
Funci que ens dona identificador del model del vehicle que ms hi ha en estoc i el nombre d'unitats que ven cada centre
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                                
FUNCTION MAX_MODELSTOCK_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quin s la marca de vehicle que ms hi ha en estoc cadascun dels centres?
Funci que ens dona identificador de la marca del vehicle que ms hi ha en estoc i el nombre d'unitats que ven cada centre
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                                 
FUNCTION MAX_MARCASTOCK_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quin s el model de vehicle que ms es repara cadascun dels centres?
Funci que ens dona identificador del model del vehicle que ms es repara i el nombre d'unitats que ven cada centre
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                                  
FUNCTION MAX_MODELREPREV_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;
/*
Quina s la marca de vehicle que ms es repara cadascun dels centres?
Funci que ens dona identificador de la marca del vehicle que ms es repara i el nombre d'unitats que ven cada centre
Si l'informa data d'inici i/o fi es filtraran les dades pel perode informat
Si S'informa l's es cerca en funci de que el vehicle sigui nou (N) o segona ma (S) o tots dos (NULL)
*/                                  
FUNCTION MAX_MARCAREPREV_C(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS;



END PAK_ESTADISTIC;
/