create or replace
PACKAGE BODY PAK_EST_CONTROL AS
  
  FUNCTION CONTROL_DATES(pDataInici IN OUT DATE, pDataFi IN OUT DATE) RETURN RETORNS IS
  
  BEGIN
  IF pDataInici IS NULL THEN
    pDataInici := '01/01/0001';
  END IF;
  IF  pDataFi IS NULL THEN
    pDataFi := '31/12/9999';
  END IF;  
  
    RETURN RETORNS(0,null, 'CONTROL_DATES');
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'CONTROL_DATES', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MITJA_REPREV(pDada OUT NUMBER, pLiteral VARCHAR2, pIdMecanic IN VARCHAR2 DEFAULT NULL,
                                 pIdCentre IN VARCHAR2 DEFAULT NULL, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  ret RETORNS;
  vDataI DATE := pDataInici;
  vDataF DATE := pDataFi;
  vSQL  VARCHAR2(1000);
  BEGIN
    ret := CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;
  
    vSQL:= 'SELECT ROUND(AVG('||pLiteral||'),2)
            FROM REPREV
            WHERE DataSortida IS NOT NULL 
              AND DataBaixa IS NULL 
              AND DataEntrada BETWEEN TO_DATE('''|| vDataI ||''', ''DD/MM/YYYY'') AND TO_DATE('''|| vDataF ||''', ''DD/MM/YYYY'')' ;
     IF pIdCentre IS NOT NULL THEN
        vSQL := vSQL || ' AND IdCentre = ' ||pIdCentre;
     END IF;
     IF pIdMecanic IS NOT NULL THEN
        vSQL := vSQL || ' AND IdMecanic = ' ||pIdMecanic;
     END IF;
     IF pIncidencia = 'REP' THEN
       vSQL := vSQL || ' AND Incidencia = ''REP''';
     ELSIF pIncidencia = 'REV' THEN
       vSQL := vSQL || ' AND Incidencia = ''REV''';
     END IF;
      EXECUTE IMMEDIATE (vSQL) INTO pDada; 
      
    RETURN RETORNS(0,null, 'PREU_REPREV');
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'PREU_REPREV', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MITJA_DIFF_REPREV(pDada OUT NUMBER, pLitDataSup VARCHAR2, pLitDataInf VARCHAR2, pIdMecanic IN VARCHAR2 DEFAULT NULL,
                                 pIdCentre IN VARCHAR2 DEFAULT NULL, pIncidencia IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  ret RETORNS;
  vDataI DATE := pDataInici;
  vDataF DATE := pDataFi;
  vSQL  VARCHAR2(1000);
  BEGIN
    ret := CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;
  
    vSQL:= 'SELECT ROUND(AVG('||pLitDataSup||'-'||pLitDataInf||'),2)
            FROM REPREV
            WHERE '||pLitDataSup||' IS NOT NULL 
                  AND '||pLitDataInf||' IS NOT NULL 
                  AND DataBaixa IS NULL                   
                  AND DataEntrada BETWEEN TO_DATE('''|| vDataI ||''', ''DD/MM/YYYY'') AND TO_DATE('''|| vDataF ||''', ''DD/MM/YYYY'')' ;
     IF pIdCentre IS NOT NULL THEN
        vSQL := vSQL || ' AND IdCentre = ' ||pIdCentre;
     END IF;
     IF pIdMecanic IS NOT NULL THEN
        vSQL := vSQL || ' AND IdMecanic = ' ||pIdMecanic;
     END IF;
     IF pIncidencia = 'REP' THEN
       vSQL := vSQL || ' AND Incidencia = ''REP''';
     ELSIF pIncidencia = 'REV' THEN
       vSQL := vSQL || ' AND Incidencia = ''REV''';
     END IF;
     EXECUTE IMMEDIATE (vSQL) INTO pDada; 
      
     RETURN RETORNS(0,null, 'MITJA_DIFF_REPREV');
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MITJA_DIFF_REPREV', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

 FUNCTION MITJA_DIFF_VENTES(pDada OUT NUMBER, pLitDataSup VARCHAR2, pLitDataInf VARCHAR2, pIdTreballador IN VARCHAR2 DEFAULT NULL,
                                 pIdCentre IN VARCHAR2 DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  ret RETORNS;
  vDataI DATE := pDataInici;
  vDataF DATE := pDataFi;
  vSQL  VARCHAR2(1000);
  BEGIN
    ret := CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;
  
    vSQL:= 'SELECT ROUND(AVG('||pLitDataSup||'-'||pLitDataInf||'),2)
            FROM VENTES
            WHERE '||pLitDataSup||' IS NOT NULL 
                  AND '||pLitDataInf||' IS NOT NULL 
                  AND DataBaixa IS NULL                  
                  AND DataVenta BETWEEN TO_DATE('''|| vDataI ||''', ''DD/MM/YYYY'') AND TO_DATE('''|| vDataF ||''', ''DD/MM/YYYY'')' ;
     IF pIdCentre IS NOT NULL THEN
        vSQL := vSQL || ' AND IdCentre = ' ||pIdCentre;
     END IF;
     IF pIdTreballador IS NOT NULL THEN
        vSQL := vSQL || ' AND IdTreballador = ' ||pIdTreballador;
     END IF;
     IF pUs = 'N' THEN
       vSQL := vSQL || ' AND Us = ''N''';
     ELSIF pUs = 'S' THEN
       vSQL := vSQL || ' AND Us = ''S''';
     END IF;

     EXECUTE IMMEDIATE (vSQL) INTO pDada; 
      dbms_output.put_line(vSQL);
     RETURN RETORNS(0,null, 'MITJA_VENTES');
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MITJA_VENTES', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MITJA_VENTES(pDada OUT NUMBER, pLiteral VARCHAR2, pIdTreballador IN VARCHAR2 DEFAULT NULL,
                                 pIdCentre IN VARCHAR2 DEFAULT NULL, pUs IN VARCHAR2 DEFAULT NULL, 
                                 pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
  ret RETORNS;
  vDataI DATE := pDataInici;
  vDataF DATE := pDataFi;
  vSQL  VARCHAR2(1000);
  BEGIN
    ret := CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;
  dbms_output.put_line(TO_CHAR(vDataI, 'DD/MM/YYYY'));
  dbms_output.put_line(TO_CHAR(vDataF, 'DD/MM/YYYY'));
    vSQL:= 'SELECT ROUND(AVG('||pLiteral||'),2)
            FROM VENTES
            WHERE DataEntrega IS NOT NULL 
              AND DataBaixa IS NULL 
              AND DataVenta BETWEEN TO_DATE('''|| vDataI ||''', ''DD/MM/YYYY'') AND TO_DATE('''|| vDataF ||''', ''DD/MM/YYYY'')' ;
     IF pIdCentre IS NOT NULL THEN
        vSQL := vSQL || ' AND IdCentre = ' ||pIdCentre;
     END IF;
     IF pIdTreballador IS NOT NULL THEN
        vSQL := vSQL || ' AND IdTreballador = ' ||pIdTreballador;
     END IF;
     IF pUs = 'N' THEN
       vSQL := vSQL || ' AND Us = ''N''';
     ELSIF pUs = 'S' THEN
       vSQL := vSQL || ' AND Incidencia = ''S''';
     END IF;
                dbms_output.put_line(vSQL);
      EXECUTE IMMEDIATE (vSQL) INTO pDada; 
      
    RETURN RETORNS(0,null, 'MITJA_VENTES');
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MITJA_VENTES', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MAX_COMPRES(pRetPerParells OUT RETORN_PARELLES, pAccio VARCHAR2, pAgrupatPer VARCHAR2,   
                      pIdCentre IN NUMBER, pUs IN VARCHAR2, 
                      pDataInici IN DATE, pDataFi IN DATE) RETURN RETORNS IS

    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;
    vSQL := ' SELECT Max(T.Valor) AS ValorMax, T.Ens AS IdEns
              FROM (SELECT '|| pAccio ||' AS Valor, '|| pAgrupatPer ||' As Agrupat
                      FROM COMPRES C, COMPRES_LINIES L
                      WHERE L.IdCompra = C.Id AND
                            DataTancament IS NOT NULL AND
                            DataTancament BETWEEN '''|| vDataI ||''' AND '''|| vDataF ||'''' ;
    IF pIdCentre IS NOT NULL THEN
      vSQL:= vSQL||' AND IdCentre = '||pIdCentre;
    END IF;
    IF pUs = 'N' THEN
      vSQL:= vSQL||' AND Us = ''N'' ';
    ELSIF pUs = 'S' THEN
      vSQL:= vSQL||' AND Us = ''S'' ';   
    END IF;
    vSQL:= vSQL||' GROUP BY Agrupat) T';
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_COMPRES');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_COMPRES', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MAX_REPREV(pRetPerParells OUT RETORN_PARELLES, pAccio VARCHAR2, pAgrupatPer VARCHAR2,   
                          pIdCentre IN NUMBER, pIncidencia IN VARCHAR2, 
                          pDataInici IN DATE, pDataFi IN DATE)  RETURN RETORNS IS

    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;
    vSQL := ' SELECT Max(T.Valor) AS ValorMax, T.Ens AS IdEns
              FROM (SELECT '|| pAccio ||' AS Valor, '|| pAgrupatPer ||' As Agrupat
                      FROM REPREV
                      WHERE DataEntrada IS NOT NULL AND
                            DataEntrada BETWEEN '''|| vDataI ||''' AND '''|| vDataF ||'''' ;
    IF pIdCentre IS NOT NULL THEN
      vSQL:= vSQL||' AND IdCentre = '||pIdCentre;
    END IF;                            
    IF pIncidencia = 'REP' THEN
      vSQL:= vSQL||' AND Incidencia = ''REP'' ';
    ELSIF pIncidencia = 'REV' THEN
      vSQL:= vSQL||' AND Incidencia = ''REV'' ';   
    END IF;
    vSQL:= vSQL||'GROUP BY Agrupat) T';
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_REPREV');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_REPREV', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MAX_VENTES(pRetPerParells OUT RETORN_PARELLES, pAccio VARCHAR2, pAgrupatPer VARCHAR2,   
                      pIdCentre IN NUMBER, pUs IN VARCHAR2, 
                      pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS

    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;
    vSQL := ' SELECT Max(T.Valor) AS ValorMax, T.Ens AS IdEns
              FROM (SELECT '|| pAccio ||' AS Valor, '|| pAgrupatPer ||' As Agrupat
                      FROM VENTES
                      WHERE DataVenta IS NOT NULL AND
                            DataVenta BETWEEN '''|| vDataI ||''' AND '''|| vDataF ||'''' ;
    IF pIdCentre IS NOT NULL THEN
      vSQL:= vSQL||' AND IdCentre = '||pIdCentre;
    END IF;
    IF pUs = 'S' THEN
      vSQL:= vSQL||' AND Us = ''S'' ';
    ELSIF pUs = 'N' THEN
      vSQL:= vSQL||' AND Us = ''N'' ';   
    END IF;
    vSQL:= vSQL||'GROUP BY Agrupat) T';
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_VENTES');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_VENTES', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MAX_VENTASTOCK(pRetPerParells OUT RETORN_PARELLES, pAccio VARCHAR2, pAgrupatPer VARCHAR2,   
                          pIdCentre IN NUMBER, pUs IN VARCHAR2, 
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS

    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;
    vSQL:='SELECT MAX('|| pAccio ||') AS Valor, '|| pAgrupatPer ||' As Agrupat
            FROM VENTES v, STOCK s
           WHERE v.dataventa is not null
             AND DataBaixa IS NULL AND
             AND v.IdVehicle = s.IdVehicle
             AND v.DataEncarrec between s.dataentrada and s.datasortida
             AND DataVenta BETWEEN '''|| vDataI ||''' AND '''|| vDataF ||'''' ;
    IF pIdcentre IS NOT NULL THEN
      vSQL:= vSQL||' AND idCentre = '||pIdcentre;
    END IF;
    IF pUs = 'S' THEN
       vSQL:=vSQL||' AND Us = ''S'' ';
    ELSIF pUs = 'N' THEN
       vSQL:=vSQL||' AND Us = ''N'' ';
    END IF;     
    vSQL:=vSQL||'group Agrupat';
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_VENTASTOCK');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_VENTASTOCK', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MAX_PERCENDTO(pRetPerParells OUT RETORN_PARELLES, pAccio VARCHAR2, pAgrupatPer VARCHAR2,   
                          pIdCentre IN NUMBER, pUs IN VARCHAR2, 
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    
    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;
      
    vSQL:='SELECT MAX((desc.ambdesc/v.tots)*100) AS Valor, v.Agrupat
            FROM (SELECT '|| pAccio ||' as tots, '|| pAgrupatPer ||' As Agrupat
                  FROM ventes
                  WHERE dataventa is not null AND
                        databaixa is null ';
     IF pIdcentre IS NOT NULL THEN
      vSQL:= vSQL||' AND idCentre = '||pIdcentre;
    END IF;
    IF pUs = 'S' THEN
       vSQL:=vSQL||' AND Us = ''S'' ';
    ELSIF pUs = 'N' THEN
       vSQL:=vSQL||' AND Us = ''N'' ';
    END IF;                        
      vSQL:= vSQL||' GROUP BY Agrupat) v, 
                 (SELECT '|| pAccio ||' as ambdesc, '|| pAgrupatPer ||' As Agrupat
                    FROM ventes
                   WHERE dataventa is not null AND
                         databaixa is null and
                         descompte <> 0 ';
     IF pIdcentre IS NOT NULL THEN
      vSQL:= vSQL||' AND idCentre = '||pIdcentre;
    END IF;
    IF pUs = 'S' THEN
       vSQL:=vSQL||' AND Us = ''S'' ';
    ELSIF pUs = 'N' THEN
       vSQL:=vSQL||' AND Us = ''N'' ';
    END IF;                           
      vSQL:= vSQL||' GROUP BY Agrupat) desc                   
           WHERE v.idvenedor = desc.idvenedor ';
    
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_PERCENDTO');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_PERCENDTO', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MAX_MODELVENTA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pUs IN VARCHAR2, 
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    
    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;

    vSQL:='SELECT MAX(Count(A.Id)) AS Valor, IdModel
           FROM VENTES A, VEHICLES B, CONFIGFIN C, CONFIG3 D, CONFIG2 E, CONFIG1 F
           WHERE A.IdVehicle = B.Id AND
                 B.IdConfigFin = C.Id AND
                 C.IdConfig3 = D.Id AND
                 D.Idconfig2 = E.Id AND
                 E.Idconfig1 = F.Id AND
                 A.DataBaixa IS NULL AND 
                 A.DataVenta IS NOT NULL AND
                 A.DataVenta BETWEEN '''|| vDataI ||''' AND '''|| vDataF ||'''' ;
    IF pIdcentre IS NOT NULL THEN
      vSQL:= vSQL||' AND idCentre = '||pIdcentre;
    END IF;
    IF pIdTreballador IS NOT NULL THEN
      vSQL:= vSQL||' AND IdTreballador = '||pIdTreballador;
    END IF;
    IF pUs = 'S' THEN
       vSQL:=vSQL||' AND Us = ''S'' ';
    ELSIF pUs = 'N' THEN
       vSQL:=vSQL||' AND Us = ''N'' ';
    END IF;                        
      vSQL:= vSQL||' GROUP BY IdModel ';
   
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_MODELVENTA');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_MODELVENTA', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

    FUNCTION MAX_MODELCOMPRA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pUs IN VARCHAR2, 
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    
    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;

    vSQL:='SELECT MAX(Count(A.Id)) AS Valor, IdModel
           FROM COMPRES_LINIES A, VEHICLES B, CONFIGFIN C, CONFIG3 D, CONFIG2 E, CONFIG1 F, COMPRA G
           WHERE A.IdVehicle = B.Id AND
                 B.IdConfigFin = C.Id AND
                 C.IdConfig3 = D.Id AND
                 D.Idconfig2 = E.Id AND
                 E.Idconfig1 = F.Id AND 
                 A.IdCompra = G.Id AND
                 G.DataBaixa IS NULL AND 
                 G.DataTancament IS NOT NULL AND
                 G.DataTancament BETWEEN '''|| vDataI ||''' AND '''|| vDataF ||'''' ;
    IF pIdcentre IS NOT NULL THEN
      vSQL:= vSQL||' AND idCentre = '||pIdcentre;
    END IF;
    IF pIdTreballador IS NOT NULL THEN
      vSQL:= vSQL||' AND IdTreballador = '||pIdTreballador;
    END IF;
    IF pUs = 'S' THEN
       vSQL:=vSQL||' AND Us = ''S'' ';
    ELSIF pUs = 'N' THEN
       vSQL:=vSQL||' AND Us = ''N'' ';
    END IF;                        
      vSQL:= vSQL||' GROUP BY IdModel ';
   
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_MODELCOMPRA');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_MODELCOMPRA', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

 FUNCTION MAX_MODELSTOCK(pRetPerParells OUT RETORN_PARELLES, pIdCentre IN NUMBER, pUs IN VARCHAR2, 
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    
    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;

    vSQL:='SELECT MAX(Count(A.Id)) AS Valor, IdModel
           FROM STOCK A, VEHICLES B, CONFIGFIN C, CONFIG3 D, CONFIG2 E, CONFIG1 F
           WHERE A.IdVehicle = B.Id AND
                 B.IdConfigFin = C.Id AND
                 C.IdConfig3 = D.Id AND
                 D.Idconfig2 = E.Id AND
                 E.Idconfig1 = F.Id AND 
                 A.DataSortida IS NULL AND 
                 A.DataEntrada IS NOT NULL AND
                 A.DataEntrada BETWEEN '''|| vDataI ||''' AND '''|| vDataF ||'''' ;
    IF pIdcentre IS NOT NULL THEN
      vSQL:= vSQL||' AND idCentre = '||pIdcentre;
    END IF;
    IF pUs = 'S' THEN
       vSQL:=vSQL||' AND Us = ''S'' ';
    ELSIF pUs = 'N' THEN
       vSQL:=vSQL||' AND Us = ''N'' ';
    END IF;                        
      vSQL:= vSQL||' GROUP BY IdModel ';
   
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_MODELSTOCK');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_MODELSTOCK', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

    FUNCTION MAX_MODELREPREV(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pIncidencia IN VARCHAR2, 
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    
    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;

    vSQL:='SELECT MAX(Count(A.Id)) AS Valor, IdModel
           FROM REPREV A, VEHICLES B, CONFIGFIN C, CONFIG3 D, CONFIG2 E, CONFIG1 F
           WHERE A.IdVehicle = B.Id AND
                 B.IdConfigFin = C.Id AND
                 C.IdConfig3 = D.Id AND
                 D.Idconfig2 = E.Id AND
                 E.Idconfig1 = F.Id AND 
                 A.DataBaixa IS NULL AND 
                 A.DataBaixa IS NULL AND               
                 A.DataEntrada BETWEEN TO_DATE('''|| vDataI ||''', ''DD/MM/YYYY'') AND TO_DATE('''|| vDataF ||''', ''DD/MM/YYYY'')' ;
    IF pIdcentre IS NOT NULL THEN
      vSQL:= vSQL||' AND idCentre = '||pIdcentre;
    END IF;
    IF pIdTreballador IS NOT NULL THEN
      vSQL:= vSQL||' AND IdTreballador = '||pIdTreballador;
    END IF;
    IF pIncidencia = 'REP' THEN
       vSQL:=vSQL||' AND Incidencia = ''REP'' ';
    ELSIF pIncidencia = 'REV' THEN
       vSQL:=vSQL||' AND Incidencia = ''REV'' ';
    END IF;                        
      vSQL:= vSQL||' GROUP BY IdModel ';
   
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_MODELREPREV');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_MODELREPREV', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MAX_MARCAVENTA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pUs IN VARCHAR2, 
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    
    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;

    vSQL:='SELECT MAX(Count(A.Id)) AS Valor, IdMarca
           FROM VENTES A, VEHICLES B, CONFIGFIN C, CONFIG3 D, CONFIG2 E, CONFIG1 F, MODEL G
           WHERE A.IdVehicle = B.Id AND
                 B.IdConfigFin = C.Id AND
                 C.IdConfig3 = D.Id AND
                 D.Idconfig2 = E.Id AND
                 E.Idconfig1 = F.Id AND 
                 F.IdModel = G.Id AND
                 A.DataBaixa IS NULL AND 
                 A.DataVenta IS NOT NULL AND
                 A.DataVenta BETWEEN '''|| vDataI ||''' AND '''|| vDataF ||'''' ;
    IF pIdcentre IS NOT NULL THEN
      vSQL:= vSQL||' AND idCentre = '||pIdcentre;
    END IF;
    IF pIdTreballador IS NOT NULL THEN
      vSQL:= vSQL||' AND IdTreballador = '||pIdTreballador;
    END IF;
    IF pUs = 'S' THEN
       vSQL:=vSQL||' AND Us = ''S'' ';
    ELSIF pUs = 'N' THEN
       vSQL:=vSQL||' AND Us = ''N'' ';
    END IF;                        
      vSQL:= vSQL||' GROUP BY IdMarca ';
   
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_MARCAVENTA');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_MARCAVENTA', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

    FUNCTION MAX_MARCACOMPRA(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pUs IN VARCHAR2, 
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    
    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;

    vSQL:='SELECT MAX(Count(A.Id)) AS Valor, IdMarca
           FROM COMPRES_LINIES A, VEHICLES B, CONFIGFIN C, CONFIG3 D, CONFIG2 E, CONFIG1 F, MODEL G, COMPRA H
           WHERE A.IdVehicle = B.Id AND
                 B.IdConfigFin = C.Id AND
                 C.IdConfig3 = D.Id AND
                 D.Idconfig2 = E.Id AND
                 E.Idconfig1 = F.Id AND 
                 F.IdModel = G.Id AND
                 A.IdCompra = H.Id AND
                 H.DataBaixa IS NULL AND 
                 H.DataTancament IS NOT NULL AND
                 H.DataTancament BETWEEN '''|| vDataI ||''' AND '''|| vDataF ||'''' ;
    IF pIdcentre IS NOT NULL THEN
      vSQL:= vSQL||' AND idCentre = '||pIdcentre;
    END IF;
    IF pIdTreballador IS NOT NULL THEN
      vSQL:= vSQL||' AND IdTreballador = '||pIdTreballador;
    END IF;
    IF pUs = 'S' THEN
       vSQL:=vSQL||' AND Us = ''S'' ';
    ELSIF pUs = 'N' THEN
       vSQL:=vSQL||' AND Us = ''N'' ';
    END IF;                        
      vSQL:= vSQL||' GROUP BY IdMarca ';
   
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_MARCACOMPRA');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_MARCACOMPRA', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
 FUNCTION MAX_MARCASTOCK(pRetPerParells OUT RETORN_PARELLES, pIdCentre IN NUMBER, pUs IN VARCHAR2, 
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    
    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;

    vSQL:='SELECT MAX(Count(A.Id)) AS Valor, IdMarca
           FROM STOCK A, VEHICLES B, CONFIGFIN C, CONFIG3 D, CONFIG2 E, CONFIG1 F, MODEL G
           WHERE A.IdVehicle = B.Id AND
                 B.IdConfigFin = C.Id AND
                 C.IdConfig3 = D.Id AND
                 D.Idconfig2 = E.Id AND
                 E.Idconfig1 = F.Id AND 
                 F.IdModel = G.Id AND
                 A.DataSortida IS NULL AND 
                 A.DataEntrada IS NOT NULL AND
                 A.DataEntrada BETWEEN '''|| vDataI ||''' AND '''|| vDataF ||'''' ;
    IF pIdcentre IS NOT NULL THEN
      vSQL:= vSQL||' AND idCentre = '||pIdcentre;
    END IF;
    IF pUs = 'S' THEN
       vSQL:=vSQL||' AND Us = ''S'' ';
    ELSIF pUs = 'N' THEN
       vSQL:=vSQL||' AND Us = ''N'' ';
    END IF;                        
      vSQL:= vSQL||' GROUP BY IdMarca ';
   
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_MARCASTOCK');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_MARCASTOCK', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
 
  FUNCTION MAX_MARCAREPREV(pRetPerParells OUT RETORN_PARELLES, pIdTreballador IN NUMBER,
                          pIdCentre IN NUMBER, pIncidencia IN VARCHAR2, 
                          pDataInici IN DATE, pDataFi IN DATE)   RETURN RETORNS IS
    
    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    ret RETORNS;
    vSQL VARCHAR2 (1000);
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;

    vSQL:='SELECT MAX(Count(A.Id)) AS Valor, IdMarca
           FROM REPREV A, VEHICLES B, CONFIGFIN C, CONFIG3 D, CONFIG2 E, CONFIG1 F, MODEL G
           WHERE A.IdVehicle = B.Id AND
                 B.IdConfigFin = C.Id AND
                 C.IdConfig3 = D.Id AND
                 D.Idconfig2 = E.Id AND
                 E.Idconfig1 = F.Id AND 
                 F.IdModel = G.Id AND
                 A.DataBaixa IS NULL AND 
                 A.DataBaixa IS NULL AND               
                 A.DataEntrada BETWEEN TO_DATE('''|| vDataI ||''', ''DD/MM/YYYY'') AND TO_DATE('''|| vDataF ||''', ''DD/MM/YYYY'')' ;
    IF pIdcentre IS NOT NULL THEN
      vSQL:= vSQL||' AND idCentre = '||pIdcentre;
    END IF;
    IF pIdTreballador IS NOT NULL THEN
      vSQL:= vSQL||' AND IdMecanic = '||pIdTreballador;
    END IF;
    IF pIncidencia = 'REP' THEN
       vSQL:=vSQL||' AND Incidencia = ''REP'' ';
    ELSIF pIncidencia = 'REV' THEN
       vSQL:=vSQL||' AND Incidencia = ''REV'' ';
    END IF;                        
      vSQL:= vSQL||' GROUP BY IdMarca ';
   
    
    EXECUTE IMMEDIATE vSQL INTO pRetPerParells.Valor, pRetPerParells.Id;
    
    RETURN RETORNS(0,null, 'MAX_MARCAREPREV');   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MAX_MARCAREPREV', null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
 
  FUNCTION XXX_PER_CENTRES(pRetPerCentre OUT RETORN_PARELLES_tab, pAccio VARCHAR2, pTipusCentre VARCHAR2,
                            pCriteri IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                            pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS
   
    CURSOR cCENTRES(pTipus VARCHAR2) IS
      SELECT Id
      FROM CENTRES
      WHERE Tipus = pTipus;
 
     vIdCentre CENTRES.Id%TYPE;
     i NUMBER :=1;
     ret RETORNS;
     vNum NUMBER;

  BEGIN

      OPEN cCENTRES(pTipusCentre);
      FETCH cCENTRES INTO vIdCentre;
      pRetPerCentre  := RETORN_PARELLES_tab();
      WHILE cCENTRES%found LOOP
        IF pAccio = 'MTEMPS_MECANIC_REPREV_C' THEN
          ret:= MITJA_DIFF_REPREV(vNum, 'DataFi', 'DataInici', null, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MTEMPS_NOUTIL_REPREV_C' THEN
          ret:= MITJA_DIFF_REPREV(vNum, 'DataInici', 'DataEntrada', null, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MTEMPS_NOLLEST_REPREV_C' THEN
          ret:= MITJA_DIFF_REPREV(vNum, 'DataFi', 'DataEntrada', null, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MTEMPS_EMMAGATZEMATGE_REPREV_C' THEN
          ret:= MITJA_DIFF_REPREV(vNum, 'DataSortida', 'DataFi', null, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MTEMPS_TOTAL_REPREV_C' THEN
          ret:= MITJA_DIFF_REPREV(vNum, 'DataSortida', 'DataEntrada', null, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MPREU_TOTAL_REPREV_C' THEN
          ret:= MITJA_REPREV(vNum, 'Preu', null, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MTEMPS_ENTREGA_VENTA_C' THEN
          ret:= MITJA_DIFF_VENTES(vNum, 'DataEntrega','DataVenta', null, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MPREU_VENTES_C' THEN
          ret:= MITJA_VENTES(vNum, 'PreuFinal', null, vIdCentre, pCriteri, pDataInici, pDataFi);     
        END IF;

       IF ret.IdMissatge = 0 THEN
         pRetPerCentre.EXTEND;
         pRetPerCentre(i).Valor := vNum;
         pRetPerCentre(i).Id := vIdCentre;
         FETCH cCENTRES INTO vIdCentre;
         i := i + 1;
       ELSE
          RETURN ret;
       END IF;                                  

      END LOOP;
    CLOSE cCENTRES;
  
    RETURN RETORNS(0,null, pAccio);
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, pAccio, null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  
   FUNCTION XXX_PER_TREBALLADORS(pRetPerTreb OUT RETORN_PARELLES_tab, pAccio VARCHAR2, pTipusCentre VARCHAR2,
                            pCriteri IN VARCHAR2 DEFAULT NULL, pDataInici IN DATE DEFAULT NULL, 
                            pDataFi IN DATE DEFAULT NULL) RETURN RETORNS IS

    CURSOR cTREBALLADORS(pTipus VARCHAR2) IS
      SELECT T.Id
      FROM CENTRES C, TREBALLADORS T
      WHERE C.Tipus = pTipus
      AND T.IdCentre = C.Id;
 
     vIdTreballador CENTRES.Id%TYPE;
     i NUMBER :=1;
     ret RETORNS;
     vNum NUMBER;

  BEGIN

      OPEN cTREBALLADORS(pTipusCentre);
      FETCH cTREBALLADORS INTO vIdTreballador;
      pRetPerTreb  := RETORN_PARELLES_tab();
      WHILE cTREBALLADORS%found LOOP
        IF pAccio = 'MTEMPS_MECANIC_REPREV_M' THEN
          ret:= MITJA_DIFF_REPREV(vNum, 'DataFi', 'DataInici', vIdTreballador, null, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MTEMPS_NOUTIL_REPREV_M' THEN
          ret:= MITJA_DIFF_REPREV(vNum, 'DataInici', 'DataEntrada', vIdTreballador, null, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MTEMPS_NOLLEST_REPREV_M' THEN
          ret:= MITJA_DIFF_REPREV(vNum, 'DataFi', 'DataEntrada', vIdTreballador, null, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MTEMPS_EMMAGATZEMATGE_REPREV_M' THEN
          ret:= MITJA_DIFF_REPREV(vNum, 'DataSortida', 'DataFi', vIdTreballador, null, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MTEMPS_TOTAL_REPREV_M' THEN
          ret:= MITJA_DIFF_REPREV(vNum, 'DataSortida', 'DataEntrada', vIdTreballador, null, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MPREU_TOTAL_REPREV_M' THEN
          ret:= MITJA_REPREV(vNum, 'Preu', vIdTreballador, null, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MTEMPS_ENTREGA_VENTA_V' THEN
          ret:= MITJA_DIFF_VENTES(vNum, 'DataEntrega','DataVenta', vIdTreballador, null, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MPREU_VENTES_V' THEN
          ret:= MITJA_VENTES(vNum, 'PreuFinal', vIdTreballador, null, pCriteri, pDataInici, pDataFi); 
        END IF;

       IF ret.IdMissatge = 0 THEN
         pRetPerTreb.EXTEND;
         pRetPerTreb(i).Valor := vNum;
         pRetPerTreb(i).Id := vIdTreballador;
         FETCH cTREBALLADORS INTO vIdTreballador;
         i := i + 1;
       ELSE
          RETURN ret;
       END IF;                                  

      END LOOP;
    CLOSE cTREBALLADORS;
  
    RETURN RETORNS(0,null, pAccio);
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, pAccio, null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  /*retorna llista de tripleta de valors: Valor, idelement, idCentre*/
  FUNCTION XXX_PER_ELEM_CEN(pRetPerCentre OUT RETORN_AMB_CENTRE_tab, pAccio IN VARCHAR2, 
                            pTipusCentre IN VARCHAR2, pCriteri IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    CURSOR cCENTRES (pTipus VARCHAR2) IS
       SELECT Id
       FROM CENTRES
       WHERE Tipus = pTipus;
    
    vIdCentre CENTRES.Id%TYPE;
    i NUMBER :=1;
    ret RETORNS;
    pRetPerParelles RETORN_PARELLES;
    
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;

    OPEN cCENTRES(pTipusCentre);
      FETCH cCENTRES INTO vIdCentre;
      pRetPerCentre  := RETORN_AMB_CENTRE_tab();
      WHILE cCENTRES%found LOOP
        IF pAccio = 'MAX_UNIT_VEND_VENTES_C' THEN
          ret:= MAX_VENTES (pRetPerParelles, 'Count(Id)', 'IdTreballador', vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_FACTURA_VEND_VENTES_C' THEN
          ret:= MAX_VENTES (pRetPerParelles,  'SUM(PreuFinal)', 'IdTreballador', vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_UNIT_VEND_COMPRES_C' THEN
          ret := MAX_COMPRES ( pRetPerParelles,'Count(IdVehicle)', 'IdTreballador', vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_FACTURA_VEND_COMPRES_C' THEN
          ret := MAX_COMPRES ( pRetPerParelles, 'SUM(Preu)', 'IdTreballador', vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_UNIT_MECANIC_REPREV_C' THEN
          ret := MAX_REPREV ( pRetPerParelles, 'Count(Id)', 'IdMecanic', vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_FACTURA_MECANIC_REPREV_C' THEN
          ret := MAX_REPREV ( pRetPerParelles, 'SUM(Preu)', 'IdMecanic', vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_UNIT_VEND_VENTESSTOCK_C' THEN
          ret := MAX_VENTASTOCK ( pRetPerParelles, 'count(v.id)', 'IdTreballador', vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_FACTURA_VEND_VENTESSTOCK_C' THEN
          ret := MAX_VENTASTOCK ( pRetPerParelles, 'SUM(Preu)', 'IdTreballador', vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_UNIT_P_DTO_VEND_VENTES_C' THEN
          ret := MAX_PERCENDTO ( pRetPerParelles, 'count(id)', 'IdTreballador', vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_FACT_P_DTO_VEND_VENTES_C' THEN
          ret := MAX_PERCENDTO ( pRetPerParelles, 'SUM(Preu)', 'IdTreballador', vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_MODELVENTA_C' THEN
          ret := MAX_MODELVENTA ( pRetPerParelles, null, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_MARCAVENTA_C' THEN
          ret := MAX_MARCAVENTA ( pRetPerParelles, null, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_MODELCOMPRA_C' THEN
          ret := MAX_MODELCOMPRA ( pRetPerParelles, null, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_MARCACOMPRA_C' THEN
          ret := MAX_MODELCOMPRA ( pRetPerParelles, null, vIdCentre, pCriteri, pDataInici, pDataFi);      
        ELSIF pAccio = 'MAX_MODELSTOCK_C' THEN
          ret := MAX_MODELSTOCK ( pRetPerParelles, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_MARCASTOCK_C' THEN
          ret := MAX_MARCASTOCK ( pRetPerParelles, vIdCentre, pCriteri, pDataInici, pDataFi);  
        ELSIF pAccio = 'MAX_MODELREPREV_C' THEN
          ret := MAX_MODELREPREV ( pRetPerParelles, null, vIdCentre, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_MARCAREPREV_C' THEN
          ret := MAX_MARCAREPREV ( pRetPerParelles, null, vIdCentre, pCriteri, pDataInici, pDataFi);            
        END IF;
       
        IF ret.IdMissatge = 0 THEN
          pRetPerCentre.EXTEND;
          pRetPerCentre(i).Valor := pRetPerParelles.Valor;
          pRetPerCentre(i).Id := pRetPerParelles.Id;
          pRetPerCentre(i).IdCentre := vIdCentre;
          FETCH cCENTRES INTO vIdCentre;
          i := i + 1;
        ELSE
          RETURN ret;
        END IF;                                  

      END LOOP;
    CLOSE cCENTRES;
  
    RETURN RETORNS(0,null, pAccio);   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, pAccio, null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  /*retorna llista de tripleta de valors: Valor, idelement, idTreballador*/
  FUNCTION XXX_PER_ELEM_TREB(pRetPerTreb OUT RETORN_AMB_CENTRE_tab, pAccio IN VARCHAR2, 
                            pTipusCentre IN VARCHAR2, pCriteri IN VARCHAR2 DEFAULT NULL, 
                            pDataInici IN DATE DEFAULT NULL, pDataFi IN DATE DEFAULT NULL)  RETURN RETORNS IS
    vDataI DATE := pDataInici;
    vDataF DATE := pDataFi;
    CURSOR cTREBALLADOR (pTipus VARCHAR2) IS
       SELECT T.Id
       FROM CENTRES C, TREBALLADORS T
       WHERE T.IdCentre = C.Id AND
             C.Tipus = pTipus;
    
    vIdTreb TREBALLADORS.Id%TYPE;
    i NUMBER :=1;
    ret RETORNS;
    pRetPerParelles RETORN_PARELLES;
    
  BEGIN
    ret := PAK_EST_CONTROL.CONTROL_DATES(vDataI, vDataF);
    IF ret.IdMissatge <> 0 THEN
      RETURN ret;
    END IF;

    OPEN cTREBALLADOR(pTipusCentre);
      FETCH cTREBALLADOR INTO vIdTreb;
      pRetPerTreb  := RETORN_AMB_CENTRE_tab();
      WHILE cTREBALLADOR%found LOOP
        IF pAccio = 'MAX_MODELVENTA_V' THEN
          ret := MAX_MODELVENTA ( pRetPerParelles, vIdTreb, null, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_MARCAVENTA_V' THEN
          ret := MAX_MARCAVENTA ( pRetPerParelles, vIdTreb, null, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_MODELCOMPRA_V' THEN
          ret := MAX_MODELCOMPRA ( pRetPerParelles, vIdTreb, null, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_MARCACOMPRA_V' THEN
          ret := MAX_MARCACOMPRA ( pRetPerParelles, vIdTreb, null, pCriteri, pDataInici, pDataFi);                
        ELSIF pAccio = 'MAX_MODELREPREV_M' THEN
          ret := MAX_MODELREPREV ( pRetPerParelles, vIdTreb, null, pCriteri, pDataInici, pDataFi);
        ELSIF pAccio = 'MAX_MARCAREPREV_M' THEN
          ret := MAX_MARCAREPREV ( pRetPerParelles, vIdTreb, null, pCriteri, pDataInici, pDataFi);            
        END IF;
       
        IF ret.IdMissatge = 0 THEN
          pRetPerTreb.EXTEND;
          pRetPerTreb(i).Valor := pRetPerParelles.Valor;
          pRetPerTreb(i).Id := pRetPerParelles.Id;
          pRetPerTreb(i).IdCentre := vIdTreb;
          FETCH cTREBALLADOR INTO vIdTreb;
          i := i + 1;
        ELSE
          RETURN ret;
        END IF;                                  

      END LOOP;
    CLOSE cTREBALLADOR;
  
    RETURN RETORNS(0,null, pAccio);   

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, pAccio, null, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  END PAK_EST_CONTROL;
  /