create or replace
PACKAGE BODY PAK_EXTRES AS

  TE_FILLS exception;
  pragma exception_init( TE_FILLS, -2292 );

  FUNCTION EXTRES_I (pNom VARCHAR2, pIdTipusExtra NUMBER, pPreu NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('EXTRES_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pNom IS NULL THEN RETURN RETORNS(2, 0, 'EXTRES.Nom');/*Valor Null no possible*/
    ELSIF pPreu IS NULL THEN RETURN RETORNS(2, 0, 'EXTRES.Preu');/*Valor Null no possible*/
    END IF;
   
    IF pIdTipusExtra IS NULL THEN RETURN RETORNS(2, 0, 'EXTRES.IdTipusExtra');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM TIPUS_EXTRES
         WHERE Id = pIdTipusExtra;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3, pIdTipusExtra, 'EXTRES.IdTipusExtra');/*Valor d'Id No existeix*/
      END;
    END IF;

    INSERT INTO EXTRES (Id, Nom, IdTipusExtra, Preu)
                VALUES (SEQ_EXTRES.NEXTVAL, pNom, pIdTipusExtra, pPreu)
    RETURNING Id INTO vRes;

    RETURN RETORNS(0, vRes,null);
 
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES', vRes, SQLCODE, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION EXTRES_MODELS_I (pIdMod NUMBER, pIdExt NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('EXTRES_MODELS_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pIdMod IS NULL THEN RETURN RETORNS(2, 0, 'EXTRES_MODELS.IdModel');/*Valor Null no possible*/
    ELSIF pIdExt IS NULL THEN RETURN RETORNS(2, 0, 'EXTRES_MODELS.IdExtra');/*Valor Null no possible*/
    END IF;

    BEGIN
      SELECT Id
        INTO vAux
        FROM MODELS
       WHERE Id = pIdMod;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3, pIdMod, 'EXTRES_MODELS.IdModel');/*Valor d'Id No existeix*/
    END;

    BEGIN
      SELECT Id
        INTO vAux
        FROM EXTRES
       WHERE Id = pIdExt;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pIdExt, 'EXTRES_MODELS.IdExtra');/*Valor d'Id No existeix*/
    END;

    BEGIN
      SELECT 1
        INTO vAux
        FROM EXTRES_MODELS
       WHERE IdModel = pIdMod AND
             IdExtra = pIdExt;
      IF vAux = 1 THEN 
        RETURN RETORNS(14, 0, 'EXTRES_MODELS'); 
      END IF;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
       null;
    END;


    INSERT INTO EXTRES_MODELS VALUES (SEQ_EXTRES_MODELS.NEXTVAL, pIdMod, pIdExt)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_MODELS', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION EXTRES_CONFIGFIN_I (pIdCon NUMBER, pIdExt NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('EXTRES_CONFIGFIN_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pIdCon IS NULL THEN RETURN RETORNS(2, 0, 'EXTRES_CONFIGFIN.IdConfigFin');/*Valor Null no possible*/
    ELSIF pIdExt IS NULL THEN RETURN RETORNS(2, 0, 'EXTRES_CONFIGFIN.IdExtra');/*Valor Null no possible*/
    END IF;

    BEGIN
      SELECT Id
        INTO vAux
        FROM CONFIGFIN
       WHERE Id = pIdCon;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3, pIdCon, 'EXTRES_CONFIGFIN.IdConfigFin');/*Valor d'Id No existeix*/
    END;

    BEGIN
      SELECT Id
        INTO vAux
        FROM EXTRES
       WHERE Id = pIdExt;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pIdExt, 'EXTRES_CONFIGFIN.IdExtra');/*Valor d'Id No existeix*/
    END;

   BEGIN
     SELECT 1
       INTO vAux
      FROM CONFIGFIN A, CONFIG3 B, CONFIG2 C, CONFIG1 D, EXTRES_MODELS E
      WHERE A.Id = pIdCon AND
            A.IdConfig3 = B.Id AND
            B.IdConfig2 = C.Id AND
            C.IdConfig1 = D.Id AND
            D.IdModel = E.IdModel AND
            E.IdExtra = pIdExt;
     IF vAux = 1 THEN 
       RETURN RETORNS(16, 0, 'EXTRES_CONFIGFIN'); 
     END IF;
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
       null;
   END;

    BEGIN
      SELECT 1
        INTO vAux
        FROM EXTRES_CONFIGFIN
       WHERE IdConfigFin = pIdCon AND
             IdExtra = pIdExt;
      IF vAux = 1 THEN 
        RETURN RETORNS(14, 0, 'EXTRES_CONFIGFIN'); 
      END IF;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
       null;
    END;

    INSERT INTO EXTRES_CONFIGFIN VALUES (SEQ_EXTRES_CONFIGFIN.NEXTVAL, pIdCon, pIdExt)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_CONFIGFIN', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION EXTRES_IDIOMA_I (pIdExt NUMBER, pIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('EXTRES_IDIOMA_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pIdExt IS NULL THEN RETURN RETORNS(2, 0, 'EXTRES_IDIOMA.IdExtra');/*Valor Null no possible*/
    ELSIF pIdId IS NULL THEN RETURN RETORNS(2, 0, 'EXTRES_IDIOMA.IdIdioma');/*Valor Null no possible*/
    ELSIF pNom IS NULL THEN RETURN RETORNS(2, 0, 'EXTRES_IDIOMA.Nom');/*Valor Null no possible*/
    END IF;

    BEGIN
      SELECT Id
        INTO vAux
        FROM IDIOMES
       WHERE Id = pIdId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3, pIdId, 'EXTRES_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
    END;

    BEGIN
      SELECT Id
        INTO vAux
        FROM EXTRES
       WHERE Id = pIdExt;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pIdExt, 'EXTRES_IDIOMA.IdExtra');/*Valor d'Id No existeix*/
    END;

    INSERT INTO EXTRES_IDIOMA VALUES (SEQ_EXTRES_IDIOMA.NEXTVAL, pIdExt, pIdId, pNom, pDesc)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_IDIOMA', vRes, pNom, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;


  FUNCTION EXTRES_U (pId NUMBER, pNom VARCHAR2, pIdTipusExtra NUMBER, pPreu NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux NUMBER;
    vModif BOOLEAN := FALSE;
    vFila EXTRES%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('EXTRES_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pId IS NULL 
      THEN RETURN RETORNS(2, 0, 'EXTRES.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM EXTRES
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'EXTRES.Id'); /*Valor d'Id No existeix*/
      END;
    END IF;

    IF pNom IS NOT NULL AND pNom <> vFila.Nom THEN
      vSQL := vSQL||' Nom = ''' || pNom ||''',';
      vModif := TRUE;
    END IF;

    IF pIdTipusExtra IS NOT NULL AND pIdTipusExtra <> vFila.IdTipusExtra THEN
      BEGIN
        SELECT Id
          INTO vAux
          FROM TIPUS_EXTRES
         WHERE Id = pIdTipusExtra;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdTipusExtra, 'EXTRES.IdTipusExtra');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdTipusExtra = ' || pIdTipusExtra||',';
      vModif := TRUE;
    END IF;


   IF pPreu IS NOT NULL AND pPreu <> vFila.Preu THEN
      vSQL := vSQL||' Preu = ' || pPreu ||',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE EXTRES SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION EXTRES_MODELS_U (pId NUMBER, pIdMod NUMBER, pIdExt NUMBER, pIdUser NUMBER) RETURN RETORNS IS

  BEGIN

    IF FUNC_ACCES_PERMES ('EXTRES_MODELS_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    RETURN RETORNS (15, 0, 'EXTRES_CONFIGFIN');

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_CONFIGFIN', pId, SQLERRM, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION EXTRES_CONFIGFIN_U (pId NUMBER, pIdCon NUMBER, pIdExt NUMBER, pIdUser NUMBER) RETURN RETORNS IS

  BEGIN

    IF FUNC_ACCES_PERMES ('EXTRES_CONFIGFIN_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    RETURN RETORNS (15, 0, 'EXTRES_MODELS');

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_MODELS', pId, SQLERRM, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION EXTRES_IDIOMA_U (pId NUMBER, pIdExt NUMBER, PIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS

    vAux VARCHAR2 (100);
    vModif BOOLEAN := FALSE;
    vFila EXTRES_IDIOMA%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('EXTRES_IDIOMA_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
   IF pId IS NULL THEN 
     RETURN RETORNS(2, 0, 'EXTRES_IDIOMA.Id');/*Valor Null no possible*/
   ELSE
     BEGIN
       SELECT *
         INTO vFila
         FROM EXTRES_IDIOMA
        WHERE Id = pId;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         RETURN RETORNS(3,pId, 'EXTRES_IDIOMA.Id');/*Valor d'Id No existeix*/
     END;
   END IF;
   
    IF pIdExt IS NOT NULL AND pIdExt <> vFila.IdExtra THEN
      BEGIN
        SELECT Id
          INTO vAux
          FROM EXTRES
         WHERE Id = pIdExt;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdExt, 'EXTRES_IDIOMA.IdExtra');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdExtra = ' || pIdExt||',';
      vModif := TRUE;
    END IF;
  
    IF pDesc IS NOT NULL AND pDesc <> vFila.Descripcio THEN
      vSQL := vSQL||' Descripcio = ''' || pDesc ||''',';
      vModif := TRUE;
    END IF;

    IF pIdId IS NOT NULL AND pIdId <> vFila.IdIdioma THEN  
      BEGIN
        SELECT Id
          INTO vAux
          FROM IDIOMES
         WHERE Id = pIdId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdId, 'EXTRES_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdIdioma = ' || pIdId||',';
      vModif := TRUE;
    END IF;  
  
    IF pNom <> vFila.Nom THEN
      vSQL := vSQL||' Nom = ''' || pNom||''',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE EXTRES_IDIOMA SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_IDIOMA', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION EXTRES_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 
 
    IF FUNC_ACCES_PERMES ('EXTRES_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
     
    BEGIN
      SELECT Id
        INTO vAux
        FROM EXTRES
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, 'EXTRES.Id');/*Valor d'Id No existeix*/
    END;
    
    DELETE EXTRES WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
    WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'EXTRES.Id');/*Error general revisar LOG*/
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES', pId, null, 'D', 0);
      RETURN RETORNS(1,pId, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION EXTRES_MODELS_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('EXTRES_MODELS_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
      
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'EXTRES_MODELS.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM EXTRES_MODELS
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE EXTRES_MODELS WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_MODELS', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'EXTRES_MODELS.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_CONFIGFIN', pId, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
    FUNCTION EXTRES_CONFIGFIN_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('EXTRES_CONFIGFIN_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
      
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'EXTRES_CONFIGFIN.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM EXTRES_CONFIGFIN
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE EXTRES_CONFIGFIN WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_CONFIGFIN', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'EXTRES_CONFIGFIN.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_CONFIGFIN', pId, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION EXTRES_IDIOMA_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('EXTRES_IDIOMA_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
      
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'EXTRES_IDIOMA.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM EXTRES_IDIOMA
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE EXTRES_IDIOMA WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_IDIOMA', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'EXTRES_IDIOMA.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'EXTRES_IDIOMA', pId, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

END PAK_EXTRES;
/