create or replace
PACKAGE BODY PAK_Idiomes IS
   FUNCTION IDIOMA_I (pNom VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    res NUMBER;
  BEGIN
  
    IF FUNC_ACCES_PERMES ('IDIOMA_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    INSERT INTO IDIOMES VALUES (SEQ_IDIOMES.NEXTVAL, pNom) 
    RETURNING Id INTO res;
    
  RETURN RETORNS(0, res, null);
  EXCEPTION
   WHEN OTHERS THEN
   PROC_INSERT_LOGERROR(SQLCODE, 'IDIOMES', res, null /*pDescripcio*/, 'I');
   RETURN RETORNS(1,0, SQLCODE);
  END;
  
  FUNCTION IDIOMA_U (pId NUMBER, pNom VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    res NUMBER;
  BEGIN
  
    IF FUNC_ACCES_PERMES ('IDIOMA_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    UPDATE IDIOMES SET Nom = pNom WHERE Id = pId 
    RETURNING Id INTO res;
  RETURN RETORNS(0, res, null);
  EXCEPTION
   WHEN OTHERS THEN
   PROC_INSERT_LOGERROR(SQLCODE, 'IDIOMES', pId, null /*pDescripcio*/, 'U');
   RETURN RETORNS(1,0, SQLCODE);
  END;
  
  FUNCTION IDIOMA_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
      res NUMBER;
  BEGIN
  
    IF FUNC_ACCES_PERMES ('IDIOMA_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
  
    DELETE IDIOMES WHERE Id = pId;
  RETURN RETORNS(0, res, null);
  EXCEPTION
   WHEN OTHERS THEN
   PROC_INSERT_LOGERROR(SQLCODE, 'IDIOMES', pId, null /*pDescripcio*/, 'D');
   RETURN RETORNS(1,0, SQLCODE);
  END;

END PAK_Idiomes;
/