create or replace
PACKAGE BODY PAK_MARQUES AS
  
  TE_FILLS exception;
  pragma exception_init( TE_FILLS, -2292 );

  FUNCTION MARQUES_I (pNom VARCHAR2, pPais VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('MARQUES_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pNom IS NULL THEN RETURN RETORNS(2, 0, 'MARQUES.Nom');/*Valor Null no possible*/
    ELSIF pPais IS NULL THEN RETURN RETORNS(2, 0, 'MARQUES.Pais');/*Valor Null no possible*/
    END IF;

    INSERT INTO MARQUES VALUES (SEQ_MARQUES.NEXTVAL, pNom, pPais)
    RETURNING Id INTO vRes;

    RETURN RETORNS(0, vRes,null);
 
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MARQUES', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MARQUES_U (pId NUMBER, pNom VARCHAR2, pPais VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
    vModif BOOLEAN := FALSE;
    vFila MARQUES%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('MARQUES_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pId IS NULL THEN 
      RETURN RETORNS(2, 0, 'MARQUES.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
       SELECT *
         INTO vFila
         FROM MARQUES
        WHERE Id = pId;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         RETURN RETORNS(3,pId, 'MARQUES.Id');/*Valor d'Id No existeix*/
     END;
   END IF;
 
    IF pPais IS NOT NULL AND pPais <> vFila.Pais THEN
      vSQL := vSQL||' Pais = ''' || pPais ||''',';
      vModif := TRUE;
    END IF;
  
    IF pNom <> vFila.Nom THEN
      vSQL := vSQL||' Nom = ''' || pNom||''',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE MARQUES SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MARQUES', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
 
  FUNCTION MARQUES_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('MARQUES_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    BEGIN
      SELECT Id
        INTO vAux
        FROM MARQUES
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, 'MARQUES.Id');/*Valor d'Id No existeix*/
    END;
    
    DELETE MARQUES WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
    WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MARQUES', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'MARQUES.Id');/*Error general revisar LOG*/
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MARQUES', pId, null, 'D', 0);
      RETURN RETORNS(1,pId, SQLCODE);/*Error general revisar LOG*/
  END;
  
 
END PAK_MARQUES;
/