create or replace
PACKAGE BODY PAK_Missatges IS
   FUNCTION MISSATGE_I (pId NUMBER, pText VARCHAR2, pIdIdioma NUMBER DEFAULT 1, pIdUser NUMBER) RETURN RETORNS IS
    res NUMBER;
  BEGIN

    IF FUNC_ACCES_PERMES ('MISSATGE_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    INSERT INTO MISSATGES VALUES (pId, pIdIdioma, pText) 
    RETURNING Id INTO res;
    
  RETURN RETORNS(0, res, null);
  EXCEPTION
   WHEN OTHERS THEN
   PROC_INSERT_LOGERROR(SQLCODE, 'MISSATGES', res, SQLERRM, 'I');
   RETURN RETORNS(1,0, SQLCODE);
  END;
  
  FUNCTION MISSATGE_U (pId NUMBER, pText VARCHAR2, pIdIdioma NUMBER DEFAULT 1, pIdUser NUMBER) RETURN RETORNS IS
    res NUMBER;
    vIdIdioma Missatges.IdIdioma%Type;
    vText Missatges.Text%TYPE;
    vSQL VARCHAR2 (500);
  BEGIN
 
    IF FUNC_ACCES_PERMES ('MISSATGE_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
   
  SELECT Text, IdIdioma 
  INTO vText, vIdIdioma
  FROM missatges 
  WHERE id = pId;
  
  vSQL := 'UPDATE MISSATGES SET';
  
  IF vText <> pText THEN
    vSQL := vSQL || ' Text = ' || pText || ' and';
  END IF;
  IF pIdIdioma <> vIdIdioma THEN
    vSQL := vSQL || 'IdIdioma = ' || PIdIdioma|| ' and';
  END IF;
  
  vSQL := SUBSTR (vSQL, 1, LENGTH(vSQL)-3);
  vSQL := vSQL ||' WHERE Id = pId RETURNING Id';
    EXECUTE IMMEDIATE  (vSQL) INTO res;
  RETURN RETORNS(0, res, null);
  EXCEPTION
   WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MISSATGES', pId, vSQL, 'U');
   RETURN RETORNS(1,0, SQLCODE);
  END;
  
  FUNCTION MISSATGE_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
      res NUMBER;
  BEGIN
  
    IF FUNC_ACCES_PERMES ('MISSATGE_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    DELETE MISSATGES WHERE Id = pId;
  RETURN RETORNS(0, res, null);
  EXCEPTION
   WHEN OTHERS THEN
   PROC_INSERT_LOGERROR(SQLCODE, 'MISSATGES', pId, SQLERRM, 'D');
   RETURN RETORNS(1,0, SQLCODE);
  END;

END PAK_Missatges;
/