create or replace
PACKAGE BODY PAK_MODELS AS
  
  TE_FILLS exception;
  pragma exception_init( TE_FILLS, -2292 );

  FUNCTION MODELS_I (pIdMarca NUMBER, pNom VARCHAR2, pAny NUMBER DEFAULT null, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('MODELS_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pNom IS NULL THEN RETURN RETORNS(2, 0, 'MODELS.Nom');/*Valor Null no possible*/
    ELSIF pAny IS NOT NULL AND (pAny > 2100 OR pAny < 1900) 
               THEN RETURN RETORNS(8, 0, 'MODELS.Nom');/*Any Incorrecte*/
    END IF;

    IF pIdMarca IS NULL THEN 
      RETURN RETORNS(2, 0, 'MODELS.IdMarca');/*Valor Null no possible*/
    ELSE 
      BEGIN
        SELECT Id
          INTO vAux
          FROM MARQUES
         WHERE Id = pIdMarca;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3, pIdMarca, 'MODELS.IdMarca');/*Valor d'Id No existeix*/
      END;
    END IF;

    INSERT INTO MODELS VALUES (SEQ_MODELS.NEXTVAL, pIdMarca, pNom, pAny)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS', vRes, pNom, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MODELS_IMATGES_I (pIdMod NUMBER, pImatgeG VARCHAR2, pImatgeP VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('MODELS_IMATGES_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pImatgeG IS NULL THEN 
      RETURN RETORNS(2, 0, 'MODELS_IMATGES.ImatgeG');/*Valor Null no possible*/
    END IF;

   IF pIdMod IS NULL THEN
     RETURN RETORNS(2, 0, 'MODELS_IMATGES.IdModel');/*Valor Null no possible*/
   ELSE
     BEGIN
       SELECT Id
         INTO vAux
         FROM MODELS
        WHERE Id = pIdMod;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         RETURN RETORNS(3, pIdMod, 'MODELS_IMATGES.IdModel');/*Valor d'Id No existeix*/
     END;
   END IF;
     
    INSERT INTO MODELS_IMATGES VALUES (SEQ_MODELS_IMATGES.NEXTVAL, pIdMod, pImatgeG, pImatgeP)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS_IMATGES', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MODELS_IMATGES_IDIOMA_I (pIdModIma NUMBER, pIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('MODELS_IMATGES_IDIOMA_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pNom IS NULL THEN 
      RETURN RETORNS(2, 0, 'MODELS_IMATGES_IDIOMA.Nom');/*Valor Null no possible*/
    END IF;

    IF pIdModIma IS NULL THEN
      RETURN RETORNS(2, 0, 'MODELS_IMATGES_IDIOMA.IdModelImatge');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM MODELS_IMATGES
         WHERE Id = pIdModIma;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3, pIdModIma, 'MODELS_IMATGES_IDIOMA.IdModelImatge');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF pIdId IS NULL THEN 
      RETURN RETORNS(2, 0, 'MODELS_IMATGES_IDIOMA.IdIdioma');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM IDIOMES
         WHERE Id = pIdId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdId, 'MODELS_IMATGES_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
      END;
    END IF;

    INSERT INTO MODELS_IMATGES_IDIOMA VALUES (SEQ_MODELS_IMATGES_IDIOMA.NEXTVAL, pIdModIma, pIdId, pNom, pDesc)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS_IMATGES_IDIOMA', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MODELS_U (pId NUMBER, pIdMarca NUMBER, pNom VARCHAR2, pAny NUMBER, pIdUser NUMBER) RETURN RETORNS IS

    vAux VARCHAR2 (100);
    vModif BOOLEAN := FALSE;
    vFila MODELS%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('MODELS_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
   IF pId IS NULL THEN 
     RETURN RETORNS(2, 0, 'MODELS.Id');/*Valor Null no possible*/
   ELSE
     BEGIN
       SELECT *
         INTO vFila
         FROM MODELS
        WHERE Id = pId;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         RETURN RETORNS(3,pId, 'MODELS.Id');/*Valor d'Id No existeix*/
     END;
   END IF;
   
    IF pIdMarca IS NOT NULL AND pIdMarca <> vFila.IdMarca THEN
      BEGIN
        SELECT Id
          INTO vAux
          FROM MARQUES
         WHERE Id = pIdMarca;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdMarca, 'MODELS.IdMarca');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdMarca = ' || pIdMarca||',';
      vModif := TRUE;
    END IF;

    IF pAny IS NOT NULL AND pAny <> vFila.AnyModel THEN
        IF (pAny > 2100 OR pAny < 1900) 
           THEN RETURN RETORNS(8, 0, 'MODELS.Nom');/*Any Incorrecte*/
        END IF;
      vSQL := vSQL||' AnyModel = ' || pAny ||',';
      vModif := TRUE;
    END IF;
  
    IF pNom <> vFila.Nom THEN
      vSQL := vSQL||' Nom = ''' || pNom||''',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE MODELS SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MODELS_IMATGES_U (pId NUMBER, pIdMod NUMBER, pImatgeG VARCHAR2, pImatgeP VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS

    vAux VARCHAR2 (100);
    vModif BOOLEAN := FALSE;
    vFila MODELS_IMATGES%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('MODELS_IMATGES_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pId IS NULL THEN 
      RETURN RETORNS(2, 0, 'MODELS_IMATGES.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM MODELS_IMATGES
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'MODELS_IMATGES.Id');/*Valor d'Id No existeix*/
      END;
    END IF;
   
    IF pIdMod IS NOT NULL AND pIdMod <> vFila.IdModel THEN
      BEGIN
        SELECT Id
          INTO vAux
          FROM MODELS
         WHERE Id = pIdMod;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdMod, 'MODELS_IMATGES.IdModel');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdModel = ' || pIdMod||',';
      vModif := TRUE;
    END IF;
  
    IF pImatgeG <> vFila.ImatgeG THEN
      vSQL := vSQL||' ImatgeG = ''' || pImatgeG||''',';
      vModif := TRUE;
    END IF;

    IF pImatgeP <> vFila.ImatgeP THEN
      vSQL := vSQL||' ImatgeP = ''' || pImatgeP||''',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE MODELS_IMATGES SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS_IMATGES', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MODELS_IMATGES_IDIOMA_U (pId NUMBER, pIdModIma NUMBER, PIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS

    vAux VARCHAR2 (100);
    vModif BOOLEAN := FALSE;
    vFila MODELS_IMATGES_IDIOMA%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('MODELS_IMATGES_IDIOMA_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
   IF pId IS NULL THEN 
     RETURN RETORNS(2, 0, 'MODELS_IMATGES_IDIOMA.Id');/*Valor Null no possible*/
   ELSE
     BEGIN
       SELECT *
         INTO vFila
         FROM MODELS_IMATGES_IDIOMA
        WHERE Id = pId;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         RETURN RETORNS(3,pId, 'MODELS_IMATGES_IDIOMA.Id');/*Valor d'Id No existeix*/
     END;
   END IF;
   
    IF pIdModIma IS NOT NULL AND pIdModIma <> vFila.IdModelImatge THEN
      BEGIN
        SELECT Id
          INTO vAux
          FROM MODELS_IMATGES
         WHERE Id = pIdModIma;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdModIma, 'MODELS_IMATGES_IDIOMA.IdModelImatge');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdModelImatge = ' || pIdModIma||',';
      vModif := TRUE;
    END IF;
  
    IF pDesc IS NOT NULL AND pDesc <> vFila.Descripcio THEN
      vSQL := vSQL||' Descripcio = ''' || pDesc ||''',';
      vModif := TRUE;
    END IF;

    IF pIdId IS NOT NULL AND pIdId <> vFila.IdIdioma THEN  
      BEGIN
        SELECT Id
          INTO vAux
          FROM IDIOMES
         WHERE Id = pIdId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdId, 'MODELS_IMATGES_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdIdioma = ' || pIdId||',';
      vModif := TRUE;
    END IF;  
  
    IF pNom <> vFila.Nom THEN
      vSQL := vSQL||' Nom = ''' || pNom||''',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE MODELS_IMATGES_IDIOMA SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS_IMATGES_IDIOMA', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MODELS_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 
  
    IF FUNC_ACCES_PERMES ('MODELS_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'MODELS.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM MODELS
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE MODELS WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'MODELS.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS', pId, SQLERRM, 'D', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION MODELS_IMATGES_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('MODELS_IMATGES_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'MODELS_IMATGES.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM MODELS_IMATGES
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE MODELS_IMATGES WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS_IMATGES', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'MODELS_IMATGES.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS_IMATGES', pId, SQLERRM, 'D', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION MODELS_IMATGES_IDIOMA_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('MODELS_IMATGES_IDIOMA_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'MODELS_IMATGES_IDIOMA.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM MODELS_IMATGES_IDIOMA
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE MODELS_IMATGES_IDIOMA WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS_IMATGES_IDIOMA', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'MODELS_IMATGES_IDIOMA.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'MODELS_IMATGES_IDIOMA', pId, SQLERRM, 'D', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
END PAK_MODELS;
/