create or replace
PACKAGE BODY PAK_PERMISOS AS

  FUNCTION PERMISOS_I (pAccio VARCHAR2, pNivell NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('PERMISOS_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pAccio IS NULL THEN RETURN RETORNS(2, 0, 'PERMISOS.Accio');/*Valor Null no possible*/
    ELSIF pNivell IS NULL THEN RETURN RETORNS(2, 0, 'PERMISOS.Nivell');/*Valor Null no possible*/
    END IF;

    INSERT INTO PERMISOS VALUES (SEQ_PERMISOS.NEXTVAL, pAccio, pNivell)
    RETURNING Id INTO vRes;

    RETURN RETORNS(0, vRes,null);
 
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'PERMISOS', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION PERMISOS_U (pId NUMBER, pAccio VARCHAR2, pNivell NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
    vModif BOOLEAN := FALSE;
    vFila PERMISOS%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('PERMISOS_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pId IS NULL THEN 
      RETURN RETORNS(2, 0, 'PERMISOS.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
       SELECT *
         INTO vFila
         FROM PERMISOS
        WHERE Id = pId;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         RETURN RETORNS(3,pId, 'PERMISOS.Id');/*Valor d'Id No existeix*/
     END;
   END IF;
 
    IF pNivell IS NOT NULL AND pNivell <> vFila.Nivell THEN
      vSQL := vSQL||' Nivell = ' || pNivell ||',';
      vModif := TRUE;
    END IF;
  
    IF pAccio IS NOT NULL AND pAccio <> vFila.Accio THEN
      vSQL := vSQL||' Accio = ''' || pAccio||''',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE PERMISOS SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;

      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE ('ERror');
      PROC_INSERT_LOGERROR(SQLCODE, 'PERMISOS', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
 
  FUNCTION PERMISOS_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('PERMISOS_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    BEGIN
      SELECT Id
        INTO vAux
        FROM PERMISOS
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, 'PERMISOS.Id');/*Valor d'Id No existeix*/
    END;
    
    DELETE PERMISOS WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'PERMISOS', pId, null, 'D', 0);
      RETURN RETORNS(1,pId, SQLCODE);/*Error general revisar LOG*/
  END;
  
 
END PAK_PERMISOS;
/