create or replace
PACKAGE BODY PAK_POTENCIES AS
  
  TE_FILLS exception;
  pragma exception_init( TE_FILLS, -2292 );

  FUNCTION POTENCIES_I (pNom VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('POTENCIES_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pNom IS NULL THEN RETURN RETORNS(2, 0, 'POTENCIES.Nom');/*Valor Null no possible*/
    END IF;

    INSERT INTO POTENCIES VALUES (SEQ_POTENCIES.NEXTVAL, pNom)
    RETURNING Id INTO vRes;

    RETURN RETORNS(0, vRes,null);
 
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'POTENCIES', vRes, pNom, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION POTENCIES_IDIOMA_I (pIdPot NUMBER, pIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('POTENCIES_IDIOMA_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pIdPot IS NULL THEN RETURN RETORNS(2, 0, 'POTENCIES_IDIOMA.IdPotencia');/*Valor Null no possible*/
    ELSIF pIdId IS NULL THEN RETURN RETORNS(2, 0, 'POTENCIES_IDIOMA.IdIdioma');/*Valor Null no possible*/
    ELSIF pNom IS NULL THEN RETURN RETORNS(2, 0, 'POTENCIES_IDIOMA.Nom');/*Valor Null no possible*/
    END IF;

    BEGIN
      SELECT Id
        INTO vAux
        FROM IDIOMES
       WHERE Id = pIdId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3, pIdId, 'POTENCIES_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
    END;

    BEGIN
      SELECT Id
        INTO vAux
        FROM POTENCIES
       WHERE Id = pIdPot;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pIdPot, 'POTENCIES_IDIOMA.IdPotencia');/*Valor d'Id No existeix*/
    END;

    INSERT INTO POTENCIES_IDIOMA VALUES (SEQ_POTENCIES_IDIOMA.NEXTVAL, pIdPot, pIdId, pNom, pDesc)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'POTENCIES_IDIOMA', vRes, pNom, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION POTENCIES_U (pId NUMBER, pNom VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('POTENCIES_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pId IS NULL THEN RETURN RETORNS(2, 0, 'POTENCIES.Id');/*Valor Null no possible*/
    ELSIF pNom IS NULL THEN RETURN RETORNS(2, 0, 'POTENCIES.Nom');/*Valor Null no possible*/
    END IF;

    BEGIN
      SELECT Nom
        INTO vAux
        FROM POTENCIES
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, 'POTENCIES.Id'); /*Valor d'Id No existeix*/
    END;

    IF vAux <> pNom THEN
      UPDATE POTENCIES SET Nom = pNom WHERE Id = pId;
      IF sql%ROWCOUNT >=1 THEN 
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'POTENCIES', pId, pNom, 'U', 0);
      RETURN RETORNS(1,pId, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION POTENCIES_IDIOMA_U (pId NUMBER, pIdPot NUMBER, PIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS

    vAux VARCHAR2 (100);
    vModif BOOLEAN := FALSE;
    vFila POTENCIES_IDIOMA%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('POTENCIES_IDIOMA_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
   IF pId IS NULL THEN 
     RETURN RETORNS(2, 0, 'POTENCIES_IDIOMA.Id');/*Valor Null no possible*/
   ELSE
     BEGIN
       SELECT *
         INTO vFila
         FROM POTENCIES_IDIOMA
        WHERE Id = pId;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         RETURN RETORNS(3,pId, 'POTENCIES_IDIOMA.Id');/*Valor d'Id No existeix*/
     END;
   END IF;
   
    IF pIdPot IS NOT NULL AND pIdPot <> vFila.IdPotencia THEN
      BEGIN
        SELECT Id
          INTO vAux
          FROM POTENCIES
         WHERE Id = pIdPot;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdPot, 'POTENCIES_IDIOMA.IdPotencia');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdPotencia = ' || pIdPot||',';
      vModif := TRUE;
    END IF;
  
    IF pDesc IS NOT NULL AND pDesc <> vFila.Descripcio THEN
      vSQL := vSQL||' Descripcio = ''' || pDesc ||''',';
      vModif := TRUE;
    END IF;

    IF pIdId IS NOT NULL AND pIdId <> vFila.IdIdioma THEN  
      BEGIN
        SELECT Id
          INTO vAux
          FROM IDIOMES
         WHERE Id = pIdId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdId, 'POTENCIES_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdIdioma = ' || pIdId||',';
      vModif := TRUE;
    END IF;  
  
    IF pNom <> vFila.Nom THEN
      vSQL := vSQL||' Nom = ''' || pNom||''',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE POTENCIES_IDIOMA SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'POTENCIES', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION POTENCIES_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 
 
    IF FUNC_ACCES_PERMES ('POTENCIES_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
   
    BEGIN
      SELECT Id
        INTO vAux
        FROM POTENCIES
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, 'POTENCIES.Id');/*Valor d'Id No existeix*/
    END;
    
    DELETE POTENCIES WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
    WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'POTENCIES', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'POTENCIES.Id');/*Error general revisar LOG*/
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'POTENCIES', pId, null, 'D', 0);
      RETURN RETORNS(1,pId, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION POTENCIES_IDIOMA_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('POTENCIES_IDIOMA_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'POTENCIES_IDIOMA.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM POTENCIES_IDIOMA
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE POTENCIES_IDIOMA WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'POTENCIES_IDIOMA', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'POTENCIES_IDIOMA.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'POTENCIES_IDIOMA', pId, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

END PAK_POTENCIES;
/