create or replace
PACKAGE BODY PAK_REPREV AS

  TE_FILLS exception;
  pragma exception_init( TE_FILLS, -2292 );

  FUNCTION REPREV_ACCIONS_I (pNom VARCHAR2, pPreu NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('REPREV_ACCIONS_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pNom IS NULL THEN RETURN RETORNS(2, 0, 'REPREV_ACCIONS.Nom');/*Valor Null no possible*/
    ELSIF pPreu IS NULL THEN RETURN RETORNS(2, 0, 'REPREV_ACCIONS.Cambi');/*Valor Null no possible*/
    END IF;

    INSERT INTO REPREV_ACCIONS (Id, Nom, Preu)
                VALUES (SEQ_REPREV_ACCIONS.NEXTVAL, pNom, pPreu)
    RETURNING Id INTO vRes;

    RETURN RETORNS(0, vRes,null);
 
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV_ACCIONS', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION REPREV_ACCIONS_IDIOMA_I (pIdRep NUMBER, pIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('REPREV_ACCIONS_IDIOMA_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pIdRep IS NULL THEN RETURN RETORNS(2, 0, 'REPREV_ACCIONS_IDIOMA.IdVersio');/*Valor Null no possible*/
    ELSIF pIdId IS NULL THEN RETURN RETORNS(2, 0, 'REPREV_ACCIONS_IDIOMA.IdIdioma');/*Valor Null no possible*/
    ELSIF pNom IS NULL THEN RETURN RETORNS(2, 0, 'REPREV_ACCIONS_IDIOMA.Nom');/*Valor Null no possible*/
    END IF;

    BEGIN
      SELECT Id
        INTO vAux
        FROM IDIOMES
       WHERE Id = pIdId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3, pIdId, 'REPREV_ACCIONS_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
    END;

    BEGIN
      SELECT Id
        INTO vAux
        FROM REPREV_ACCIONS
       WHERE Id = pIdRep;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pIdRep, 'REPREV_ACCIONS_IDIOMA.IdRepRevAccio');/*Valor d'Id No existeix*/
    END;

    INSERT INTO REPREV_ACCIONS_IDIOMA VALUES (SEQ_REPREV_ACCIONS_IDIOMA.NEXTVAL, pIdRep, pIdId, pNom, pDesc)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV_ACCIONS_IDIOMA', vRes, pNom, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION REPREV_ACCIONS_U (pId NUMBER, pNom VARCHAR2, pPreu NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vModif BOOLEAN := FALSE;
    vFila REPREV_ACCIONS%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('REPREV_ACCIONS_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
   
    IF pId IS NULL 
      THEN RETURN RETORNS(2, 0, 'VERSIO.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM REPREV_ACCIONS
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'VERSIO.Id'); /*Valor d'Id No existeix*/
      END;
    END IF;

    IF pNom IS NOT NULL AND pNom <> vFila.Nom THEN
      vSQL := vSQL||' Nom = ''' || pNom ||''',';
      vModif := TRUE;
    END IF;

   IF pPreu IS NOT NULL AND pPreu <> vFila.Preu THEN
      vSQL := vSQL||' Preu = ' || pPreu ||',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE REPREV_ACCIONS SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV_ACCIONS', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION REPREV_ACCIONS_IDIOMA_U (pId NUMBER, pIdRep NUMBER, PIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS

    vAux VARCHAR2 (100);
    vModif BOOLEAN := FALSE;
    vFila REPREV_ACCIONS_IDIOMA%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('REPREV_ACCIONS_IDIOMA_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
   IF pId IS NULL THEN 
     RETURN RETORNS(2, 0, 'REPREV_ACCIONS_IDIOMA.Id');/*Valor Null no possible*/
   ELSE
     BEGIN
       SELECT *
         INTO vFila
         FROM VERSIO_IDIOMA
        WHERE Id = pId;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         RETURN RETORNS(3,pId, 'REPREV_ACCIONS_IDIOMA.Id');/*Valor d'Id No existeix*/
     END;
   END IF;
   
    IF pIdRep IS NOT NULL AND pIdRep <> vFila.IdRepRevAccio THEN
      BEGIN
        SELECT Id
          INTO vAux
          FROM VERSIO
         WHERE Id = pIdRep;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdRep, 'REPREV_ACCIONS_IDIOMA.IdRepRevAccio');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdRepRevAccio = ' || pIdRep||',';
      vModif := TRUE;
    END IF;
  
    IF pDesc IS NOT NULL AND pDesc <> vFila.Descripcio THEN
      vSQL := vSQL||' Descripcio = ''' || pDesc ||''',';
      vModif := TRUE;
    END IF;

    IF pIdId IS NOT NULL AND pIdId <> vFila.IdIdioma THEN  
      BEGIN
        SELECT Id
          INTO vAux
          FROM IDIOMES
         WHERE Id = pIdId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdId, 'REPREV_ACCIONS_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdIdioma = ' || pIdId||',';
      vModif := TRUE;
    END IF;  
  
    IF pNom <> vFila.Nom THEN
      vSQL := vSQL||' Nom = ''' || pNom||''',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE REPREV_ACCIONS_IDIOMA SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV_ACCIONS_IDIOMA', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION  REPREV_ACCIONS_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 
 
    IF FUNC_ACCES_PERMES ('REPREV_ACCIONS_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
     
    BEGIN
      SELECT Id
        INTO vAux
        FROM VERSIO
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, 'REPREV_ACCIONS.Id');/*Valor d'Id No existeix*/
    END;
    
    DELETE REPREV_ACCIONS WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
    WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV_ACCIONS', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'REPREV_ACCIONS.Id');/*Error general revisar LOG*/
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV_ACCIONS', pId, null, 'D', 0);
      RETURN RETORNS(1,pId, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION REPREV_ACCIONS_IDIOMA_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('REPREV_ACCIONS_IDIOMA_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
      
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'REPREV_ACCIONS_IDIOMA.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM REPREV_ACCIONS_IDIOMA
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE REPREV_ACCIONS_IDIOMA WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV_ACCIONS_IDIOMA', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'REPREV_ACCIONS_IDIOMA.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV_ACCIONS_IDIOMA', pId, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION REPREV_I (pIdVehicle NUMBER, pIdCentre NUMBER, pIdClient NUMBER, pIncidencia VARCHAR2, pIdAccioSol NUMBER, 
                     pIdMecanicEnt NUMBER, pComentariClient VARCHAR2, pComentariMecanic VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('REPREV_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pIdVehicle IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.IdVehicle'); /*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM VEHICLES
         WHERE Id = pIdVehicle;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdVehicle, 'REPREV.IdVehicle');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF pIdCentre IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.IdCentre'); /*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM CENTRES
         WHERE Id = pIdCentre;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdCentre, 'REPREV.IdCentre');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF pIdClient IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.IdClient'); /*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM CLIENTS
         WHERE Id = pIdClient;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdClient, 'REPREV.IdClient');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF pIncidencia IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.Incidencia');/*Valor Null no possible*/ 
    ELSIF pIncidencia NOT IN ('REP', 'REV') THEN 
      RETURN RETORNS(19, 0, 'REPREV.Incidencia');/*Error Tipus Document*/     
    END IF;

    IF pIdAccioSol IS NOT NULL THEN 
      BEGIN
        SELECT Id
          INTO vAux
          FROM REPREV_ACCIONS
         WHERE Id = pIdAccioSol;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdAccioSol, 'REPREV.IdAccioSol');/*Valor d'Id No existeix*/
      END;
    END IF;
    
   IF pIdMecanicEnt IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.IdMecanicEnt'); /*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM TREBALLADORS
         WHERE Id = pIdMecanicEnt;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdMecanicEnt, 'REPREV.IdMecanicEnt');/*Valor d'Id No existeix*/
      END;
    END IF;
/*Comprobar que el mecanico no es vendedor*/
/*Comprobar que el trabajador es del centro*/
/*Comprovar que en vehiculo el IdCliente coincide*/
    INSERT INTO REPREV (Id, IdVehicle, IdCentre, IdClient, Incidencia, IdAccioSol,
                       IdMecanicEnt, ComentariClient, ComentariMecanic)
                VALUES (SEQ_REPREV.NEXTVAL, pIdVehicle, pIdCentre, pIdClient, pIncidencia, pIdAccioSol, 
                        pIdMecanicEnt, pComentariClient, pComentariMecanic)
    RETURNING Id INTO vRes;

    RETURN RETORNS(0, vRes,null);
  
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV', vRes, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION ASSIGNAR_MECANIC(pId NUMBER, pIdTreballador NUMBER, pIdUser NUMBER) RETURN RETORNS IS 
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('ASSIGNAR_MECANIC', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
      
    IF pId IS NULL 
      THEN RETURN RETORNS(2, 0, 'REPREV.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM REPREV
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'REPREV.Id'); /*Valor d'Id No existeix*/
      END;
    END IF;
/* No es consulta si ja esta assignat per que es dona per entes que no es la tasca d'aquesta funci,
  aquesta acci es per una funci de consulta i si arriba fins aqui es que vol assignar un nou mecanic.*/
  
  IF pIdTreballador IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.IdMecanic'); /*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM TREBALLADORS
         WHERE Id = pIdTreballador;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdTreballador, 'REPREV.IdMecanic');/*Valor d'Id No existeix*/
      END;
    END IF;

     UPDATE REPREV SET IdMecanic = pIdTreballador, DataInici = SYSDATE WHERE Id = pId;

     IF sql%ROWCOUNT >=1 THEN
       RETURN RETORNS(0, pId, null);
     ELSE
       RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
     END IF;

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'ASSIGNAR_MECANIC', pId, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION REPREV_LINIES_I (pIdRepRev NUMBER, pIdAccio NUMBER, pPreu NUMBER, pQuantitat NUMBER, pComentari VARCHAR2, pIdUser NUMBER)  RETURN RETORNS IS
    vRes NUMBER;
    vFila REPREV%ROWTYPE;
    vAux VARCHAR2 (100);
  BEGIN 
    
    IF FUNC_ACCES_PERMES ('REPREV_LINIES_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 

    IF pPreu IS NULL THEN RETURN RETORNS(2, 0, 'REPREV_LINIES.Preu');/*Valor Null no possible*/
    ELSIF pQuantitat IS NULL THEN RETURN RETORNS(2, 0, 'REPREV_LINIES.Quantitat');/*Valor Null no possible*/
    END IF;

    IF pIdRepRev IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV_LINIES.IdRepRev');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM REPREV
         WHERE Id = pIdRepRev;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdRepRev, 'REPREV_LINIES.IdRepRev');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF vFila.IdMecanic IS NULL THEN
      RETURN RETORNS (20,0,'REPREV.IdMecanic');
    END IF; 
    
    IF vFila.DataFi IS NOT NULL THEN
      RETURN RETORNS (21,0,'REPREV.DataFi:'||vFila.DataFi);
    END IF; 
    
    IF pIdAccio IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV_LINIES.IdAccio');/*Valor Null no possible*/
    ELSE     
      BEGIN
        SELECT Id
          INTO vAux
          FROM REPREV_ACCIONS
         WHERE Id = pIdAccio;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdAccio, 'REPREV_LINIES.IdAccio');/*Valor d'Id No existeix*/
      END;
    END IF;

    INSERT INTO REPREV_LINIES (Id, IdRepRev, IdAccio, Preu, Quantitat, Comentari)
                VALUES (SEQ_REPREV_LINIES.NEXTVAL, pIdRepRev, pIdAccio, pPreu, pQuantitat, pComentari)
    RETURNING Id INTO vRes;

    RETURN RETORNS(0, vRes,null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV_LINIES_I', vRes, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION TANCAR_REPREV (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vFila REPREV%ROWTYPE;
    vAux VARCHAR2 (100);
      
  BEGIN     
 
    IF FUNC_ACCES_PERMES ('TANCAR_REPREV', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
   
    IF pId IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM REPREV
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'REPREV.Id');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF vFila.DataFi IS NOT NULL THEN
      RETURN RETORNS (22,0,'REPREV.DataFi:'||vFila.DataFi);
    END IF;
    
    BEGIN  
      SELECT SUM(Preu*Quantitat)
        INTO vRes
        FROM REPREV_LINIES
        WHERE IdRepRev = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, 'REPREV.Id');/*Valor d'Id No existeix*/
    END; 
      
    UPDATE REPREV SET DataFi = SYSDATE, Preu = vRes WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
    END IF;

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'TANCAR_REPREV', vRes, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;


FUNCTION ENTREGAR_VEHICLE (pId NUMBER, pIdMecanicSor NUMBER, pIdUser NUMBER) RETURN RETORNS IS
  vFila REPREV%ROWTYPE;
  vAux VARCHAR2 (100);
  BEGIN     
 
    IF FUNC_ACCES_PERMES ('ENTREGAR_VEHICLE', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
        IF pId IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM REPREV
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'REPREV.Id');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF vFila.DataSortida IS NOT NULL THEN
      RETURN RETORNS(23, pId, 'REPREV.Id'); 
    END IF;
    
    IF pIdMecanicSor IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.IdMecanic'); /*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT Id
          INTO vAux
          FROM TREBALLADORS
         WHERE Id = pIdMecanicSor;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdMecanicSor, 'REPREV.IdMecanicSor');/*Valor d'Id No existeix*/
      END;
    END IF;

    UPDATE REPREV SET DataSortida = SYSDATE, IdMecanicSor = pIdMecanicSor WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
    END IF;

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'ENTREGAR_VEHICLE', pId, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

FUNCTION AFEGIR_COMENT_CLIENT (pId NUMBER, pComentariClient VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
  vFila REPREV%ROWTYPE;
  vAux VARCHAR2 (100);
  vComentariClient REPREV.ComentariClient%TYPE;
  BEGIN     
 
    IF FUNC_ACCES_PERMES ('AFEGIR_COMENT_CLIENT', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pId IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM REPREV
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'REPREV.Id');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF vFila.ComentariClient IS NOT NULL THEN
      vComentariClient:=  vFila.ComentariClient ||' - '|| pComentariClient;
    ELSE
      vComentariClient:=  pComentariClient;
    END IF;

    UPDATE REPREV SET ComentariClient = pComentariClient WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
    END IF;

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'AFEGIR_COMENT_CLIENT', pId, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

FUNCTION AFEGIR_COMENT_MECANIC (pId NUMBER, pComentariMecanic VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
  vFila REPREV%ROWTYPE;
  vAux VARCHAR2 (100);
  vComentariMecanic REPREV.ComentariMecanic%TYPE;
  BEGIN     
 
    IF FUNC_ACCES_PERMES ('AFEGIR_COMENT_MECANIC', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pId IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM REPREV
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'REPREV.Id');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF vFila.ComentariMecanic IS NOT NULL THEN
      vComentariMecanic:=  vFila.ComentariMecanic ||' - '|| pComentariMecanic;
    ELSE
      vComentariMecanic:=  pComentariMecanic;
    END IF;

    UPDATE REPREV SET ComentariMecanic = pComentariMecanic WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
    END IF;

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'AFEGIR_COMENT_MECANIC', pId, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION REOBRIR_REPREV (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vFila REPREV%ROWTYPE;
    vAux VARCHAR2 (100);
      
  BEGIN     
 
    IF FUNC_ACCES_PERMES ('REOBRIR_REPREV', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
   
    IF pId IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM REPREV
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'REPREV.Id');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF vFila.DataFi IS NULL THEN
      RETURN RETORNS (24,pId,'REPREV.Id');
    END IF;

    IF vFila.DataSortida IS NOT NULL THEN
      RETURN RETORNS (25,pId,'REPREV.Id');
    END IF;
   
    UPDATE REPREV SET DataFi = NULL, Preu = NULL WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
    END IF;

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REOBRIR_REPREV', vRes, SQLERRM, 'F', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION REPREV_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
    vFila REPREV%ROWTYPE;
  BEGIN 
 
    IF FUNC_ACCES_PERMES ('REPREV_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
      
    IF pId IS  NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV.Id');/*Valor Null no possible*/ 
    ELSE
      BEGIN
        SELECT *
          INTO vFila
          FROM REPREV
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'REPREV.Id');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    IF vFila.DataSortida IS NOT NULL THEN
      RETURN RETORNS(30,pId, 'REPREV.Id');/*Tancada*/
    END IF;

    
    BEGIN
      vAux:= NULL;
      SELECT Id
        INTO vAux
        FROM REPREV_LINIES
       WHERE IdrepRev = pId;
      IF vAux IS NOT NULL THEN
        RETURN RETORNS(32,pId, 'REPREV.Id');/*Recepcionada*/    
      END IF;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
       null; /*tot ok*/
    END;
    
    DELETE REPREV WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
    WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'REPREV.Id');/*Error general revisar LOG*/
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV', pId, SQLERRM, 'D', 0);
      RETURN RETORNS(1,pId, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION REPREV_LINIES_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux NUMBER;
    vFila REPREV%ROWTYPE;
  BEGIN 
 
    IF FUNC_ACCES_PERMES ('REPREV_LINIES_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
    IF pId IS NULL THEN 
      RETURN RETORNS(2, 0, 'REPREV_LINIES.Id');/*Valor Null no possible*/
    ELSE
      BEGIN
        SELECT IdRepRev
          INTO vAux
          FROM REPREV_LINIES
         WHERE Id = pId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pId, 'REPREV_LINIES.Id');/*Valor d'Id No existeix*/
      END;
    END IF;
    
    BEGIN
      SELECT *
        INTO vFila
        FROM REPREV
       WHERE Id = vAux;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, 'REPREV_LINIES.Id');/*Valor d'Id No existeix*/
    END;
    
    IF vFila.DataSortida IS NOT NULL THEN
      RETURN RETORNS(34,pId, 'REPREV_LINIES.Id');/*Tancada*/
    END IF;
     
    DELETE REPREV_LINIES WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
    WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV_LINIES', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'REPREV_LINIES.Id');/*Error general revisar LOG*/
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'REPREV_LINIES', pId, SQLERRM, 'D', 0);
      RETURN RETORNS(1,pId, SQLCODE);/*Error general revisar LOG*/
  END; 

END PAK_REPREV;
/