create or replace
PACKAGE BODY PAK_TIPUS_EXTRES AS

  TE_FILLS exception;
  pragma exception_init( TE_FILLS, -2292 );

  FUNCTION TIPUS_EXTRES_I (pNom VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('TIPUS_EXTRES_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 

    IF pNom IS NULL THEN RETURN RETORNS(2, 0, 'TIPUS_EXTRES.Nom');/*Valor Null no possible*/
    END IF;

    INSERT INTO TIPUS_EXTRES VALUES (SEQ_TIPUS_EXTRES.NEXTVAL, pNom)
    RETURNING Id INTO vRes;

    RETURN RETORNS(0, vRes,null);
 
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'TIPUS_EXTRES', vRes, pNom, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION TIPUS_EXTRES_IDIOMA_I (pIdTex NUMBER, pIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vRes NUMBER;
    vAux NUMBER;
  BEGIN 

    IF FUNC_ACCES_PERMES ('TIPUS_EXTRES_IDIOMA_I', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 

    IF pIdTex IS NULL THEN RETURN RETORNS(2, 0, 'TIPUS_EXTRES_IDIOMA.IdTipusExtra');/*Valor Null no possible*/
    ELSIF pIdId IS NULL THEN RETURN RETORNS(2, 0, 'TIPUS_EXTRES_IDIOMA.IdIdioma');/*Valor Null no possible*/
    ELSIF pNom IS NULL THEN RETURN RETORNS(2, 0, 'TIPUS_EXTRES_IDIOMA.Nom');/*Valor Null no possible*/
    END IF;

    BEGIN
      SELECT Id
        INTO vAux
        FROM IDIOMES
       WHERE Id = pIdId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3, pIdId, 'TIPUS_EXTRES_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
    END;

    BEGIN
      SELECT Id
        INTO vAux
        FROM TIPUS_EXTRES
       WHERE Id = pIdTex;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pIdTex, 'TIPUS_EXTRES_IDIOMA.IdTipusExtra');/*Valor d'Id No existeix*/
    END;

    INSERT INTO TIPUS_EXTRES_IDIOMA VALUES (SEQ_TIPUS_EXTRES_IDIOMA.NEXTVAL, pIdTex, pIdId, pNom, pDesc)
    RETURNING Id INTO VRes;

    RETURN RETORNS(0, vRes, null);

  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'TIPUS_EXTRES_IDIOMA', vRes, pNom, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION TIPUS_EXTRES_U (pId NUMBER, pNom VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 

    IF FUNC_ACCES_PERMES ('TIPUS_EXTRES_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 

    IF pId IS NULL THEN RETURN RETORNS(2, 0, 'TIPUS_EXTRES.Id');/*Valor Null no possible*/
    ELSIF pNom IS NULL THEN RETURN RETORNS(2, 0, 'TIPUS_EXTRES.Nom');/*Valor Null no possible*/
    END IF;

    BEGIN
      SELECT Nom
        INTO vAux
        FROM TIPUS_EXTRES
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, 'TIPUS_EXTRES.Id'); /*Valor d'Id No existeix*/
    END;

    IF vAux <> pNom THEN
      UPDATE TIPUS_EXTRES SET Nom = pNom WHERE Id = pId;
      IF sql%ROWCOUNT >=1 THEN 
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'TIPUS_EXTRES', pId, pNom, 'U', 0);
      RETURN RETORNS(1,pId, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION TIPUS_EXTRES_IDIOMA_U (pId NUMBER, pIdTex NUMBER, PIdId NUMBER, pNom VARCHAR2, pDesc VARCHAR2, pIdUser NUMBER) RETURN RETORNS IS

    vAux VARCHAR2 (100);
    vModif BOOLEAN := FALSE;
    vFila TIPUS_EXTRES_IDIOMA%ROWTYPE;
    vSQL VARCHAR2(1000):='';
  BEGIN 

    IF FUNC_ACCES_PERMES ('TIPUS_EXTRES_IDIOMA_U', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
    
   IF pId IS NULL THEN 
     RETURN RETORNS(2, 0, 'TIPUS_EXTRES_IDIOMA.Id');/*Valor Null no possible*/
   ELSE
     BEGIN
       SELECT *
         INTO vFila
         FROM TIPUS_EXTRES_IDIOMA
        WHERE Id = pId;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         RETURN RETORNS(3,pId, 'TIPUS_EXTRES_IDIOMA.Id');/*Valor d'Id No existeix*/
     END;
   END IF;
   
    IF pIdTex IS NOT NULL AND pIdTex <> vFila.IdTipusExtra THEN
      BEGIN
        SELECT Id
          INTO vAux
          FROM TIPUS_EXTRES
         WHERE Id = pIdTex;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdTex, 'TIPUS_EXTRES_IDIOMA.IdTipusExtra');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdTipusExtra = ' || pIdTex||',';
      vModif := TRUE;
    END IF;
  
    IF pDesc IS NOT NULL AND pDesc <> vFila.Descripcio THEN
      vSQL := vSQL||' Descripcio = ''' || pDesc ||''',';
      vModif := TRUE;
    END IF;

    IF pIdId IS NOT NULL AND pIdId <> vFila.IdIdioma THEN  
      BEGIN
        SELECT Id
          INTO vAux
          FROM IDIOMES
         WHERE Id = pIdId;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RETURN RETORNS(3,pIdId, 'TIPUS_EXTRES_IDIOMA.IdIdioma');/*Valor d'Id No existeix*/
      END;
      vSQL := vSQL||' IdIdioma = ' || pIdId||',';
      vModif := TRUE;
    END IF;  
  
    IF pNom <> vFila.Nom THEN
      vSQL := vSQL||' Nom = ''' || pNom||''',';
      vModif := TRUE;
    END IF;

    IF vModif THEN
      vSQL := 'UPDATE TIPUS_EXTRES_IDIOMA SET ' || SUBSTR(vSQL, 1,LENGTH (vSQL)-1)|| ' WHERE Id = '|| pId;
      EXECUTE IMMEDIATE (vSQL);

      IF sql%ROWCOUNT >=1 THEN
        RETURN RETORNS(0, pId, null);
      ELSE
        RETURN RETORNS(5, pId, null); /*No s'ha modificat registre*/
      END IF;
    ELSE
      RETURN RETORNS(4, pId, null);/*No s'ha realitzat cap acci*/
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'TIPUS_EXTRES', pId, vSQL, 'U', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

  FUNCTION TIPUS_EXTRES_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 
  
    IF FUNC_ACCES_PERMES ('TIPUS_EXTRES_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF;   

    BEGIN
      SELECT Id
        INTO vAux
        FROM TIPUS_EXTRES
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, 'TIPUS_EXTRES.Id');/*Valor d'Id No existeix*/
    END;
    
    DELETE TIPUS_EXTRES WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
    WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'TIPUS_EXTRES', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'TIPUS_EXTRES.Id');/*Error general revisar LOG*/
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'TIPUS_EXTRES', pId, null, 'D', 0);
      RETURN RETORNS(1,pId, SQLCODE);/*Error general revisar LOG*/
  END;
  
  FUNCTION TIPUS_EXTRES_IDIOMA_D (pId NUMBER, pIdUser NUMBER) RETURN RETORNS IS
    vAux VARCHAR2 (100);
  BEGIN 
  
    IF FUNC_ACCES_PERMES ('TIPUS_EXTRES_IDIOMA_D', pIdUser) = FALSE THEN
      RETURN RETORNS(10, pIdUser, 'TREBALLADORS.IdUser');
    END IF; 
  
    IF pId IS NULL THEN
      RETURN RETORNS(2, 0, 'TIPUS_EXTRES_IDIOMA.Id');/*Valor Null no possible*/
    END IF;
  
    BEGIN
      SELECT Id
        INTO vAux
        FROM TIPUS_EXTRES_IDIOMA
       WHERE Id = pId;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RETURN RETORNS(3,pId, null);/*Valor d'Id No existeix*/
    END;
  
    DELETE TIPUS_EXTRES_IDIOMA WHERE Id = pId;
    
    IF sql%ROWCOUNT >=1 THEN
      RETURN RETORNS(0, pId, null);
    ELSE
      RETURN RETORNS(5, pId, null); /*No s'ha esborrat registre*/
    END IF;
  
  EXCEPTION
   WHEN TE_FILLS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'TIPUS_EXTRES', pId, 'FK Error: '||SQLERRM, 'D', 0);
      RETURN RETORNS(6,pId, 'TIPUS_EXTRES_IDIOMA.Id');/*Error general revisar LOG*/  
    WHEN OTHERS THEN
      PROC_INSERT_LOGERROR(SQLCODE, 'TIPUS_EXTRES', pId, SQLERRM, 'I', 0);
      RETURN RETORNS(1,0, SQLCODE);/*Error general revisar LOG*/
  END;

END PAK_TIPUS_EXTRES;
/